#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <map>
#include <random>
#include <stack>
#include <climits>
#include <chrono>
#include <fstream>
#include <algorithm>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

#define _ << " " <<
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sp(n) fixed << setprecision(n)
#define ff first
#define ss second
#define pb push_back
#define debug(x) cout << (#x) << " is " << (x) << endl

using namespace std;
//using namespace __gnu_pbds;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
//using ordered_multiset = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const double eps = 1e-8;
const ll INF = 2e9;

//#define int ll

struct node {
    int cnt = 0;
    int p = -1;
    int del = 0;
    map<char, int> next;
};

node trie[1001000];
int ptr = 1;

void add(string &s) {
    int cur = 0;
    trie[cur].cnt++;
    for (int i = 0; i < s.size(); i++) {
        if (trie[cur].next.find(s[i]) == trie[cur].next.end()) {
            trie[cur].next[s[i]] = ptr++;
        }
        int prev = cur;
        cur = trie[cur].next[s[i]];
        trie[cur].p = prev;
        trie[cur].cnt++;
    }
}

ll ans = 0;

int to_minus = 0;

void dfs(int v, int k) {
    if (trie[v].p != -1 && trie[trie[v].p].cnt - trie[v].del - trie[trie[v].p].del <= k) return;
    if (trie[v].cnt <= k) {
        trie[v].del = trie[v].cnt;
        ans++;
        return;
    }

    vector<pii> candidates;
    for (auto &i : trie[v].next) candidates.pb({i.ss, trie[i.ss].cnt});
    sort(all(candidates), [](pii a, pii b) {return a.ss > b.ss;});
    for (auto &i : candidates) {
        dfs(i.ff, k);
        trie[v].del += trie[i.ff].del;
        if (trie[v].p != -1 && trie[trie[v].p].cnt - trie[v].del - trie[trie[v].p].del <= k) return;
        if (trie[v].cnt - trie[v].del <= k) {
            trie[v].del = trie[v].cnt;
            ans++;
            return;
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output_false.txt", "w", stdout); //outs
#endif
    int n, k;
    cin >> n >> k;
    while (n--) {
        string s;
        cin >> s;
        add(s);
    }
    dfs(0, k);
    cout << ans << endl;
    return 0;
}