#include <bits/stdc++.h>

using namespace std;

string to_string(string s) {
  return '"' + s + '"';
}
string to_string(const char* s) {
  return to_string((string) s);
}
string to_string(bool b) {
  return (b ? "true" : "false");
}
template <typename A, typename B>
string to_string(pair<A, B> p) {
  return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}
template <typename A>
string to_string(A v) {
  bool first = true;
  string res = "{";
  for (const auto &x : v) {
    if (!first) {
      res += ", ";
    }
    first = false;
    res += to_string(x);
  }
  res += "}";
  return res;
}
void debug_out() { cerr << endl; }
template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
  cerr << " " << to_string(H);
  debug_out(T...);
}
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif

int main() {
  cin.tie(0);
  ios_base::sync_with_stdio(false);
  int n, m;
  cin >> n >> m;
  vector<vector<pair<int, int>>> g(n);
  for (int i = 0; i < m; ++i) {
    int u, v, x;
    cin >> u >> v >> x;
    --u; --v;
    g[u].emplace_back(v, x);
    g[v].emplace_back(u, x);
  }
  vector<int> d1(n, -1), mx1(n, -1), mn1(n, INT_MAX), p1mx(n, -1), p1mn(n, -1);
  vector<int> dn(n, -1), mxn(n, -1), mnn(n, INT_MAX), pnmx(n, -1), pnmn(n, -1);
  auto BFS = [&g](int start, vector<int> &d1, vector<int> &mx1, vector<int> &mn1, vector<int> &p1mx, vector<int> &p1mn) {
    queue<int> q;
    d1[start] = 0;
    q.push(start);
    while (!q.empty()) {
      int u = q.front();
      q.pop();
      debug(u);
      for (const auto &[v, x] : g[u]) {
        debug(v, x);
        debug(d1, mn1, mx1);
        if (d1[v] != -1) {
          if (d1[v] == d1[u] + 1) {
            if (mn1[v] > min(mn1[u], x)) {
              p1mn[v] = u;
              mn1[v] = min(mn1[u], x);
            }
            if(mx1[v] < max(mx1[u], x)) {
              p1mx[v] = u;
              mx1[v] = max(mx1[u], x);
            }
          } 
          continue;
        }
        p1mn[v] = p1mx[v] = u;
        d1[v] = d1[u] + 1;
        mn1[v] = min(mn1[u], x);
        mx1[v] = max(mx1[u], x);
        q.push(v);
      }
    }
  };
  BFS(0, d1, mx1, mn1, p1mx, p1mn);
  BFS(n - 1, dn, mxn, mnn, pnmx, pnmn);
  debug(d1, mn1, mx1, p1mn, p1mx);
  debug(dn, mnn, mxn, pnmn, pnmx);
  int bn = -1, delta = -1;
  for (int w = 1; w < n - 1; ++w) {
    if (d1[w] + dn[w] != d1[n - 1]) continue;
    if (abs(mx1[w] - mnn[w]) > delta) {
      bn = w;
      delta = abs(mx1[w] - mnn[w]);
    }
    if (abs(mn1[w] - mxn[w]) > delta) {
      bn = w;
      delta = abs(mn1[w] - mxn[w]); 
    }
  }
  if (delta == -1) {
    cout << 1 << '\n';
    cout << 1 << ' ' << n << '\n';
    return 0;
  }
  cout << d1[n - 1] << '\n';
  bool flag = (mx1[bn] - mnn[bn] == delta);
  if (flag) {
    vector<int> left;
    int u = bn;
    while (u != -1) {
      left.push_back(u);
      u = p1mx[u];
    }
    reverse(left.begin(), left.end());
    u = bn;
    vector<int> right;
    while (u != -1) {
      right.push_back(u);
      u = pnmn[u];
    }
    left.pop_back();
    for (const auto &p : left) cout << p + 1 << ' ';
    for (const auto &p : right) cout << p + 1 << ' ';
    return 0;
  } else {
    vector<int> left;
    int u = bn;
    while (u != -1) {
      left.push_back(u);
      u = p1mn[u];
    }
    reverse(left.begin(), left.end());
    vector<int> right;
    u = bn;
    while (u != -1) {
      right.push_back(u);
      u = pnmx[u];
    }
    left.pop_back();
    for (const auto &p : left) cout << p + 1 << ' ';
    for (const auto &p : right) cout << p + 1 << ' ';
  }
  return 0;
}

