#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")
#ifdef ONPC
    #define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define sz(a) ((int)((a).size()))
#define char unsigned char

using namespace std;
// mt19937 rnd(239);
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;

const ll MOD = 998244353;

const int NN = 1e6;

ll facts[NN];
ll revfacts[NN];

ll binpow(ll a, ll b) {
    ll ans = 1;
    while (b) {
        if (b & 1) {
            ans = ans * a % MOD;
        }
        a = a * a % MOD;
        b >>= 1;
    }
    return ans;
}

ll inv(ll a) {
    return binpow(a, MOD - 2);
}

const int N = 505;
const int M = 27;
const int K = 305;

ll prob[N][M][K];
int dp[N][M][M][K];
ll prefprob[N][M][K];

int solve() {
    facts[0] = revfacts[0] = 1;
    for (int i = 1; i < NN; i++) {
        facts[i] = facts[i - 1] * i % MOD;
        revfacts[i] = inv(facts[i]);
    }
    int n, m, k;
    if (!(cin >> n >> m >> k)) {
        return 1;
    }
    vector<vector<int>> a(n, vector<int>(m, 0));
    vector<int> cnt(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            if (a[i][j]) {
                cnt[i]++;
            }
        }
    }
    /*
    n = 500;
    m = 26;
    k = 300;
    cnt.assign(n, m);
    a.assign(n, vector<int>(m, k / m));
    */
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[i][j][0][0] = 1;
        }
        for (int j = 0; j < m; j++) {
            if (a[i][j] != 0) {
                for (int jj = 0; jj < m; jj++) {
                    if (jj == j || a[i][jj] == 0) {
                        continue;
                    }
                    for (int c = j; c >= 0; c--) {
                        for (int mom = 0; mom + a[i][j] <= k; mom++) {
                            int &val = dp[i][jj][c + 1][mom + a[i][j]];
                            val += dp[i][j][c][mom];
                            if (val >= MOD) {
                                val -= MOD;
                            }
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == 0) {
                continue;
            }
            for (int mom = 0; mom + a[i][j] <= k; mom++) {
                for (int c = 0; c < cnt[i]; c++) {
                    prob[i][j][mom + a[i][j]] = (prob[i][j][mom + a[i][j]] + 1LL * dp[i][j][c][mom] * facts[c] % MOD * facts[cnt[i] - c - 1] % MOD * revfacts[cnt[i]] % MOD) % MOD;
                }
                prefprob[i][j][mom + a[i][j]] = (prob[i][j][mom + a[i][j]] + prefprob[i][j][mom + a[i][j] - 1]) % MOD;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        ll ans = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j]) {
                ll probb = 0;
                for (int mom = a[i][j]; mom <= k; mom++) {
                    ll curprob = prob[i][j][mom];
                    for (int z = 0; z < n; z++) {
                        if (z != i) {
                            curprob = curprob * (1LL - (a[z][j] == 0 ? 0LL : prefprob[z][j][mom - 1]) + MOD) % MOD;
                        }
                    }
                    probb = (probb + curprob) % MOD;
                }
                ans = (ans + probb) % MOD;
            }
        }
        cout << ans << '\n';
    }
    return 1;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int TET = 1e9;
    //cin >> TET;
    for (int i = 1; i <= TET; i++) {
        if (solve()) {
            break;
        }
        #ifdef ONPC
            cout << "__________________________" << endl;
        #endif
    }
    #ifdef ONPC
        cerr << endl << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
    #endif
}
