//  Copyright 2021 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k;
  cin >> n >> k;

  struct node {
    int term{};
    int nxt[26];
  };
  vector<node> tree;
  tree.emplace_back();
  auto addVertex = [&] {
    tree.emplace_back();
    return int(tree.size()) - 1;
  };

  auto add = [&](string const& s) {
    int cur = 0;
    for (char ch : s) {
      int id = ch - 'a';
      if (tree[cur].nxt[id] == 0) {
        tree[cur].nxt[id] = addVertex();
      }
      cur = tree[cur].nxt[id];
    }
    tree[cur].term++;
  };

  for (int i = 0; i < n; ++i) {
    string s; cin >> s; add(s);
  }

  auto dfs = [&](auto&& self, int v) -> pair<int, int> {
    vector<int> lens{tree[v].term};
    int opsch = 0;
    for (int ch = 0; ch < 26; ++ch) {
      if (tree[v].nxt[ch]) {
        auto[chops, chlast] = self(self, tree[v].nxt[ch]);
        opsch += chops;
        lens.push_back(chlast);
      }
    }
    sort(lens.begin(), lens.end());
    int sum = 0;
    for (int x : lens) sum += x;
    while (sum > k) {
      opsch++;
      sum -= lens.back();
      lens.pop_back();
    }
    return make_pair(opsch, sum);
  };

  auto[ops, last] = dfs(dfs, 0);
  ops += (last > 0);
  cout << ops << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
