#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <cstddef>
#include <cstring>
#include <bitset>
#include <random>
#include <memory>
#include <iomanip>

typedef long long ll;
typedef long double ld;

using namespace std;

const int mod = 998'244'353;

void add(int& a, int b) {
    a += b;
    if (a >= mod) a -= mod;
}

void sub(int& a, int b) {
    a -= b;
    if (a < 0) a += mod;
}

int mul(int a, int b) {
    return (a * 1ll * b) % mod;
}

int up(int a, int n) {
    int res = 1;
    for (ll now = a; n; n >>= 1, now = (now * now) % mod) {
        if (n & 1) res = (res * now) % mod;
    }
    return res;
}


const int N = 507;
const int K = 307;
const int M = 30;


int fact[N];
int ifact[N];

int dp[N][M][K];
int a[N][M];
int n, m, k;

int lol[M][K];
int awk[M][K];
int all_p[M][K];

void build(int i) {
    int am = 0;
    for (int j = 0; j < m; j++) am += (a[i][j] != 0);

    for (int j = 0; j < M; j++) {
        fill(begin(lol[j]), end(lol[j]), 0);
    }
    lol[0][0] = 1;
    for (int p = 0; p < m; p++) {
        if (a[i][p] == 0) continue;
        for (int j = p; j >= 0; j--) {
            for (int ki = k - a[i][p]; ki >= 0; ki--) {
                add(lol[j + 1][ki + a[i][p]], lol[j][ki]);
            }
        }
    }

    for (int p = 0; p < m; p++) {
        if (a[i][p] == 0) {
            dp[i][p][k + 1] = 1;
            continue;
        }
        for (int j = 0; j < M; j++) {
            copy(begin(lol[j]), end(lol[j]), begin(awk[j]));
        }
        for (int ki = a[i][p]; ki <= k; ki++) {
            for (int j = 1; j <= m; j++) {
                sub(awk[j][ki], awk[j - 1][ki - a[i][p]]);
            }
        }
        for (int ki = 0; ki <= k - a[i][p]; ki++) {
            for (int j = 0; j < am; j++) {
                int val = mul(awk[j][ki], mul(fact[j], fact[am - 1 - j]));
                add(dp[i][p][ki + a[i][p]], val);
            }
            dp[i][p][ki + a[i][p]] = mul(dp[i][p][ki + a[i][p]], ifact[am]);
        }
    }
}

int dp2[N][M][K];
void stupid_dp(int i) {
    int am = 0;
    vector<int> p;
    for (int j = 0; j < m; j++) {
        am += (a[i][j] != 0);
        if (a[i][j]) p.push_back(j);
    }

    do {
        int sum = 0;
        for (int j : p) {
            sum += a[i][j];
            if (sum <= k) {
                add(dp2[i][j][sum], ifact[am]);
            }
        }
    } while (next_permutation(p.begin(), p.end()));
}

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);


    cin >> n >> m >> k;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }

    fact[0] = ifact[0] = 1;
    for (int i = 1; i < N; i++) {
        fact[i] = mul(i, fact[i - 1]);
        ifact[i] = up(fact[i], mod - 2);
    }

    for (int i = 0; i < n; i++) {
        build(i);
        // stupid_dp(i); // TODO
    }

    // for (int i = 0; i < n; i++) {
        // for (int j = 0; j < m; j++) {
            // for (int ki = 0; ki <= k; ki++) {
                // if (dp[i][j][ki] != dp2[i][j][ki]) {
                    // cerr << i << ' ' << j << ' ' << ki << '\n';
                    // cerr << dp[i][j][ki] << ' ' << dp2[i][j][ki] << '\n';
                    // assert(false);
                // }
            // }
        // }
    // }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int sum = 0;
            for (int ki = 0; ki <= k; ki++) {
                add(sum, dp[i][j][ki]);
            }
            dp[i][j][k + 1] = (1 - sum + mod) % mod;
            for (int ki = k; ki >= 0; ki--) {
                add(dp[i][j][ki], dp[i][j][ki + 1]);
            }
        }
    }


    for (int j = 0; j < m; j++) {
        for (int ki = 0; ki <= k; ki++) {
            all_p[j][ki] = 1;
            for (int i = 0; i < n; i++) {
                all_p[j][ki] = mul(all_p[j][ki], dp[i][j][ki]);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        int ans = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] == 0) continue;

            for (int ki = 0; ki <= k; ki++) {
                int val = (dp[i][j][ki] - dp[i][j][ki + 1] + mod) % mod;
                if (val == 0) continue;
                val = mul(val, all_p[j][ki]);
                val = mul(val, up(dp[i][j][ki], mod - 2));
                add(ans, val);
            }

        }
        cout << ans << '\n';
    }



    return 0;
}
