#include <bits/stdc++.h>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;

#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define forrn(i, s, n) for (int i = (int)(s); i < (int)(n); i++)
#define PYMOD(a, m) ((((a) % (m)) + (m)) % (m))
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define mp make_pair
#define ff first
#define ss second

int cmp(int i, int j) {
    if (abs(i - j) * 100 <= max(i, j)) {
        return 0;
    } else if (i < j) {
        return -1;
    } else {
        return 1;
    }
}

#ifdef LOCAL
int n;
vector<int> secret;
int qs = 0;

void init() {
    cin >> n;
    secret.resize(n);
    forn(i, n) { cin >> secret[i]; }
}

int compare(int i, int j) {
    qs++;
    int ans = cmp(secret[i], secret[j]);
    cout << "C " << i + 1 << " " << j + 1 << " " << ans << endl;
    return ans;
}

bool do_swap(int i, int j) {
    cout << "S " << i + 1 << " " << j + 1 << endl;
    qs++;
    swap(secret[i], secret[j]);
    if (is_sorted(all(secret))) {
        cout << "Total queries: " << qs << endl;
        return true;
    }
    return false;
}

#else

int n;

void init() { cin >> n; }

int compare(int i, int j) {
    cout << "C " << i + 1 << " " << j + 1 << endl;
    int x;
    cin >> x;
    return x;
}

bool do_swap(int i, int j) {
    cout << "S " << i + 1 << " " << j + 1 << endl;
    int x;
    cin >> x;
    return x;
}

#endif

struct segment {
    int l, r;
    vector<int> nums;
};

list<segment> segs;
void qsort(int l, int r, const vector<int> &ns) {
    static mt19937 rnd(179);

    if (l >= r) {
        return;
    }
    if (l == r - 1) {
        segs.emplace_back(segment{l, r, ns});
        return;
    }
    uniform_int_distribution<> pdist(l, r - 1);
    int pivot = ns[pdist(rnd) - l];
    vector<int> lt, md, rt;
    for (int i : ns) {
        int c = compare(i, pivot);
        if (c < 0) {
            lt.push_back(i);
        } else if (c == 0) {
            md.push_back(i);
        } else {
            rt.push_back(i);
        }
    }
    qsort(l, l + lt.size(), lt);
    segs.emplace_back(segment{l + (int)lt.size(), r - (int)rt.size(), md});
    qsort(r - rt.size(), r, rt);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // Code here:

    init();
    if (do_swap(0, 0)) {
        return 0;
    }

    {
        vector<int> ns(n);
        iota(all(ns), 0);
        qsort(0, n, ns);
    }

    auto cl = segs.begin();
    for (auto it = segs.begin(); it != segs.end();) {
        if (it->nums.size() == 1) {
            it++;
            continue;
        }
        while (next(cl) != it && cmp(cl->l + 1, it->l + 1) == -1) {
            cl++;
        }
        if (cmp(cl->l + 1, it->l + 1) == -1) {
            it++;
            continue;
        }
        int crb = it->l;
        while (crb < it->r && cmp(cl->l + 1, crb + 1) == 0) {
            crb++;
        }
        if (crb == it->r) {
            it++;
            continue;
        }
        auto best = cl;
        int cbest = max(crb - it->l, it->r - crb);
        auto cur = cl;
        while (next(cur) != it) {
            cur++;
            while (crb < it->r && cmp(cur->l + 1, crb + 1) == 0) {
                crb++;
            }
            if (crb == it->r) {
                break;
            }
            int cval = max(crb - it->l, it->r - crb);
            if (cval < cbest) {
                best = cur;
                cbest = cval;
            }
        }
        vector<int> lt, rt;
        for (int i : it->nums) {
            int c = compare(best->nums[0], i);
            assert(c != 1);
            if (c == 0) {
                lt.push_back(i);
            } else {
                rt.push_back(i);
            }
        }
        if (lt.empty() || rt.empty()) {
            it++;
            continue;
        }

        segs.insert(it, segment{it->l, it->l + (int)lt.size(), lt});
        segs.insert(it, segment{it->l + (int)lt.size(), it->r, rt});
        auto jt = prev(prev(it));
        segs.erase(it);
        it = jt;
    }

    cl = prev(segs.end());
    for (auto it = prev(segs.end()); it != segs.begin();) {
        if (it->nums.size() == 1) {
            it--;
            continue;
        }
        while (prev(cl) != it && cmp(cl->l + 1, it->l + 1) == 1) {
            cl--;
        }
        if (cmp(cl->l + 1, it->l + 1) == 1) {
            it--;
            continue;
        }
        int crb = it->r - 1;
        while (crb >= it->l && cmp(cl->l + 1, crb + 1) == 0) {
            crb--;
        }
        if (crb == it->l - 1) {
            it--;
            continue;
        }
        auto best = cl;
        int cbest = max(crb - it->l, it->r - crb);
        auto cur = cl;
        while (prev(cur) != it) {
            cur--;
            while (crb >= it->l && cmp(cur->l + 1, crb + 1) == 0) {
                crb--;
            }
            if (crb == it->l - 1) {
                break;
            }
            int cval = max(crb - it->l, it->r - crb);
            if (cval < cbest) {
                best = cur;
                cbest = cval;
            }
        }
        vector<int> lt, rt;
        for (int i : it->nums) {
            int c = compare(best->nums[0], i);
            assert(c != -1);
            if (c == 0) {
                rt.push_back(i);
            } else {
                lt.push_back(i);
            }
        }
        if (lt.empty() || rt.empty()) {
            it--;
            continue;
        }

        segs.insert(it, segment{it->l, it->l + (int)lt.size(), lt});
        segs.insert(it, segment{it->l + (int)lt.size(), it->r, rt});
        auto jt = prev(it);
        segs.erase(it);
        it = jt;
    }

    for (auto seg : segs) {
        if (seg.nums.size() > 1) {
            cout << seg.l << " " << seg.r << " " << seg.nums.size() << endl;
        }
    }
    return 0;

    vector<int> perm(n);
    {
        int ci = 0;
        for (auto &seg : segs) {
            for (int i : seg.nums) {
                perm[ci++] = i;
            }
        }
    }
    vector<int> pos(n);
    iota(all(pos), 0);
    vector<int> cperm(n);
    iota(all(cperm), 0);
    for (int i = 0; i < n; i++) {
        if (pos[perm[i]] == i) {
            continue;
        }
        if (do_swap(pos[perm[i]], i)) {
            return 0;
        }
        int j = pos[perm[i]];
        swap(cperm[i], cperm[j]);
        pos[cperm[i]] = i;
        pos[cperm[j]] = j;
    }

    assert(false);

    return 0;
}
