#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <cstddef>
#include <cstring>
#include <bitset>
#include <random>
#include <memory>
#include <iomanip>

typedef long long ll;
typedef long double ld;

using namespace std;

const int MX = 1e5 + 7;
ld c[MX];
ld t[MX];
ld v[MX];
int n;
ld L, V;

ld get(int i) {
    if (i < 0 || i > n) return 1e18;

    if (i) {
        t[0] = L / v[n - 1];
    } else {
        t[0] = L / (v[n - 1] + V);
    }

    for (int j = 1; j < i; j++) {
        t[j] = t[j - 1] * (v[n - j] / v[n - 1 - j]);
    }
    for (int j = max(i, 1); j < n; j++) {
        t[j] = t[j - 1] * (v[n - j] + V) / (v[n - 1 - j] + V);
    }
    ld res = 0;
    for (int j = 0; j < n; j++) {
        res += t[j] * c[j];
    }
    return res;
}

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);


    cin >> n >> L >> V;

    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }

    for (int i = 0; i < n; i++) {
        c[i] = (1 - (v[n - 1 - i] / V));
    }

    int l = 0, r = n;
    while (r - l > 2) {
        int m1 = (2 * l + r) / 3;
        int m2 = (l + 2 * r) / 3;

        if (get(m1) < get(m2)) l = m1;
        else r = m2;
    }

    ld res = 1e18;
    for (int i = l - 5; i <= r + 5; i++) {
        res = min(res, get(i));
    }


    ld ans = L / V + res / n;
    cout << fixed << setprecision(20) << ans;

    return 0;
}
