#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ui = unsigned int;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<long long, long long>;

const int inf = 1e9;
const ll inf64 = 1e18;

struct output {
    int can = 0;
    vector<tuple<int, int, char>> edges;

    void print() {
        if (can) {
            cout << "Yes\n";
            for (auto [u, v, w] : edges) {
                cout << u << " " << v << " " << w << "\n";
            }
        } else {
            cout << "No\n";
        }
    }

    bool operator == (const output& o) const {
        return true;
    }
};

struct input {
    int n;
    vector<int> w, b;

    input() = default;

    void read() {
        cin >> n;
        w.resize(n + 1);
        b.resize(n + 1);
        for (int v = 1; v <= n; v++) {
            cin >> w[v] >> b[v];
        }
    }

    void print() {

    }

    void gen() {
        static mt19937 rnd(42);
        const int MAXN = 100;
        n = rnd() % MAXN + 1;
        w.resize(n + 1);
        b.resize(n + 1);
        for (int v = 2; v <= n; v++) {
            int u = rnd() % (v - 1) + 1;
            if (rnd() % 2) {
                w[u]++, w[v]++;
            } else {
                b[u]++, b[v]++;
            }
        }
    }

    output fast() {
        set<tuple<int, int, int>> W, B;
        for (int v = 1; v <= n; v++) {
            W.insert({w[v], b[v], v});
            B.insert({b[v], w[v], v});
        }
        vector<tuple<int, int, char>> edges;
        while (!W.empty() || !B.empty()) {
            if (!W.empty() && get<0>(*W.begin()) == 0) {
                W.erase(W.begin());
                continue;
            }
            if (!B.empty() && get<0>(*B.begin()) == 0) {
                B.erase(B.begin());
                continue;
            }

            char c = '?';
            int leaf = -1, to = -1;

            if (!W.empty() && get<0>(*W.begin()) == 1 && get<1>(*W.begin()) == 0) {
                leaf = get<2>(*W.begin());
            } else if (!B.empty()) {
                leaf = get<2>(*B.begin());
            } else {
                return output{0, {}};
            }

//            cout << leaf << endl;

            if (w[leaf] + b[leaf] > 1)
                return output{0, {}};

            if (w[leaf]) {
                to = get<2>(*--W.end());
                c = 'W';
            } else {
                to = get<2>(*--B.end());
                c = 'B';
            }

            if (to == leaf)
                return output{0, {}};

            W.erase({w[leaf], b[leaf], leaf});
            B.erase({b[leaf], w[leaf], leaf});

            W.erase({w[to], b[to], to});
            B.erase({b[to], w[to], to});

            if (c == 'W') {
                w[leaf]--;
                w[to]--;
            } else {
                b[leaf]--;
                b[to]--;
            }

            edges.emplace_back(leaf, to, c);

            if (w[leaf]) W.insert({w[leaf], b[leaf], leaf});
            if (b[leaf]) B.insert({b[leaf], w[leaf], leaf});

            if (w[to]) W.insert({w[to], b[to], to});
            if (b[to]) B.insert({b[to], w[to], to});
        }
        return output{1, edges};
    }

    output slow() {
        return output();
    }
};

void test_case() {
    input in;
    in.read();
    output res = in.fast();
    res.print();
}

void work() {
    int t;
    cin >> t;
    while (t--)
        test_case();
}

void test() {
    for (int t = 1;;t++) {
        input in;
        in.gen();
        input in_fs = in;
        input in_sl = in;
        output fs = in_fs.fast();
        output sl = in_sl.slow();
        if (fs == sl) {
            assert(fs.can);
            cout << "OK" << endl;
            fs.print();
            cout << "\n=========" << endl;
        } else {
            cout << "WA " << t << "\n";
            cout << "exp\n";
            sl.print();
            cout << "\n=========\n";
            cout << "fnd\n";
            fs.print();
            cout << "\n=========\n";
            in.print();
            break;
        }
    }
}

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    work();
//    test();

    return 0;
}
