#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 mt(736);


constexpr string_view yes = "Yes", no = "No";


void solve_test(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;

	cin >> n;

	vector<vector<pair<string, int>>> thr(n);

	for (auto &prog: thr)
	{
		int sz;

		cin >> sz;

		prog.resize(sz);

		for (auto &[var, val]: prog)
		{
			char ch;

			cin >> ch;

			while (ch != '=')
			{
				var += ch;

				cin >> ch;
			}

			cin >> val;
		}
	}

	unordered_map<string, int> req;

	int m;

	cin >> m;

	for (int j = 0; j < m; j++)
	{
		string a;
		int b;

		cin >> a >> b;

		req[a] = b;
	}

	queue<int> trash;
	unordered_map<string, queue<int>> bad, good;

	vector<int> ans, ind(thr.size());

	for (int j = 0; j < ind.size(); j++)
		ind[j] = (int) thr[j].size() - 1;

	auto upd = [&](int val)
	{
		if (ind[val] >= 0)
		{
			if (const auto &line = thr[val][ind[val]]; req.count(line.first))
			{
				(req.at(line.first) == line.second ? good : bad)[line.first].push(val);
			}
			else
				trash.push(val);
		}
	};

	for (int i = 0; i < thr.size(); i++)
		upd(i);

	auto make_move = [&](int val)
	{
		ans.push_back(val);
		ind[val]--;

		upd(val);
	};

	while (!trash.empty() || !bad.empty() || !good.empty())
	{
		if (!trash.empty())
		{
			auto val = trash.front();
			trash.pop();

			make_move(val);
		}
		else if (!good.empty())
		{
			if (auto str = good.begin()->first; !req.count(str))
			{
				auto &q = good.begin()->second;

				while (!q.empty())
				{
					trash.push(q.front());
					q.pop();
				}

				good.erase(good.begin());
			}
			else
			{
				auto val = good.begin()->second.front();
				good.begin()->second.pop();
				req.erase(str);
				make_move(val);

				if (bad.count(str))
				{
					auto &q = bad[str];

					while (!q.empty())
					{
						trash.push(q.front());
						q.pop();
					}

					bad.erase(str);
				}
			}
		}
		else
		{
			cout << no << endl;

			return;
		}
	}

	cout << yes << endl;

	for (auto &it: ans)
		it++;

	copy(ans.rbegin(), ans.rend(), ostream_iterator<int>(cout, " "));
	cout << endl;
}


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int t = 1;

	for (int i = 0; i < t; i++)
		solve_test(cin, cout);
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int) str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
