#pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <map>
#include <vector>
#include <deque>
#include <algorithm>
#include <bitset>
#include <cstring>
#include <math.h>
#include <string>
#include <set>
#include <iomanip>
#include <bitset>
#include <random>
#include <complex>
#include <random>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;
#define pb push_back
#define ll long long
#define mp make_pair
#define snd second
#define ins insert
//#define ld long double
#define mt make_tuple
#define fst first
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
const double PI = acos(-1);
// = 5e5 + 17;
const int MOD1 = 998244353;
const int MOD = 1'000'000'007;
const int INF = 1e9;
const int MaXN = 150;
const int N = 1e8 + 1000;
const int LOG = 25;
const int FACT = 120;

mt19937 rng(239);

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

pair<ll, ll> gcd_eu(ll a, ll b) {
	if (b == 0) return mp(1, 0);
	auto res = gcd_eu(b, a % b);
	swap(res.first, res.second);
	res.second -= (a / b) * res.first;
	return res;
}

pair<ll, ll> long_ans(ll n, ll a, ll b) {
	auto res = gcd_eu(a, b);
	ll g = gcd(a, b);
	res.first *= n / g;
	res.second *= n / g;

	if (res.first < 0) {
		ll times = (-res.first-1) / b + 1;
		res.first += times * b;
		res.second -= times * a;
	}
	if (res.second < 0) {
		ll times = (-res.second-1) / a + 1;
		res.first -= times * b;
		res.second += times * a;
	}

	return res;
}

template<class T>
T up(T n)
{
	T r = 1;

	while (r < n)
		r *= 2;

	return r;
}


template<class T>
class segtree
{
	vector<pair<T, int>> arr;
	vector<bool> laz;
	vector<T> add;


	void push(int v)
	{
		if (laz[v])
		{
			laz[v] = false;
			arr[v].first = 0;

			if (v < arr.size() / 2)
			{
				add[2 * v] = 0;
				laz[2 * v] = true;
				add[2 * v + 1] = 0;
				laz[2 * v + 1] = true;
			}
		}
		if (add[v] != 0)
		{
			arr[v].first += add[v];

			if (v < arr.size() / 2)
			{
				add[2 * v] += add[v];
				add[2 * v + 1] += add[v];
			}

			add[v] = 0;
		}
	}


	void upd(int v)
	{
		push(v);

		if (v < arr.size() / 2)
		{
			push(2 * v);
			push(2 * v + 1);

			arr[v] = max(arr[2 * v], arr[2 * v + 1]);
		}
	}


	pair<T, int> segmax(int l, int r, int cl, int cr, int v)
	{
		if (r <= cl || cr <= l)
			return { numeric_limits<T>::lowest(), -1 };
		push(v);
		if (l <= cl && cr <= r)
			return arr[v];

		auto ct = (cl + cr) / 2;

		auto ans = max(segmax(l, r, cl, ct, 2 * v), segmax(l, r, ct, cr, 2 * v + 1));

		upd(v);

		return ans;
	}


	void segnull(int l, int r, int cl, int cr, int v)
	{
		if (r <= cl || cr <= l)
			return;
		push(v);
		if (l <= cl && cr <= r)
		{
			laz[v] = true;

			return;
		}

		auto ct = (cl + cr) / 2;

		segnull(l, r, cl, ct, 2 * v);
		segnull(l, r, ct, cr, 2 * v + 1);

		upd(v);
	}


	void segadd(int l, int r, int cl, int cr, int v, const T &x)
	{
		if (r <= cl || cr <= l)
			return;
		push(v);
		if (l <= cl && cr <= r)
		{
			add[v] += x;

			return;
		}

		auto ct = (cl + cr) / 2;

		segadd(l, r, cl, ct, 2 * v, x);
		segadd(l, r, ct, cr, 2 * v + 1, x);

		upd(v);
	}


public:
	explicit segtree(size_t n = 0) : arr(2 * up(n)), laz(2 * up(n)), add(2 * up(n))
	{
		for (int j = 0; j < n; j++)
			arr[j + arr.size() / 2].second = j;
		for (int j = (int)arr.size() / 2 - 1; j > 0; j--)
			arr[j] = max(arr[2 * j], arr[2 * j + 1]);
	}


	auto segmax(int l, int r)
	{
		return segmax(l, r, 0, arr.size() / 2, 1);
	}


	auto segnull(int l, int r)
	{
		return segnull(l, r, 0, arr.size() / 2, 1);
	}


	auto segadd(int l, int r, const T &x = 1)
	{
		return segadd(l, r, 0, arr.size() / 2, 1, x);
	}
};


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;

	for (int test = 0; test < t; test++) {
		int n;
		cin >> n;

		vector<int> w_deg(n), b_deg(n);

		for (int i = 0; i < n; i++) cin >> w_deg[i] >> b_deg[i];

		// First checks
		int total_w_deg = 0, total_b_deg = 0;
		for (int i = 0; i < n; i++) {
			total_w_deg += w_deg[i];
			total_b_deg += b_deg[i];
		}
		if (total_w_deg % 2 != 0 || total_b_deg % 2 != 0 || total_w_deg + total_b_deg != 2 * n - 2) {
			cout << "No" << endl;
			continue;
		}

		if (n == 1) {
			cout << "Yes" << endl;
			continue;
		}

		set<pair<int, int>> ds, wds, bds;
		for (int i = 0; i < n; i++) {
			ds.insert(mp(w_deg[i] + b_deg[i], i));
			if (w_deg[i] + b_deg[i] > 1) {
				if (w_deg[i] > 0) wds.insert(mp(-w_deg[i], i));
				if (b_deg[i] > 0) bds.insert(mp(-b_deg[i], i));
			}
		}

		vector<pair<pair<int, int>, char>> edges;

		bool ok = true;

		while (sz(ds) > 2) {
			int v = ds.begin()->second;
			ds.erase(ds.begin());
			if (w_deg[v] > 0) {
				if (sz(wds) == 0) {
					ok = false;
					break;
				}
				int w = wds.begin()->second;
				wds.erase(wds.begin());
				w_deg[v]--;
				w_deg[w]--;
				edges.push_back(mp(mp(v + 1, w + 1), 'W'));
				if (w_deg[w] + b_deg[w] > 1 && w_deg[w] > 0) wds.insert(mp(-w_deg[w], w));
				if (w_deg[w] + b_deg[w] == 1) bds.erase(mp(-b_deg[w], w));
				ds.erase(mp(w_deg[w] + b_deg[w] + 1, w));
				ds.insert(mp(w_deg[w] + b_deg[w], w));
			}
			else {
				if (sz(bds) == 0) {
					ok = false;
					break;
				}
				int w = bds.begin()->second;
				bds.erase(bds.begin());
				b_deg[v]--;
				b_deg[w]--;
				edges.push_back(mp(mp(v + 1, w + 1), 'B'));
				if (w_deg[w] + b_deg[w] > 1 && b_deg[w] > 0) bds.insert(mp(-b_deg[w], w));
				if (w_deg[w] + b_deg[w] == 1) wds.erase(mp(-w_deg[w], w));
				ds.erase(mp(w_deg[w] + b_deg[w] + 1, w));
				ds.insert(mp(w_deg[w] + b_deg[w], w));
			}
		}

		if (!ok) {
			cout << "No" << endl;
			continue;
		}

		edges.push_back(mp(mp(ds.begin()->second + 1, ((++ds.begin())->second) + 1), (w_deg[ds.begin()->second] > 0 ? 'W' : 'B')));
		cout << "Yes" << endl;
		for (auto e : edges) {
			cout << e.first.first << ' ' << e.first.second << ' ' << e.second << '\n';
		}
	}

	return 0;
}