#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  int h, w;
  cin >> h >> w;
  vector<string> a(h);
  for (int i = 0; i < h; i++) {
    cin >> a[i];
  }

  vector<vector<bool>> used(h, vector<bool>(w));
  auto isF = [&](int i, int j) {
    for (int k = 0; k <= 2; k++) {
      if (a[i][j + k] != '#') {
        return false;
      }
    }
    return a[i + 1][j] == '#' && a[i + 2][j] == '#' && a[i + 2][j + 1] == '#' && a[i + 3][j] == '#' &&
           a[i + 4][j] == '#' && a[i + 1][j + 1] == '.';
  };
  auto isQ = [&](int i, int j) {
    for (int k = 0; k <= 2; k++) {
      if (a[i][j + k] != '#') {
        return false;
      }
    }
    if (a[i + 1][j] != '#' || a[i + 1][j + 1] != '.' || a[i + 1][j + 2] != '#') {
      return false;
    }
    for (int k = 0; k <= 2; k++) {
      if (a[i + 2][j + k] != '#') {
        return false;
      }
    }
    return a[i + 3][j + 2] == '#' && a[i + 4][j + 2] == '#';
  };
  vector<pii> order;
  queue<pii> pq;
  for (int i = 0; i < h; i++) {
    pq.emplace(i, 0);
    pq.emplace(i, w - 3);
    used[i][0] = used[i][w - 3] = true;
  }
  for (int j = 1; j < w - 1; j++) {
    pq.emplace(0, j);
    pq.emplace(h - 5, j);
    used[0][j] = used[h - 5][j] = true;
  }
  while (!pq.empty()) {
    auto[i, j] = pq.front();
    pq.pop();
    order.emplace_back(i, j);
    for (auto[di, dj]: vector<pii>{{-1, 0},
                                   {1,  0},
                                   {0,  -1},
                                   {0,  1}}) {
      int pi = i + di, pj = j + dj;
      if (0 <= pi && pi <= h - 5 && 0 <= pj && pj <= w - 3 && !used[pi][pj]) {
        pq.emplace(pi, pj);
        used[pi][pj] = true;
      }
    }
  }

  int f = 0, q = 0;
  for (int j = 0; j <= w - 3; j++) {
    for (int i = 0; i <= h - 5; i++) {
      if (isF(i, j)) {
        f++;
        a[i][j] = '.';
        a[i][j + 1] = '.';
        a[i][j + 2] = '.';
        a[i + 1][j] = '.';
        a[i + 2][j] = '.';
        a[i + 2][j + 1] = '.';
        a[i + 3][j] = '.';
        a[i + 4][j] = '.';
      } else if (isQ(i, j)) {
        q++;
        a[i][j] = '.';
        a[i][j + 1] = '.';
        a[i][j + 2] = '.';
        a[i + 1][j] = '.';
        a[i + 1][j + 2] = '.';
        a[i + 2][j] = '.';
        a[i + 2][j + 1] = '.';
        a[i + 2][j + 2] = '.';
        a[i + 3][j + 2] = '.';
        a[i + 4][j + 2] = '.';
//        cout << i + 1 << " " << j + 1 << endl;
      }
    }
  }
  cout << q << " " << f;
  return 0;
}
