#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <utility>
#include <set>
#include <unordered_map>
#include <numeric>
#include <map>
#include <cassert>
#include <deque>
#include <stack>
#include <queue>
#include <random>
#include <functional>
#include <unordered_set>
#include <complex>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

void solve() {
    int n;
    cin >> n;
    set<pair<int, int>> white, black;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        if (a[i] > 0) {
            white.emplace(a[i] + b[i], i);
        }
        if (b[i] > 0) {
            black.emplace(a[i] + b[i], i);
        }
    }
    vector<tuple<int, int, char>> edges;
    for (int i = 0; i < n - 1; i++) {
        pair<int, int> pr;
        int clr;
        if (!white.empty() && white.begin()->first == 1) {
            pr = *white.begin();
            clr = 0;
        } else if (!black.empty() && black.begin()->first == 1) {
            pr = *black.begin();
            clr = 1;
        } else {
            cout << "No\n";
            return;
        }
        white.erase(pr);
        black.erase(pr);
        auto [_, v] = pr;
        if (clr == 0) {
            if (white.empty()) {
                cout << "No\n";
                return;
            }
            pr = *(--white.end());
        } else {
            if (black.empty()) {
                cout << "No\n";
                return;
            }
            pr = *(--black.end());
        }
        white.erase(pr);
        black.erase(pr);
        auto [deg, u] = pr;
        edges.emplace_back(v, u, clr == 1 ? 'B' : 'W');
        if (clr == 1) {
            b[u]--;
        } else {
            a[u]--;
        }
        if (a[u] > 0) {
            white.emplace(a[u] + b[u], u);
        }
        if (b[u] > 0) {
            black.emplace(a[u] + b[u], u);
        }
    }
    if (!black.empty() || !white.empty()) {
        cout << "No\n";
        return;
    }
    cout << "Yes\n";
    for (auto &[a, b, c] : edges) {
        cout << a + 1 << " " << b + 1 << " " << c << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
