#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
#define len(x) (int)(x).size()

//#define int ll

const int mod = 998244353;
const int N = 510;
const int T = 310;
const int M = 30;

void add(int &a, int b) {
    a += b;
    if (a >= mod) {
        a -= mod;
    }
}

inline int sub(int a, int b) {
    a -= b;
    if (a < 0) {
        a += mod;
    }
    return a;
}

int mult(int a, int b) {
    return (a * 1ll * b) % mod;
}

int b_pow(int a, int p) {
    int cur = a;
    int ans = 1;
    while (p > 0) {
        if (p & 1) {
            ans = mult(ans, cur);
        }
        p /= 2;
        cur = mult(cur, cur);
    }
    return ans;
}

int inv(int x) {
    return b_pow(x, mod - 2);
}

vector<vector<int>> calc_dp(vector<int>& tasks, int t) {
    int k = 0;
    for (int i = 0; i < len(tasks); i++) {
        if (tasks[i] != 0)
            k++;
    }
    vector<vector<int>> dp(k + 1, vector<int> (t + 1, 0));
    dp[0][0] = 1;
    for (int i = 0; i < len(tasks); i++) {
        if (tasks[i] == 0)
            continue;
        for (int kk = k; kk >= 1; kk--) {
            for (int tt = t; tt >= tasks[i]; tt--) {
                dp[kk][tt] += dp[kk - 1][tt - tasks[i]];
                if (dp[kk][tt] >= mod)
                    dp[kk][tt] -= mod;
            }
        }
    }
    return dp;
}

ll fac[M];

void init() {
    fac[0] = 1;
    for (int i = 1; i < M; i++) {
        fac[i] = (fac[i - 1] * i) % mod;
    }
}

int getcoef(int x, int p, int s) {
    return ((x * fac[p]) % mod * fac[s]) % mod;
}

int calc[N][M][T], suf[N][M][T], prod_suf[M][T], f[M][T], vl[M];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    init();
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> tasks(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (auto &it : tasks[i]) {
            cin >> it;
        }
        int cnt = 0;
        for (auto it : tasks[i]) {
            if (it) {
                cnt++;
            }
        }
        auto dp = calc_dp(tasks[i], k);
        for (int j = 0; j < m; j++) {
            if (tasks[i][j]) {
                for (int kk = 1; kk <= cnt; kk++) {
                    for (int time = tasks[i][j]; time <= k; time++) {
                        f[kk][time] = dp[kk - 1][time - tasks[i][j]];
                        /*if (i == 0 && j == 0 && time == 30) {
                            cerr << "HUY " << f[kk][time] << '\n';
                        }*/
                        if (time >= 2 * tasks[i][j] && kk >= 2) {
                            f[kk][time] = sub(f[kk][time], f[kk - 1][time - tasks[i][j]]);
                        }
                        add(calc[i][j][time], getcoef(f[kk][time], kk - 1, cnt - kk));
                    }
                }
                /*if (i == 0 && j == 0) {
                    cerr << "HUY2 " << calc[0][0][30] << '\n';
                }*/
                calc[i][j][k + 1] = fac[cnt];
                for (int t = 0; t <= k; t++) {
                    calc[i][j][k + 1] = sub(calc[i][j][k + 1], calc[i][j][t]);
                }
            } else {
                calc[i][j][k + 1] = fac[cnt];
            }
            for (int t = 0; t <= k + 1; t++) {
                calc[i][j][t] = mult(calc[i][j][t], inv(fac[cnt]));
            }
            /*if (i == 0 && j == 0) {
                cerr << calc[0][0][30] << '\n';
            }*/
        }
    }

    //cout << calc[0][0][30] << '\n';
    //cout << "FUCK " << calc[4][0][60] << ' ' << calc[4][0][61] << '\n';
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            suf[i][j][k + 1] = calc[i][j][k + 1];
            for (int t = k; t >= 0; t--) {
                suf[i][j][t] = suf[i][j][t + 1];
                add(suf[i][j][t], calc[i][j][t]);
            }
        }
        cerr << suf[0][0][30] << '\n';
    }
    for (int j = 0; j < m; j++) {
        for (int t = 0; t <= k + 1; t++) {
            prod_suf[j][t] = 1;
            for (int i = 0; i < n; i++) {
                prod_suf[j][t] = mult(prod_suf[j][t], suf[i][j][t]);
            }
        }
    }
    cerr << prod_suf[0][30] << '\n';
    for (int i = 0; i < n; i++) {
        int sum = 0;
        for (int j = 0; j < m; j++) {
            if (!tasks[i][j]) {
                continue;
            }
            for (int t = 0; t <= k; t++) {
                int other_prod = mult(prod_suf[j][t], inv(suf[i][j][t]));
                add(sum, mult(calc[i][j][t], other_prod));
            }
        }
        cout << sum << '\n';
    }
}