#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

const int N = 2e5 + 7;

int n, m;
int a[N];

struct Item {
  int left, center, right, left_x, right_x, len;
} t[2 * N];

void merge(Item a, Item b, Item& res) {
  res.len = a.len + b.len;
  res.left_x = a.left_x;
  res.right_x = b.right_x;
  if (a.right_x + 1 == b.left_x) {
    if (a.left == a.len) {
      res.left = a.left + b.left;
    } else {
      res.left = a.left;
    }
    if (b.right == b.len) {
      res.right = b.right + a.right;
    } else {
      res.right = b.right;
    }
    res.center = max(a.right + b.left, max(a.center, b.center));
  } else {
    res.left = a.left;
    res.right = b.right;
    res.center = max(a.center, b.center);
  }
}

#define L() pos + 1
#define R() pos + (r - l >> 1 << 1)

void build(int pos, int l, int r) {
  if (r - l == 1) {
    t[pos] = {1, 1, 1, a[l], a[l], 1};
  } else {
    build(L(), l, l + r >> 1);
    build(R(), l + r >> 1, r);
    merge(t[L()], t[R()], t[pos]);
  }
}

void upd(int pos, int l, int r, int i) {
  if (i < l || i >= r) {
    return;
  } else if (r - l == 1) {
    t[pos] = {1, 1, 1, a[l] + 1, a[l] + 1, 1};
  } else {
    upd(L(), l, l + r >> 1, i);
    upd(R(), l + r >> 1, r, i);
    merge(t[L()], t[R()], t[pos]);
  }
}

void run_solve() {
  MTEST() {
    cin >> n >> m;
    vector<pair<int, int>> events;
    for (int i = 0; i < n; ++i) {
      cin >> a[i];
      if (a[i] % m != 0) {
        events.push_back({m - a[i] % m, i});
      }
      a[i] /= m;
    }
    build(0, 0, n);
    sort(ALL(events));
    pair<int, int> ans = make_pair(t[0].center, 0);
    for (int i = 0; i < SZ(events); ++i) {
      upd(0, 0, n, events[i].second);
      while (i < SZ(events) - 1 && events[i].first == events[i + 1].first) {
        ++i;
        upd(0, 0, n, events[i].second);
      }
      ans = max(ans, make_pair(t[0].center, events[i].first));
    }
    cout << ans.first << ' ' << ans.second << '\n';
  }
}