#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

const int N = DEB ? 100 : 1e5 + 7;
const int INF = 1e9 + 7;

struct Edge {
  int v, u, c;
};

int n, m;
vector<Edge> g[N];

int dist_back[N], dist_forward[N];

void bfs(int start, int* dist, int* dp, int* par) {
  fill(dist, dist + n, N);
  dist[start] = 0;
  queue<int> q;
  q.push(start);
  while (!q.empty()) {
    int v = q.front();
    q.pop();
    for (Edge e : g[v]) {
      if (dist[e.u] == N) {
        dist[e.u] = dist[e.v] + 1;
        q.push(e.u);
      }
    }
  }
  vector<int> order(n);
  iota(ALL(order), 0);
  sort(ALL(order), [&](int v, int u) { return dist[v] < dist[u]; });
  for (int v : order) {
    dp[v] = INF;
    for (Edge e : g[v]) {
      if (dist[e.u] + 1 == dist[e.v]) {
        if (dp[e.v] > min(dp[e.v], min(dp[e.u], e.c))) {
          dp[e.v] = min(dp[e.v], min(dp[e.u], e.c));
          par[e.v] = e.u;
        }
      }
    }
  }
}

int dp_back[N], dp_forward[N];
int par_back[N], par_forward[N];

vector<int> back_ans, forward_ans;

void restore_back(int v) {
  while (v != 0) {
    back_ans.push_back(v);
    v = par_back[v];
  }
  back_ans.push_back(v);
  reverse(ALL(back_ans));
}

void restore_forward(int v) {
  while (v != n - 1) {
    forward_ans.push_back(v);
    v = par_forward[v];
  }
  forward_ans.push_back(v);
}

void run_solve() {
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    int v, u, c;
    cin >> v >> u >> c;
    --v, --u;
    g[v].push_back({v, u, c});
    g[u].push_back({u, v, c});
  }
  bfs(0, dist_back, dp_back, par_back);
  bfs(n - 1, dist_forward, dp_forward, par_forward);
  int ans = 0;
  for (int v = 0; v < n; ++v) {
    for (Edge e : g[v]) {
      if (dist_back[e.v] + dist_forward[e.u] + 1 == dist_forward[0]) {
        ans = max(ans, e.c - min(e.c, min(dp_back[e.v], dp_forward[e.u])));
      }
    }
  }
  // cout << dist[0] << ' ' << ans << '\n';
  // return;
  for (int v = 0; v < n; ++v) {
    for (Edge e : g[v]) {
      if (dist_back[e.v] + dist_forward[e.u] + 1 == dist_forward[0]) {
        if (ans == e.c - min(e.c, min(dp_back[e.v], dp_forward[e.u]))) {
          restore_back(e.v);
          restore_forward(e.u);
          cout << dist_forward[0] << '\n';
          for (int t : back_ans) {
            cout << t + 1 << ' ';
          }
          for (int t : forward_ans) {
            cout << t + 1 << ' ';
          }
          cout << '\n';
          return;
        }
      }
    }
  }
}