#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

const int N = DEB ? 100 : 3e5 + 7;

struct Edge {
  int v, u, c;
};

int n;
int c[N][2];
set<vector<int>> r, rc[2];
vector<Edge> edges;

void add_edge(int v, int u, int color) {
  edges.push_back({v, u, color});
  r.erase({c[u][0] + c[u][1], u});
  --c[v][color];
  --c[u][color];
  r.insert({c[u][0] + c[u][1], u});
  rc[color].erase({c[u][color] + 1, c[u][0] + c[u][1] + 1, u});
  rc[color].insert({c[u][color], c[u][0] + c[u][1], u});
  rc[!color].erase({c[u][!color], c[u][0] + c[u][1] + 1, u});
  rc[!color].insert({c[u][!color], c[u][0] + c[u][1], u});
}

bool check() {
  for (int v = 0; v < n; ++v) {
    if (c[v][0] != 0 || c[v][1] != 0) {
      return false;
    }
  }
  return true;
}

bool solve() {
  for (int i = 0; i < n - 1; ++i) {
    if (r.empty() || (*r.begin())[0] != 1) {
      return false;
    }
    int v = (*r.begin())[1];
    r.erase(r.begin());
    int flag = (c[v][1] == 1);
    rc[flag].erase({c[v][flag], c[v][0] + c[v][1], v});
    if (rc[flag].empty() || (*--rc[flag].end())[0] < 1) {
      return false;
    }
    int u = (*--rc[flag].end())[2];
    add_edge(v, u, flag);
  }
  return check();
}

void run_solve() {
  MTEST() {
    cin >> n;
    r.clear();
    edges.clear();
    for (int v = 0; v < n; ++v) {
      cin >> c[v][0] >> c[v][1];
      r.insert({c[v][0] + c[v][1], v});
      rc[0].insert({c[v][0], c[v][0] + c[v][1], v});
      rc[1].insert({c[v][1], c[v][0] + c[v][1], v});
    }
    if (solve()) {
      cout << "YES\n";
      for (auto e : edges) {
        cout << e.v + 1 << ' ' << e.u + 1 << ' ' << (e.c == 0 ? 'W' : 'B')
             << '\n';
      }
    } else {
      cout << "NO\n";
    }
  }
}
