// #pragma GCC optimize("Ofast,no-stack-protector,unroll-all-loops,unroll-loops")
// #pragma GCC target("abm,mmx,sse,sse2,sse3,ssse3,sse4a,popcnt,tune=native")
 
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <vector>
#include <unordered_map>
#include <map>
#include <ctime>

#define prev asldasd
 
using namespace std;

typedef long long ll;
typedef long double dbl;


const int maxn = 1e5 + 7;

const int inf = 1e9 + 7;

int dist[maxn], prev[maxn];

vector<int> s[maxn];
map<pair<int, int>, int> color;


int calc_val(vector<int>& path){
    int minc = inf;
    int maxc = 0;
    for (int i = 1; i < path.size(); i++){
        int c = color[{path[i - 1], path[i]}];
        minc = min(minc, c);
        maxc = max(maxc, c);
    }
    return maxc - minc;
}

vector<int> bfs(int st, int n, bool use_min){
    fill(dist, dist + n, inf);
    dist[st] = 0;
    vector<int> q{st};
    int cur = 0;
    vector<int> vals(n, use_min ? inf : -1);
    while (cur < q.size()){
        int v = q[cur++];
        for (int u : s[v]){
            if (dist[u] > dist[v] + 1){
                dist[u] = dist[v] + 1;
                q.push_back(u);
            }
            if (dist[u] == dist[v] + 1){
                int c = color[{v, u}];
                if (use_min && vals[u] >= min(vals[v], c)){
                    prev[u] = v;
                    vals[u] = min(vals[v], c);
                }
                if (!use_min && vals[u] <= max(vals[v], c)){
                    prev[u] = v;
                    vals[u] = max(vals[v], c);
                }
            }
        }
    }
    return vals;
}

vector<int> restore(int st, int fin, int n){
    bfs(fin, n, 0);
    vector<int> ans;
    while (fin != st){
        ans.push_back(st);
        st = prev[st];
    }
    return ans;
}

vector<int> solve(int st, int fin, int n){
    vector<int> mini = bfs(st, n, 1);
    vector<int> maxi = bfs(fin, n, 0);
    if (dist[st] == 1)
        return {st, fin};
    int x = 1;
    for (int i = 0; i < n; i++){
        if (i != st && i != fin && maxi[x] - mini[x] < maxi[i] - mini[i])
            x = i;
    }
    // cout << mini[1] << ' ' << maxi[1] << endl;
    // cout << maxi[2] << endl;
    // cout << x << endl;
    // cout << endl;
    vector<int> ans;
    for (int v : restore(st, x, n))
        ans.push_back(v);
    for (int v : restore(x, fin, n))
        ans.push_back(v);
    ans.push_back(fin);
    return ans;
}

 
void solve(){
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        s[a - 1].push_back(b - 1);
        s[b - 1].push_back(a - 1);
        color[{a - 1, b - 1}] = c;
        color[{b - 1, a - 1}] = c;
    }
    auto path1 = solve(0, n - 1, n);
    auto path2 = solve(n - 1, 0, n);
    if (calc_val(path1) < calc_val(path2)){
        swap(path1, path2);
        reverse(path1.begin(), path1.end());
    }
    cout << path1.size() - 1 << endl;
    for (int x : path1)
        cout << x + 1 << ' ';
    cout << endl;
}

 
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
    return 0;
}