#include <iostream>
#include <chrono>
#include <cmath>
#include <complex>
#include <memory.h>
#include <random>
#include<algorithm>
#include <iomanip>
#include <set>
//#include <bits/extc++.h>
//#include <immintrin.h>

using namespace std;

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")


template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)
        in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a) {
        out << i << " ";
    }
    return out;
}

template<typename T, typename D>
istream &operator>>(istream &in, pair<T, D> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename D>
ostream &operator<<(ostream &out, const pair<T, D> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct LogOutput {
    template<typename T>
    LogOutput &operator<<(const T &x) {
#ifdef DIVAN
        cout << x;
#endif
        return *this;
    }
} dout, fout;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef long double ld;
typedef complex<double> cd;

#define elif else if
#define all(_v) _v.begin(), _v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(v) (int)(v.size())
#define sqr(_v) ((_v) * (_v))
#define eb emplace_back
#define pb push_back
#define mod(x, m) ((x) >= 0 ? ((x) % m) : ((((x) % m) + m) % m))
#define minq(x, y) x = min((x), (y))
#define maxq(x, y) x = max(x, (y))
#define forn(i, n) for (int i = 0; i < (n); ++i)

#define vpi vector <pair <int, int>>
#define vi vector<int>
#define pi pair <int, int>
#define ti tuple <int, int, int>


const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const int INF = 2139062143;
const int nINF = -2139062144;
const ull ULINF = numeric_limits<ull>::max();
const long double PI = acos(-1);
auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
//auto seed = 0;
mt19937 rnd(seed);

inline void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    //    freopen("input.txt", "r", stdin);
    //    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

#define int ll

const int MAXN = 3e5 + 15;

int nxt[MAXN][26];
int par[MAXN];
int cnt[MAXN];
int root = 0, timer = 1;
bool deleted[MAXN];
set<pi > q;

void Add(const string &s) {
    int v = root;
    cnt[v]++;
    for (auto u : s) {
        u -= 'a';
        if (nxt[v][u] == -1) {
            par[timer] = v;
            nxt[v][u] = timer++;
        }
        v = nxt[v][u];
        ++cnt[v];
    }
}

void Delete(int v) {
    q.erase({cnt[v], v});
    deleted[v] = 1;
    forn(i, 26) {
        if (nxt[v][i] != -1 && !deleted[nxt[v][i]]) {
            Delete(nxt[v][i]);
        }
    }
}

void Subtract(int v) {
    if (v == root) {
        return;
    }
    int c = cnt[v];
    do {
        v = par[v];
        q.erase({cnt[v], v});
        cnt[v] -= c;
        q.insert({cnt[v], v});
    } while (v != root);
}

void Solve() {
    memset(nxt, -1, sizeof(nxt));
    memset(par, -1, sizeof(par));
    int n, k;
    cin >> n >> k;
    forn(i, n) {
        string s;
        cin >> s;
        Add(s);
    }
    int ans = 0;
    while (true) {
        int memo = -1;
        for (int v = 0; v < timer; v++) {
            if (cnt[v] <= k && !deleted[v]) {
                if (memo == -1 || cnt[v] > cnt[memo]) memo = v;
            }
        }
        if (memo == -1) break;
        Delete(memo);
        Subtract(memo);
        ans++;
    }
    cout << ans;
}

signed main() {
    auto startTime = chrono::high_resolution_clock::now();
    IO();
    Solve();
    auto endTime = chrono::high_resolution_clock::now();
    chrono::duration<long double> duration = endTime - startTime;
    cout << setprecision(6) << fixed;
    fout << '\n' << "Time: " << duration.count();
    return 0;
}
/*
5 3
 please
 remove
 all
 these
 files
 */