#pragma GCC optimize("Ofast")

#include <iostream>
#include <chrono>
#include <cmath>
#include <complex>
#include <memory.h>
#include <random>
#include<algorithm>
#include <iomanip>
#include <map>
#include <set>
//#include <bits/extc++.h>
//#include <immintrin.h>

using namespace std;

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")


template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)
        in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a) {
        out << i << " ";
    }
    return out;
}

template<typename T, typename D>
istream &operator>>(istream &in, pair<T, D> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename D>
ostream &operator<<(ostream &out, const pair<T, D> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct LogOutput {
    template<typename T>
    LogOutput &operator<<(const T &x) {
#ifdef DIVAN
        cout << x;
#endif
        return *this;
    }
} dout, fout;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef long double ld;
typedef complex<double> cd;

#define elif else if
#define all(_v) _v.begin(), _v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(v) (int)(v.size())
#define sqr(_v) ((_v) * (_v))
#define eb emplace_back
#define pb push_back
#define mod(x, m) ((x) >= 0 ? ((x) % m) : ((((x) % m) + m) % m))
#define minq(x, y) x = min((x), (y))
#define maxq(x, y) x = max(x, (y))
#define forn(i, n) for (int i = 0; i < (n); ++i)

#define vpi vector <pair <int, int>>
#define vi vector<int>
#define pi pair <int, int>
#define ti tuple <int, int, int>


const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const int INF = 2139062143;
const int nINF = -2139062144;
const ull ULINF = numeric_limits<ull>::max();
const long double PI = acos(-1);
auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
//auto seed = 0;
mt19937 rnd(seed);

inline void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    //    freopen("input.txt", "r", stdin);
    //    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

#define int ll

vector<int> xc;
vector<int> yc;

const int N = 10;


long long f(int x, int y) {
    long long res = 0;
    long long stepx = 1;
    long long stepy = 1;
    for (int i = 0; i < xc.size(); i++) {
        res += xc[i] * stepx;
        res += yc[i] * stepy;
        stepx *= x;
        stepy *= y;
    }
    return res;
}

map<tuple<bool, bool, bool>, pair<vector<int>, vector<int>>> ans;

tuple<bool, bool, bool> check() {
    int hasmin = 0;
    for (int x = -9; x < 10; x++) {
        for (int y = -9; y < 10; y++) {
            if (f(x, y) < f(x - 1, y) && f(x, y) < f(x + 1, y) && f(x, y) < f(x, y - 1) && f(x, y) < f(x, y + 1)) {
                hasmin++;
            }
        }
    }
    int hasmax = 0;
    for (int x = -9; x < 10; x++) {
        for (int y = -9; y < 10; y++) {
            if (f(x, y) > f(x - 1, y) && f(x, y) > f(x + 1, y) && f(x, y) > f(x, y - 1) && f(x, y) > f(x, y + 1)) {
                hasmax++;
            }
        }
    }
    bool hasplato = 0;
    for (int x = -9; x <= 10; x++) {
        for (int y = -10; y <= 10; y++) {
            if (f(x, y) == f(x - 1, y)) {
                hasplato = true;
                break;
            }
        }
    }
    for (int x = -10; x < 10; x++) {
        for (int y = -10; y <= 10; y++) {
            if (f(x, y) == f(x + 1, y)) {
                hasplato = true;
                break;
            }
        }
    }
    for (int x = -10; x <= 10; x++) {
        for (int y = -9; y <= 10; y++) {
            if (f(x, y) == f(x, y - 1)) {
                hasplato = true;
                break;
            }
        }
    }
    for (int x = -10; x <= 10; x++) {
        for (int y = -10; y < 10; y++) {
            if (f(x, y) == f(x, y + 1)) {
                hasplato = true;
                break;
            }
        }
    }
    return {hasmin >= 2, hasmax >= 2, hasplato};
}

void brute(int left) {
    if (left == 0) {
        auto res = check();
        if (!ans.count(res)) ans[res] = {xc, yc};
        if (ans.size() == 8) {
            for (auto[p, q] : ans) {
                cout << "\"" << get<0>(p) << get<1>(p) << get<2>(p) << "\" : \"";
                for (int i = 0; i < q.first.size(); i++) {
                    cout << q.first[i] << " ";
                    for (int j = 0; j < i; j++) {
                        cout << " x ";
                    }
                    for (int j = 0; j < i; j++) {
                        cout << " * ";
                    }
                }
                for (int i = 0; i < q.second.size(); i++) {
                    cout << q.second[i] << " ";
                    for (int j = 0; j < i; j++) {
                        cout << " y ";
                    }
                    for (int j = 0; j < i; j++) {
                        cout << " * ";
                    }
                }
                for (int i = 0; i < q.first.size() + q.second.size() - 2; i++) {
                    cout << " + ";
                }
                cout << "\"\n";
            }
            exit(0);
        }
        return;
    }
    vector<int> ar, br;
    for (int a = -N; a <= N; a++) ar.push_back(a);
    for (int a = -N; a <= N; a++) br.push_back(a);
    random_shuffle(ar.begin(), ar.end());
    random_shuffle(br.begin(), br.end());
    for (int a : ar) {
        for (int b  : br) {
            xc.push_back(a);
            yc.push_back(b);
            brute(left - 1);
            xc.pop_back();
            yc.pop_back();
        }
    }
}

void Solve() {
    // brute(10);
    map<string, string> ans = {
            {"000", "4 10  x  * 2  x  x  *  * -5  x  x  x  *  *  * -9  x  x  x  x  *  *  *  * -9  x  x  x  x  x  *  *  *  *  * -3  x  x  x  x  x  x  *  *  *  *  *  * 5  x  x  x  x  x  x  x  *  *  *  *  *  *  * 6  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  * -10  x  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  *  * 3 -7  y  * -9  y  y  *  * 6  y  y  y  *  *  * -6  y  y  y  y  *  *  *  * -6  y  y  y  y  y  *  *  *  *  * 7  y  y  y  y  y  y  *  *  *  *  *  * -3  y  y  y  y  y  y  y  *  *  *  *  *  *  * 10  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  * -7  y  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  *  *  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  + "},
            {"001", "4 10  x  * 2  x  x  *  * -5  x  x  x  *  *  * -9  x  x  x  x  *  *  *  * -9  x  x  x  x  x  *  *  *  *  * -3  x  x  x  x  x  x  *  *  *  *  *  * 5  x  x  x  x  x  x  x  *  *  *  *  *  *  * 6  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  * 3  x  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  *  * 3 -7  y  * -9  y  y  *  * 6  y  y  y  *  *  * -6  y  y  y  y  *  *  *  * -6  y  y  y  y  y  *  *  *  *  * 7  y  y  y  y  y  y  *  *  *  *  *  * -3  y  y  y  y  y  y  y  *  *  *  *  *  *  * 10  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  * -7  y  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  *  *  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  + "},
            {"010", "4 10  x  * 2  x  x  *  * -5  x  x  x  *  *  * -9  x  x  x  x  *  *  *  * -9  x  x  x  x  x  *  *  *  *  * -3  x  x  x  x  x  x  *  *  *  *  *  * 5  x  x  x  x  x  x  x  *  *  *  *  *  *  * 6  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  * -3  x  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  *  * 3 -7  y  * -9  y  y  *  * 6  y  y  y  *  *  * -6  y  y  y  y  *  *  *  * -6  y  y  y  y  y  *  *  *  *  * 7  y  y  y  y  y  y  *  *  *  *  *  * -3  y  y  y  y  y  y  y  *  *  *  *  *  *  * -7  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  * 0  y  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  *  *  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  + "},
            {"011", "4 10  x  * 2  x  x  *  * -5  x  x  x  *  *  * -9  x  x  x  x  *  *  *  * -9  x  x  x  x  x  *  *  *  *  * -3  x  x  x  x  x  x  *  *  *  *  *  * 5  x  x  x  x  x  x  x  *  *  *  *  *  *  * 6  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  * -3  x  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  *  * 3 -7  y  * -9  y  y  *  * 6  y  y  y  *  *  * -6  y  y  y  y  *  *  *  * -6  y  y  y  y  y  *  *  *  *  * 7  y  y  y  y  y  y  *  *  *  *  *  * -3  y  y  y  y  y  y  y  *  *  *  *  *  *  * 10  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  * 8  y  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  *  *  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  + "},
            {"100", "4 10  x  * 2  x  x  *  * -5  x  x  x  *  *  * -9  x  x  x  x  *  *  *  * -9  x  x  x  x  x  *  *  *  *  * -3  x  x  x  x  x  x  *  *  *  *  *  * 5  x  x  x  x  x  x  x  *  *  *  *  *  *  * 6  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  * -3  x  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  *  * 3 -7  y  * -9  y  y  *  * 6  y  y  y  *  *  * -6  y  y  y  y  *  *  *  * -6  y  y  y  y  y  *  *  *  *  * 7  y  y  y  y  y  y  *  *  *  *  *  * -3  y  y  y  y  y  y  y  *  *  *  *  *  *  * 10  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  * 0  y  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  *  *  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  + "},
            {"101", "4 10  x  * 2  x  x  *  * -5  x  x  x  *  *  * -9  x  x  x  x  *  *  *  * -9  x  x  x  x  x  *  *  *  *  * -3  x  x  x  x  x  x  *  *  *  *  *  * 5  x  x  x  x  x  x  x  *  *  *  *  *  *  * 6  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  * 0  x  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  *  * 3 -7  y  * -9  y  y  *  * 6  y  y  y  *  *  * -6  y  y  y  y  *  *  *  * -6  y  y  y  y  y  *  *  *  *  * 7  y  y  y  y  y  y  *  *  *  *  *  * -3  y  y  y  y  y  y  y  *  *  *  *  *  *  * 2  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  * 4  y  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  *  *  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  + "},
            {"110", "4 10  x  * 2  x  x  *  * -5  x  x  x  *  *  * -9  x  x  x  x  *  *  *  * -9  x  x  x  x  x  *  *  *  *  * -3  x  x  x  x  x  x  *  *  *  *  *  * 5  x  x  x  x  x  x  x  *  *  *  *  *  *  * 6  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  * -3  x  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  *  * 3 -7  y  * -9  y  y  *  * 6  y  y  y  *  *  * -6  y  y  y  y  *  *  *  * -6  y  y  y  y  y  *  *  *  *  * 7  y  y  y  y  y  y  *  *  *  *  *  * -3  y  y  y  y  y  y  y  *  *  *  *  *  *  * 10  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  * -1  y  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  *  *  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  + "},
            {"111", "4 10  x  * 2  x  x  *  * -5  x  x  x  *  *  * -9  x  x  x  x  *  *  *  * -9  x  x  x  x  x  *  *  *  *  * -3  x  x  x  x  x  x  *  *  *  *  *  * 5  x  x  x  x  x  x  x  *  *  *  *  *  *  * 6  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  * -2  x  x  x  x  x  x  x  x  x  *  *  *  *  *  *  *  *  * 3 -7  y  * -9  y  y  *  * 6  y  y  y  *  *  * -6  y  y  y  y  *  *  *  * -6  y  y  y  y  y  *  *  *  *  * 7  y  y  y  y  y  y  *  *  *  *  *  * -3  y  y  y  y  y  y  y  *  *  *  *  *  *  * -1  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  * 1  y  y  y  y  y  y  y  y  y  *  *  *  *  *  *  *  *  *  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  +  + "}
    };
    string first, second, third;
    cin >> first >> second >> third;
    if (first.back() == 'o') first = "0";
    else first = "1";
    if (second.back() == 'o') second = "0";
    else second = "1";
    if (third.back() == 'o') third = "0";
    else third = "1";
    cout << ans[first + second + third];
}

signed main() {
    auto startTime = chrono::high_resolution_clock::now();
    IO();
    Solve();
    auto endTime = chrono::high_resolution_clock::now();
    chrono::duration<long double> duration = endTime - startTime;
    cout << setprecision(6) << fixed;
    fout << '\n' << "Time: " << duration.count();
    return 0;
}