#define FS first
#define SC second

#include <random>
#include <iostream>
#include <iomanip>
#include <unordered_map>
#include <map>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

mt19937 gen(339264);

const int MAXN = 1050;
int d[MAXN][MAXN];


struct ass{
    string var;
    int val;

    ass(string var, int val): var(var), val(val) {}
};

int main() {
    ios::sync_with_stdio(0), cin.tie(0);

    uniform_int_distribution<int> rand(0,100500);

    int n;
    cin >> n;

    vector<vector<ass>> programs(n);
    vector<int> cnt(n);

    int sum_size = 0;

    for (int i = 0; i < n; i++) {
        int l;
        cin >> l;
        cnt[i] = l - 1;
        sum_size += l;
        for (int j = 0; j < l; j++) {
            string s;
            cin >> s;
            int pos = -1;
            for (int k = 0; k < s.size(); k++) {
                if (s[k] == '=') {
                    pos = k;
                    break;
                }
            }

            string var = s.substr(0, pos);
            int val = stoi(s.substr(pos + 1, s.size() - pos - 1));

            programs[i].push_back(ass(var, val));
        }
    }

    int k;
    cin >> k;

    unordered_map<string, int> last_val;
    for (int i = 0; i < k; i++) {
        string var;
        int val;
        cin >> var >> val;
        last_val[var] = val;
    }


    vector<int> ans;
    set<string> initialized;
    for (int i = 0; i < sum_size; i++) {
        for (int j = 0; j < n; j++) {
            if (cnt[j] >= 0 && (initialized.count(programs[j][cnt[j]].var) || last_val[programs[j][cnt[j]].var] == programs[j][cnt[j]].val)) {
                initialized.insert(programs[j][cnt[j]].var);
                ans.push_back(j);
                cnt[j]--;
                break;
            }
        }
    }

    if (ans.size() != sum_size) {
        cout << "No\n";
    } else {
        cout << "Yes\n";
        reverse(ans.begin(), ans.end());
        for (int v: ans) {
            cout << v + 1 << " ";
        }
        cout << endl;
    }

    return 0;
}
