#include "bits/stdc++.h"

using namespace std;

struct node {
    int sum;
    int term;
    int depth;
    node *parent;
    bool deleted;
    vector<node *> edges;

    node() : sum(0), term(0), depth(0), parent(nullptr), deleted(false), edges(26, nullptr) {}

    explicit node(node *myparent) : sum(0),
                                    term(0),
                                    depth(myparent->depth + 1),
                                    parent(myparent),
                                    deleted(false),
                                    edges(26, nullptr) {}
};

int n, k;
set<pair<pair<int, int>, node *>> s; // max sum, min depth


void dfs(node *v) {
    if (v->sum <= k) {
        s.insert({{-v->sum, v->depth}, v});
        return;
    }
    for (node *to: v->edges) {
        if (to != nullptr) {
            dfs(to);
        }
    }
}

void doDelete(node *v) {
    if (v->deleted) {
        return;
    }
    v->deleted = true;
    for (node *to : v->edges) {
        if (to != nullptr) {
            doDelete(to);
        }
    }
}

void recalcSum(node *v) {
    v->sum = v->term;
    for (node *to: v->edges) {
        if (to != nullptr) {
            if (!to->deleted) {
                v->sum += to->sum;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);

    cin >> n >> k;

    node *root = new node();
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        node *v = root;
        v->sum++;
        for (char c: s) {
            c -= 'a';
            if (v->edges[c] == nullptr) {
                v->edges[c] = new node(v);
            }
            v = v->edges[c];
            v->sum++;
        }
        v->term++;
    }

    dfs(root);

    int ans = 0;
    while (!s.empty()) {
        auto top = *s.begin();
        s.erase(s.begin());
        node *v = top.second;
        if (v->deleted) {
            continue;
        }
        ans++;
        if (v == root) {
            break;
        }
        v->sum = 0;
        doDelete(v);
        bool any = false;
        while (v->parent != nullptr) {
            recalcSum(v->parent);
            if (v->parent->sum <= k) {
                v = v->parent;
                any = true;
            } else {
                break;
            }
        }
        if (any) {
            s.insert({{-v->sum, v->depth}, v});
        }
    }
    cout << ans << endl;
}
