﻿#include <iostream>
#include <string>
#include <stack>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <deque>
#include <queue>
#include <cmath>

#define fast_io std::ios_base::sync_with_stdio(false); std::cin.tie(0)

struct p  {
    int min = 1e9 + 1, max = -1, dist = -1, best = 0;
};

void relax(std::pair<int,int> &from, int w) {
    from.first = std::min(from.first, w);
    from.second = std::max(from.second, w);
}

signed main() {
    fast_io;
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<std::pair<int,int>>> g(n);
    for (int i = 0;i < m; ++i) {
        int x, y, c;
        std::cin >> x >> y >> c;
        x--; y--;
        g[x].push_back({y, c});
        g[y].push_back({x, c});
    }
    std::vector<p> best(n);
    std::queue<int> q;
    best[0] = {0, 0, 0, 0};
    std::vector<bool> is_in_queue(n);

    for (auto i:g[0]) {
        q.push(i.first);
        is_in_queue[i.first] = true;
        best[i.first] = {i.second, i.second, 1, 0};
    }

    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        for (auto i:g[v]) {
            if (best[i.first].dist == -1 || best[i.first].dist == best[v].dist + 1) {
                best[i.first].dist = best[v].dist + 1;
                best[i.first].min = std::min(best[i.first].min, std::min(i.second, best[v].min));
                best[i.first].max = std::max(best[i.first].max, std::max(i.second, best[v].max));

                best[i.first].best = std::max(best[i.first].best, best[v].best);
                best[i.first].best = std::max(best[i.first].best, std::max(i.second - best[v].min, best[v].max - i.second));

                if (!is_in_queue[i.first]) {
                    q.push(i.first);
                    is_in_queue[i.first] = true;
                }
            }
        }
    }
    std::vector<int> ans;
    ans.push_back(n);
    int need_min = -1, need_max = -1;
    int v = n - 1;
    while (best[v].dist != 1) {
        for (auto u : g[v]) {
            if (best[u.first].dist + 1 == best[v].dist) {
                // may be parent
                if (need_min != -1) {
                    if (best[u.first].min == need_min || u.second == need_min) {
                        v = u.first;
                        ans.push_back(v + 1);
                        if (u.second == need_min) need_min = -1;
                        break;
                    }
                    continue;
                }
                if (need_max != -1) {
                    if (best[u.first].max == need_max || u.second == need_max) {
                        v = u.first;
                        ans.push_back(v + 1);
                        if (u.second == need_max) need_max = -1;
                        break;
                    }
                    continue;
                }
                if (best[u.first].best == best[v].best) {
                    v = u.first;
                    ans.push_back(v + 1);
                    break;
                }
                if (u.second - best[u.first].min == best[v].best) {
                    v = u.first;
                    ans.push_back(v + 1);
                    need_min = best[u.first].min;
                    break;
                }
                if (best[u.first].max - u.second == best[v].best) {
                    v = u.first;
                    ans.push_back(v + 1);
                    need_max = best[u.first].max;
                    break;
                }
            }
        }
    }
    ans.push_back(1);
    std::cout << ans.size() - 1 << '\n';
    for (int i = (int)ans.size() - 1; i >=0; --i) {
        std::cout << ans[i] << ' ';
    }
}