#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,sse4a,popcnt,abm,mmx,avx,avx2,tune=native")

#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
#include <cmath>
#include <iomanip>
#include <map>
#include <stack>
#include <set>
#include <string>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <stdio.h>
#include <memory.h>
#include <cstdlib>
#include <stdlib.h>
#include <time.h>
#include <bitset>
#include <random>
#include <chrono>

#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(a) (a)*(a)

using namespace std;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;

const ll mod = 998244353LL;
const int inf = 1e9;
const ll biginf = 2e18;
const ld pi = acosl(-1);
const ld eps = 1e-9;
const int maxn = 101;
const ll negative_inf = -1e18;
const int alph_size = 26;

vector<int> v;

struct node {
    int lb, rb;
    int curl, curr, curin;
    node *l, *r;

    void calc_one() {
        if (lb == rb) {
            if (v[lb] == 0) {
                curl = 0, curr = 0, curin = 0;
            } else {
                curl = 1, curr = 1, curin = 1;
            }
        }
    }

    void calc() {
        if (lb == rb) {
            return;
        }
        curin = max(l->curr + r->curl, max(l->curin, r->curin));
        if (l->curl == l->rb - l->lb + 1) {
            curl = l->curl + r->curl;
        } else {
            curl = l->curl;
        }
        if (r->curr == r->rb - r->lb + 1) {
            curr = r->curr + l->curr;
        } else {
            curr = r->curr;
        }
    }

    node(int lq, int rq) {
        lb = lq;
        rb = rq;
        if (lb == rb) {
            l = nullptr;
            r = nullptr;
            calc_one();
            return;
        }
        int m = (lb + rb) / 2;
        l = new node(lb, m);
        r = new node(m + 1, rb);
        calc();
    }

    void upd_delta(int ind, int delta) {
        if (ind < lb || rb < ind) {
            return;
        }
        if (ind == lb && lb == rb) {
            v[lb] += delta;
            calc_one();
            return;
        }
        l->upd_delta(ind, delta);
        r->upd_delta(ind, delta);
        calc();
    }

    int get_ans() {
        return curin;
    }

    void clean() {
        if (lb != rb) {
            l->clean();
            r->clean();
        }
        delete this;
    }
};

/*
5
4 10
0 3 8 24
2 10
32 35
10 1
0 1 3 4 5 6 7 10 11 12
10 24
0 1 3 4 5 6 7 10 11 12
8 24
26 71 101 147 181 201 244 268
 */

void solve() {
    v.clear();
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    unordered_map<int, int> s;
    vector<vector<int> > shift(m);
    set<int, greater<> > ss;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        int d = a[i] / m;
        shift[a[i] % m].pb(i);
        ss.insert(a[i] % m);
        s[d]++;
        for (int j = max(0, d - 2); j <= d + 2; j++) {
            s[j] += 0;
        }
    }
    vector<int> day_num;
    unordered_map<int, int> inv;
    for (auto x : s) {
        inv[x.first] = day_num.size();
        day_num.pb(x.first);
        v.pb(x.second);
    }
    node *root = new node(0, v.size() - 1);
    int opt = root->get_ans(), opt_shift = 0;
    ss.erase(0);
    for (int cur_shift : ss) {
        for (int i : shift[cur_shift]) {
            int day = a[i] / m;
            root->upd_delta(inv[day], -1);
            root->upd_delta(inv[day + 1], 1);
        }
        int cur = root->get_ans();
        if (cur > opt) {
            opt = cur;
            opt_shift = cur_shift;
        }
    }
    cout << opt << " " << (m - opt_shift) % m << "\n";
    root->clean();
}

void multisolve() {
    int t;
    cin >> t;
    for (int i = 1; i <= t; i++) {
        solve();
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    multisolve();
}