#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Q = 26;
const int MAX_LEN = 3e5 + 10;
int cur = 0;

struct Node {
    map<char, int> go_to;
    int cnt, prev;
};

void add_string(vector<Node> &trie, const string &s) {
    int sz = s.size();
    int cur_node = 0;
    for (int i = 0; i < sz; i++) {
        if (trie[cur_node].go_to[s[i]] == 0) {
            trie[cur].prev = cur_node;
            trie[cur_node].go_to[s[i]] = cur++;
        }
        cur_node = trie[cur_node].go_to[s[i]];
    }
    trie[cur_node].cnt++;
}

void count_sizes(int v, int h, vector<Node> &trie, set<pair<pair<int, int>, int> > &st) {
    for (auto ch : trie[v].go_to) {
        if (ch.second != 0) {
            count_sizes(ch.second, h + 1, trie, st);
            trie[v].cnt += trie[ch.second].cnt;
        }
    }
    st.insert({{-trie[v].cnt, h}, v});
}

void null_subtree(int v, int h, vector<Node> &trie, set<pair<pair<int, int>, int> > &st) {
    st.erase({{-trie[v].cnt, h}, v});
    trie[v].cnt = 0;
    for (auto ch : trie[v].go_to) {
        if (ch.second != 0 && trie[ch.second].cnt != 0) null_subtree(ch.second, h + 1, trie, st);
    }
}

int main() {
    int n, k;
    cin >> n >> k;
    vector<Node> trie(MAX_LEN);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        add_string(trie, s);
    }
    set<pair<pair<int, int>, int> > st;
    count_sizes(0, 0, trie, st);
    int ans = 0;
    while (!st.empty()) {
        ans++;
        pair<pair<int, int>, int> cur_v = *st.lower_bound({{-k, 0}, 0});
        int v = cur_v.second, h = cur_v.first.second;
        null_subtree(v, h, trie, st);
        while (v != 0) {
            v = trie[v].prev;
            h--;
            st.erase({{-trie[v].cnt, h}, v});
            trie[v].cnt += cur_v.first.first;
            st.insert({{-trie[v].cnt, h}, v});
        }
    }
    cout << ans;
    return 0;
}