#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <queue>
#include <numeric>
#include <map>

using namespace std;

const int INF = 1e9 + 7;


struct edge {
    int to;
    int w;
    edge(int to = -1, int w = -1) : to(to), w(w) {}
};
 
enum dir {
    max_edge,
    min_edge,
    max_diff
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), 
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> a(n, vector<edge>(0));
    for (int i = 0; i < m; i++)
    {
        int x, y, w;
        cin >> x >> y >> w;
        x--;
        y--;
        a[x].push_back(edge(y, w));
        a[y].push_back(edge(x, w));
    }
    vector<int> maxx(n, 0), minn(n, INF), dist(n, 0), used(n), pr(n, -1);
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        used[v] = true;
        for (auto x : a[v]) {
            int u = x.to;
            int w = x.w;
            if (used[u] == false) {
                used[u] = true;
                q.push(u);
                minn[u] = min(minn[v], w);
                maxx[u] = max(maxx[v], w);
                dist[u] = dist[v] + 1;
                pr[u] = v;
            } 
        }
    }
    vector<int> maxx2(n, 0), minn2(n, INF), dist2(n, 0), used2(n), pr2(n, -1);
    queue<int> q2;
    q2.push(n - 1);
    while (!q2.empty()) {
        int v = q2.front();
        q2.pop();
        used2[v] = true;
        for (auto x : a[v]) {
            int u = x.to;
            int w = x.w;
            if (used2[u] == false) {
                used2[u] = true;
                q2.push(u);
                minn2[u] = min(minn2[v], w);
                maxx2[u] = max(maxx2[v], w);
                dist2[u] = dist2[v] + 1;
                pr2[u] = v;
            } 
        }
    }
    int ans;
    int answer = 0;
    for (int i = 0; i < n; i++) {
        if (dist[i] + dist2[i] == dist[n - 1]) {
            // cout << i << endl;
            // cout << maxx[i] << " " << minn[i] << " " << maxx2[i] << " " << minn2[i] << endl;
            if (maxx[i] - minn2[i] > answer) {
                ans = i;
                answer = maxx[i] - minn2[i];
            }
            if (maxx2[i] - minn[i] > answer) {
                ans = i;
                answer = maxx2[i] - minn[i];
            }
        }
    }
    // cout << ans << endl;
    // cout << answer << endl;
    vector<int> arr;
    int v = ans;
    while (pr[v] != -1) {
        arr.push_back(pr[v]);
        v = pr[v];
    }
    reverse(arr.begin(), arr.end());
    arr.push_back(ans);
    int u = ans;
    while (pr2[u] != -1) {
        arr.push_back(pr2[u]);
        u = pr2[u];
    }
    cout << arr.size() - 1 << endl;
    for (int u : arr) {
        cout << u + 1 << " ";
    }
}

