
#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <numeric>
#include <map>
#include <unordered_map>

using namespace std;

vector<vector<int>> a;
vector<int> color;
bool cycle = false;
vector<int> top_sort;

void dfs(int v)
{
    color[v] = 1;
    for (const auto& u : a[v])
    {
        if (color[u] == 2)
        {
            continue;
        }
        if (color[u] == 1)
        {
            cycle = true;
            return;
        }
        dfs(u);
    }
    top_sort.push_back(v);
    color[v] = 2;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int sections_count;
    cin >> sections_count;
    int max_n = 0;
    vector<vector<std::pair<std::string, int>>> f(sections_count, std::vector<std::pair<std::string, int>>(0));
    for (int i = 0; i < sections_count; i++)
    {
        int n;
        cin >> n;
        max_n = max(n, max_n);
        for (int j = 0; j < n; j++)
        {
            char c;
            std::string res;
            cin >> c;
            while (c != '=') {
                res += c;
                cin >> c;
            }
            int x;
            cin >> x;
            f[i].push_back({res, x});
        }
    }
    a.resize(sections_count * max_n + 1);
    color.resize(sections_count * max_n + 1);
    unordered_map<string, std::vector<int>> ref;
    for (int i = 0; i < sections_count; i++)
    {
        ref[f[i][0].first].push_back(i * max_n);
        for (int j = 1; j < f[i].size(); j++)
        {
            ref[f[i][j].first].push_back(i * max_n + j);
            a[i * max_n + j - 1].push_back(i * max_n + j);
        }
    }
    int rules_count;
    cin >> rules_count;
    for (int i = 0; i < rules_count; i++)
    {
        std::string s;
        int x;
        cin >> s >> x;
        const auto& cur_vec = ref[s];
        std::vector<int> unmatched;
        for (auto ind_a : cur_vec)
        {
            int i_f = ind_a / max_n;
            int j_f = ind_a % max_n;
            int val = f[i_f][j_f].second;
            if (val != x)
            {
                unmatched.push_back(ind_a);
                continue;
            }
        }
        int count = 0;
        int all = 0;
        for (int ind_a : cur_vec)
        {
            int i_f = ind_a / max_n;
            int j_f = ind_a % max_n;
            int val = f[i_f][j_f].second;
            if (val != x)
            {
                continue;
            }
            all++;
            bool flag = false;
            for (const auto& ind_unmatched : unmatched)
            {
                if ((ind_unmatched / max_n == ind_a / max_n) && (ind_unmatched > ind_a)) {
                    color[ind_a] = 2;
                    flag = true;
                    break;
                }
                a[ind_unmatched].push_back(ind_a);
            }
            if (flag)
                count++;
        }
        if (all == count)
        {
            cout << "No";
            return 0;
        }
    }
    for (int i = 0; i < sections_count; i++)
    {
        a[sections_count * max_n].push_back(i * max_n);
    }
//    for (int i = 0; i < a.size(); i++)
//    {
//        cout << i << ":";
//        for (auto u : a[i])
//        {
//            cout << " " << u;
//        }
//        cout << endl;
//    }
    dfs(sections_count * max_n);
    if (cycle)
    {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    for (int i = top_sort.size() - 2; i >= 0; i--)
    {
        int val = top_sort[i];
        cout << val / max_n + 1 << " ";
    }
}

/*
3 5
start=1 counter=1111 counter=10 counter=3333 finish=1
4
start=2 counter=20 counter=10 finish=2
3
start=3 qwerty=787788 finish=3
4
counter 10 start 1 finish 1 qwerty 787788
 */