#include <bits/stdc++.h>

using namespace std;

#define rall(x) (x).begin(), (x).end()
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
#define F first
#define S second
#define int int64_t


const int INF = 1e9;

const int N = 100'010;

struct Edge {
    int to, c;
};

vector <Edge> g[N];
vector <Edge> newg[N];
vector <Edge> newg_rev[N];

int dist[N];
int dp[N];
int dp_rev[N];
int pr[N];
int pr_rev[N];

void bfs(int n) {
    queue <int> q;
    vector <bool> used(n + 1, false);
    used[1] = true;
    q.push(1);
    dist[1] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto [to, c] : g[v]) {
            if (!used[to]) {
                used[to] = true;
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }
}

bool used[N];
vector <int> order;

void dfs(int v) {
    used[v] = true;
    for (auto [to, c] : newg[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    order.push_back(v);
}

void topsort(int n) {
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    } 
    reverse(all(order));
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        g[u].push_back(Edge{v, c});
        g[v].push_back(Edge{u, c});
    }
    bfs(n);
    for (int v = 1; v <= n; ++v) {
        for (auto [to, c] : g[v]) {
            if (dist[to] == dist[v] + 1) {
                newg[v].push_back(Edge{to, c});
                newg_rev[to].push_back(Edge{v, c});
            }
        }
    } 
    topsort(n);
    fill(dp, dp + N, -1);
    fill(dp_rev, dp_rev + N, -1);
    dp[1] = 0;
    for (int v : order) {
        if (dp[v] == -1) {
            continue;
        } 
        for (auto [to, c] : newg[v]) {
            if (dp[to] < max(dp[v], c)) {
                dp[to] = max(dp[v], c);
                pr[to] = v;
            }
        }
    }
    dp_rev[n] = 0;
    reverse(all(order));
    for (int v : order) {
        if (dp_rev[v] == -1) {
            continue;
        }
        for (auto [to, c] : newg_rev[v]) {
            if (dp_rev[to] < max(dp_rev[v], c)) {
                dp_rev[to] = max(dp_rev[v], c);
                pr_rev[to] = v;
            }
        }
    }

    int ans = 0, u_ans = -1, v_ans = -1;
    for (int v = 1; v <= n; ++v) {
        for (auto [to, c] : newg[v]) {
            if (dp[v] == -1 || dp_rev[to] == -1) {
                continue;
            }
            if (max({dp[v], c, dp_rev[to]}) - c >= ans) {
                ans = max({dp[v], c, dp_rev[to]}) - c;
                u_ans = v;
                v_ans = to;
            }
        }
    }
    vector <int> path;
    while (u_ans != 0) {
        path.push_back(u_ans);
        u_ans = pr[u_ans];
    }
    reverse(all(path));
    while (v_ans != 0) {
        path.push_back(v_ans);
        v_ans = pr_rev[v_ans];
    }
    cout << (int)(path.size()) - 1 << '\n';
    for (int v : path) {
        cout << v << ' ';
    }
    cout << endl;


}


int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #ifdef fleek$
        assert(freopen ("input.txt", "r", stdin));
    #endif
    int t = 1;
    // cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    } 
    return 0;
}