#include <cassert>
#include <utility>
#include <tuple>
#include <iostream>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <set>
#include <sstream>

using namespace std;
using ll = long long;

//#define int ll

#define pb push_back
#define eb emplace_back
#define agn assign
#define DEBUG(x) cerr << #x << ": " << x << "\n";
#define F first
#define S second

#define BOUNDS_1(x, n) (x >= 0 && x < n)
#define BOUNDS_2(x, n) (x > 0 && x <= n)
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<double, int> pdi;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<ll> vll;
typedef vector<pii> vpii;
typedef vector<pll> vpll;

const int INF = 1000 * 1000 * 1000 + 10;
//const int M = 1000 * 1000 * 1000 + 7;
const ll INFLL = 1000ll * 1000 * 1000 * 1000 * 1000 * 1000;

const int MOD = 998244353;

struct Node {
    Node *g[35];
    Node *parent = nullptr;
    char parent_c;
    bool term = false;
    int num = 0, del = 0;
    int len = 0;
};

Node *root = new Node();

void put(const std::string &s) {
    Node *cur = root;
    for (char c : s) {
        c -= 'a';
        if (!cur->g[c]) {
            cur->g[c] = new Node();
            cur->g[c]->parent_c = c + 'a';
            cur->g[c]->parent = cur;
            cur->g[c]->len = cur->len + 1;
        }

        ++cur->num;
        cur = cur->g[c];
    }
    ++cur->num;
    cur->term = true;
}

void print_path(Node *v) {
    string s;
    while (v->parent) {
        s += v->parent_c;
        v = v->parent;
    }
    reverse(ALL(s));
    cout << s << "\n";
}

set<tuple<int, int, Node *>> que;

auto tup(Node *v) {
    return tuple {v->del - v->num, v->len, v};
}

void calc(Node *cur, int k) {
    if (cur->num <= k)
        que.insert(tup(cur));
    else
        for (Node *to : cur->g)
            if (to)
                calc(to, k);
}

void rem(Node *v) {
    auto p = tup(v);
    auto it = que.find(p);
    if (it != que.end() && *it == p) {
        que.erase(it);
        for (Node *to : v->g)
            if (to)
                rem(to);
    }
}

void update(Node *v, int k) {
    v->del = v->num;

    Node *lcur = v->parent;
    Node *cur = v->parent;
    while (cur) {
        int sum = 0;
        for (Node *to : cur->g)
            if (to)
                sum += to->del;
        if (cur->num - sum <= k) {
            que.erase(tup(cur));
            cur->del = sum;
            que.insert(tup(cur));
            cur = cur->parent;
        } else {
            break;
        }
    }
}

void solve() {
    int n, k;
    cin >> n >> k;

    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        put(s);
    }

    calc(root, k);

    int ops = 0;
    while (root->del < root->num) {
        ++ops;
        auto it = que.begin();
        auto[d, o, v] = *it;
        rem(v);
//        print_path(v);
//        cout << abs(d) << "\n";
        update(v, k);
    }
    cout << ops << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

//    int T;
//    cin >> T;
//    while (T--)
//        solve();
    solve();
}

