#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <deque>
#include <queue>

using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");

using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll const inf = 1e18;

random_device rd;
mt19937 mersenne(rd());

struct Bor 
{
	struct Node
	{
		ll dp = 0;
		map<char, pair<ll, ll>> children;
		set<pair<ll, ll>> priority;

		Node()
		{

		}
	};

	vector<Node> tree;
	ll root = 0;

	Bor() 
	{
		tree.push_back(Node());
	}

	void add(ll node, string& s, ll i)
	{
		tree[node].dp++;
		if (i == s.size())
		{
			return;
		}
		if (!tree[node].children.count(s[i]))
		{
			tree.push_back(Node());
			tree[node].children[s[i]] = { 0, tree.size() - 1 };
			tree[node].priority.insert({ -0, tree.size() - 1 });
		}
		ll child = tree[node].children[s[i]].second;
		ll dp = tree[child].dp;
		tree[node].children.erase(s[i]);
		tree[node].priority.erase({ -dp, child });
		dp++;

		tree[node].children[s[i]] = { dp, child };
		tree[node].priority.insert({ -dp, child });
		add(child, s, i + 1);
	}

	void add(string s)
	{
		add(root, s, 0);
	}
	
	void dfs(ll v, ll p, ll k, ll& ans, vector<ll>& del)
	{
		if (p != -1)
		{
			if (tree[p].dp - del[p] - del[v] <= k)
				return;

			for (auto& du : tree[v].priority)
			{
				ll d = du.first;
				ll u = du.second;
				dfs(u, v, k, ans, del);
			}
			
			if (tree[v].dp - del[v] > 0 && tree[p].dp - del[p] - del[v] > k)
			{
				++ans;
				del[v] += tree[v].dp;
			}
			del[p] += del[v];
		}
		else
		{
			for (auto& du : tree[v].priority)
			{
				ll d = du.first;
				ll u = du.second;
				dfs(u, v, k, ans, del);
			}

			if (tree[v].dp - del[v] > 0)
			{
				++ans;
				del[v] += tree[v].dp;
			}
		}

	}

};

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll n, k; cin >> n >> k;
	Bor bor;

	for (int i = 0; i < n; ++i)
	{
		string s; cin >> s;
		bor.add(s);
	}
	ll ans = 0;
	vector<ll> del(bor.tree.size(), 0);
	bor.dfs(0, -1, k, ans, del);
	cout << ans << '\n';

	return 0;
}