#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;
typedef complex<double> cld;

const int inf = 1e18;
const ld eps = 1e-9;
const ld pi = atan2(0, -1);
const int mod = 1e9+7;

/// Code  part ///

struct Solver {
    vector<vector<int>> a;
    int n, m;

    Solver(vector<vector<int>> a): a(a) {
        n = a.size(), m = a[0].size();
    }

    void delete_f(int i, int j) {
        a[i+0][j+0] = 0;
        a[i+0][j+1] = 0;
        a[i+0][j+2] = 0;
        
        a[i+1][j+0] = 0;
        
        a[i+2][j+0] = 0;
        a[i+2][j+1] = 0;
        
        a[i+3][j+0] = 0;
        
        a[i+4][j+0] = 0;
    }
    
    void delete_q(int i, int j) {
        a[i+0][j+0] = 0;
        a[i+0][j+1] = 0;
        a[i+0][j+2] = 0;

        a[i+1][j+0] = 0;
        a[i+1][j+2] = 0;

        a[i+2][j+0] = 0;
        a[i+2][j+1] = 0;
        a[i+2][j+2] = 0;

        a[i+3][j+2] = 0;

        a[i+4][j+2] = 0;
    }

    void solve() {
        int q = 0, f = 0;

        for(int j = 0; j < m; ++j) {
            int cnt = 0;
            for(int i = 0; i < n; ++i) {
                if(a[i][j]) cnt++;

                if(!a[i][j] && cnt) {
                    if(cnt % 5) {
                        delete_q(i-3, j);
                        i -= 3;
                        cnt-=3;
                        q += 1;
                    }
                    if(cnt == 0) continue;
                    f += cnt/5;
                    for(int k = 0; 5*k < cnt; ++k)
                        delete_f(i-5*k-5, j);
                    

                    cnt = 0;
                }
            }
        }

        cout << q << " " << f << "\n";
    }
};

/// Code part ///
int file_io = 0, debug = 0;

int32_t main() {
    // file_io = 1;

    if(file_io) freopen("inp.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tests = (debug ? 1000 : 1);
    if(file_io) cin >> tests;

    for(int test = 0; test < tests; ++test) {
        if(!debug) {
            /// Main part ///

            int n, m;
            cin >> n >> m;

            vector<vector<int>> a(n+1, vector<int>(m, 0));
            for(int i = 0; i < n; ++i) {
                string s;
                cin >> s;
                for(int j = 0; j < m; ++j) {
                    a[i][j] = (s[j] == '#');
                }
            }

            Solver solver(a);
            solver.solve();

            /// Main part ///
        } else {}
    }

    return 0;
}

/**

*/
