#include <bits/stdc++.h>
using namespace std;

const vector<vector<char>> LETTER_Q = {{'#', '#', '#'},
                                       {'#', '.', '#'},
                                       {'#', '#', '#'},
                                       {'.', '.', '#'},
                                       {'.', '.', '#'}};


const vector<vector<char>> LETTER_F = {{'#', '#', '#'},
                                       {'#', '.', '.'},
                                       {'#', '#', '.'},
                                       {'#', '.', '.'},
                                       {'#', '.', '.'}};



bool check_for_letter(int i, int j, vector<vector<char>> &grid, const vector<vector<char>> &letter) {
    bool flag = true;
    flag &= i + letter.size() <= grid.size();
    flag &= j + letter.front().size() <= grid.front().size();
    for (int a = 0; flag && a < letter.size(); a++) {
        for (int b = 0; flag && b < letter.front().size(); b++) {
            if (letter[a][b] == '#') {
                flag &= grid[i + a][j + b] == letter[a][b];
            }
        }
    }
    if (flag) {
        for (int a = 0; a < letter.size(); a++) {
            for (int b = 0; b < letter.front().size(); b++) {
                if (letter[a][b] == '#') {
                    grid[i + a][j + b] = '.';
                }
            }
        }
    }
    return flag;
}

void run() {
    int n;
    int m;
    cin >> n >> m;
    vector<vector<char>> grid(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> grid[i][j];
        }
    }
    int count_q = 0;
    int count_f = 0;
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            bool f = check_for_letter(i, j, grid, LETTER_F);
            bool q = check_for_letter(i, j, grid, LETTER_Q);
            if (q) {
//                cout << "Q: " << i << " " << j << '\n';
                count_q++;
            } else if (f) {
//                cout << "F: " << i << " " << j << '\n';
                count_f++;
            }
        }
    }
    cout << count_q << " " << count_f << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("data", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(16);
    run();
    return 0;
}
