// @author: noisegain

fun main() {
    val (n, m) = readInts(2)
    val a = readLines(n)
    var (ansQ, ansF) = 0 to 0
    val dp = Array(n) { BooleanArray(m) }

    fun parse(i: Int, j: Int, q: Boolean = true) {
        if (q) ansQ++
        else ansF++
        dp[i][j - 1] = true
        (i..i + if (q) 4 else 0).forEach { dp[it][j] = true }
        (i..i + if (q) 2 else 4).forEach { dp[it][j - 2] = true }
        dp[i + 2][j - 1] = true
    }

    for (j in m - 1 downTo 0) {
        for (i in 0 until n) {
            if (!dp[i][j] && a[i][j] == '#') parse(i, j, a[i + 1][j] == '#' && !dp[i + 1][j])
        }
    }
    printm(ansQ, ansF)
}

private fun <E> List<E>.toPair(): Pair<E, E> = Pair(this[0], this[1])

fun maxOf(ans: Pair<Int, Int>, b: Pair<Int, Int>): Pair<Int, Int> =
    if (ans.first > b.first || ans.first == b.first && ans.second > b.second) ans else b

private fun <T1 : Comparable<T1>, T2 : Comparable<T2>> pairCmp(): Comparator<Pair<T1, T2>> =
    Comparator { a, b ->
        val res = a.first.compareTo(b.first)
        if (res == 0) a.second.compareTo(b.second) else res
    }


val INPUT = System.`in`
const val BUFFER_SIZE = 1 shl 16
val buffer = ByteArray(BUFFER_SIZE)
var bufferPt = 0
var bytesRead = 0

tailrec fun readChar(): Char {
    if (bufferPt == bytesRead) {
        bufferPt = 0
        bytesRead = INPUT.read(buffer, 0, BUFFER_SIZE)
    }
    return if (bytesRead < 0) Char.MIN_VALUE
    else {
        val c = buffer[bufferPt++].toChar()
        if (c == '\r') readChar()
        else c
    }
}


fun readLine(): String? {
    var c = readChar()
    return if (c == Char.MIN_VALUE) null
    else buildString {
        while (true) {
            when (c) {
                '\n', Char.MIN_VALUE -> return@buildString
                else -> {
                    append(c)
                    c = readChar()
                }
            }
        }
    }
}

fun readLn() = readLine()!!

fun read() = buildString {
    var c = readChar()
    while (c <= ' ') {
        if (c == Char.MIN_VALUE) return@buildString
        c = readChar()
    }
    do {
        append(c)
        c = readChar()
    } while (c > ' ')
}

fun readInt() = read().toInt()
fun readDouble() = read().toDouble()
fun readLong() = read().toLong()
fun readStrings(n: Int) = List(n) { read() }
fun readLines(n: Int) = List(n) { readLn() }
fun readInts(n: Int) = List(n) { read().toInt() }
fun readIntArray(n: Int) = IntArray(n) { read().toInt() }
fun readDoubles(n: Int) = List(n) { read().toDouble() }
fun readDoubleArray(n: Int) = DoubleArray(n) { read().toDouble() }
fun readLongs(n: Int) = List(n) { read().toLong() }
fun readLongArray(n: Int) = LongArray(n) { read().toLong() }
private fun println(x: Any?) = print("$x\n")
private fun printm(vararg x: Any?) = println(x.joinToString(" "))