#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <cfenv>
#include <queue>
#include <math.h>
#include <vector>
#include <string>
#include <random>
#include <numeric>
#include <iomanip>
#include <cassert>
#include <complex>
#include <iostream>
#include <iterator>
#include <memory.h>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double db;
typedef complex <db> cmpl;
typedef pair <int, int> pii;

const ll MOD1 = 998244353;
const ll MOD2 = (int)1e9 + 7;
const db EPS = 1e-7;
const int INF = (int)1e9 + 7;

const int N = (int)5e5;

struct node {
    map <char, int> nxt;

    int parent;

    node() : parent(-1) {}
};

node tree[N];
int n, k, tree_size = 1, ans, cnt_leaves[N];
vector <int> nxt_verts[N];
string s;

void add(int node_ind = 0, int s_ind = 0) {
    if (s_ind == s.size()) {
        return;
    }
    if (tree[node_ind].nxt.find(s[s_ind]) == tree[node_ind].nxt.end()) {
        tree[node_ind].nxt[s[s_ind]] = tree_size++;
        tree[tree_size - 1].parent = node_ind;
    }
    add(tree[node_ind].nxt[s[s_ind]], s_ind + 1);
}

int make_cnt_leaves(int node_ind = 0) {
    if (tree[node_ind].nxt.size() == 0) {
        if (node_ind) {
            cnt_leaves[node_ind] = 1;
        }
    } else {
        for (auto e : tree[node_ind].nxt) {
            cnt_leaves[node_ind] += make_cnt_leaves(e.second);
        }
    }
    for (auto e : tree[node_ind].nxt) {
        nxt_verts[node_ind].push_back(e.second);
    }
    return cnt_leaves[node_ind];
}

int deleting(int v = 0) {
    int old_cnt_leaves = cnt_leaves[v];
    for (auto e : tree[v].nxt) {
        if (cnt_leaves[e.second] > k) {
            cnt_leaves[v] += deleting(e.second);
        }
    }
    if (cnt_leaves[v] > k) {
        sort(nxt_verts[v].begin(), nxt_verts[v].end(), [&](int a, int b) {return cnt_leaves[a] > cnt_leaves[b]; });
        for (int i = 0; i < nxt_verts[v].size(); ++i) {
            if (cnt_leaves[nxt_verts[v][i]]) {
                cnt_leaves[v] -= cnt_leaves[nxt_verts[v][i]];
                ++ans;
            }
            if (cnt_leaves[v] <= k) {
                break;
            }
        }
    }
    if (v) {
        return cnt_leaves[v] - old_cnt_leaves;
    }
    if (cnt_leaves[v]) {
        ++ans;
    }
    return 0;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    iostream::sync_with_stdio(0);
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> s;
        add();
    }
    make_cnt_leaves();
    deleting();
    cout << ans;
    return 0;
}
