#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <cfenv>
#include <queue>
#include <math.h>
#include <vector>
#include <string>
#include <random>
#include <numeric>
#include <iomanip>
#include <cassert>
#include <complex>
#include <iostream>
#include <iterator>
#include <memory.h>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double db;
typedef complex <db> cmpl;
typedef pair <int, int> pii;

const ll MOD1 = 998244353;
const ll MOD2 = (int)1e9 + 7;
const db EPS = 1e-7;
const int INF = (int)1e9 + 7;

const int N = (int)1e5;

struct way {
    int cnt, c_max, c_min;

    way(int cnt = INF, int c_max = 0, int c_min = 0) : cnt(cnt), c_max(c_max), c_min(c_min) {}
};

int n, m, p[N];
vector <pair <int, int>> G[N];
way d[N];
vector <int> ans;

bool cmp(way a, way b) {
    if (a.cnt == b.cnt) {
        return a.c_max - a.c_min > b.c_max - b.c_min;
    }
    return a.cnt < b.cnt;
}

bool cmp1(pair <way, int> a, pair <way, int> b) {
    if (cmp(a.first, b.first)) {
        return true;
    }
    if (cmp(b.first, a.first)) {
        return false;
    }
    return a.second < b.second;
}

using compare = integral_constant<decltype(&cmp1), &cmp1>;

void bfs() {
    set <pair <way, int>, compare> q;
    d[0] = way(0, -INF, INF);
    q.insert({ d[0], 0 });
    while (q.size()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto e : G[v]) {
            way new_d = d[v];
            new_d.c_max = max(new_d.c_max, e.second);
            new_d.c_min = min(new_d.c_min, e.second);
            ++new_d.cnt;
            if (cmp(new_d, d[e.first])) {
                p[e.first] = v;
                q.erase({ d[e.first], e.first });
                d[e.first] = new_d;
                q.insert({ d[e.first], e.first });
            }
        }
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    scanf("%d%d", &n, &m);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        scanf("%d%d%d", &u, &v, &c);
        --u, --v;
        G[v].push_back({ u, c });
        G[u].push_back({ v, c });
    }
    bfs();
    int v = n - 1;
    while (v) {
        ans.push_back(v + 1);
        v = p[v];
    }
    ans.push_back(v + 1);
    reverse(ans.begin(), ans.end());
    printf("%d\n", ans.size() - 1);
    for (int v : ans) {
        printf("%d ", v);
    }
    return 0;
}
