#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <map>
#include <cfenv>
#include <queue>
#include <math.h>
#include <vector>
#include <string>
#include <random>
#include <numeric>
#include <iomanip>
#include <cassert>
#include <complex>
#include <iostream>
#include <iterator>
#include <memory.h>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double db;
typedef complex <db> cmpl;
typedef pair <int, int> pii;

const ll MOD1 = 998244353;
const ll MOD2 = (int)1e9 + 7;
const db EPS = 1e-7;
const int INF = (int)1e9 + 7;

const int N = (int)1e5;

struct way {
    int cnt, c_max, c_min;

    way(int cnt = INF, int c_max = 0, int c_min = 0) : cnt(cnt), c_max(c_max), c_min(c_min) {}
};

int n, m, d[N];
pair <int, int> dp_front[N], dp_back[N], p_front[N], p_back[N];
vector <pair <int, int>> G[N];
vector <int> ans;
bool used[N];

void bfs() {
    queue <int> q;
    fill(d, d + n, INF);
    fill(used, used + n, false);
    d[0] = 0;
    q.push(0);
    used[0] = true;
    while (q.size()) {
        int v = q.front();
        q.pop();
        for (auto e : G[v]) {
            if (!used[e.first]) {
                d[e.first] = d[v] + 1;
                q.push(e.first);
                used[e.first] = true;
            }
        }
    }
}

void make_dp_front(int v = 0) {
    if (used[v]) {
        return;
    }
    used[v] = true;
    dp_front[v] = { INF, -INF };
    if (v == n - 1) {
        return;
    }
    for (auto e : G[v]) {
        if (d[e.first] == d[v] + 1) {
            make_dp_front(e.first);
            if (dp_front[v].first != INF || e.first == n - 1) {
                if (dp_front[v].first > min(e.second, dp_front[e.first].first)) {
                    dp_front[v].first = min(e.second, dp_front[e.first].first);
                    p_front[v].first = e.first;
                }
                if (dp_front[v].second < max(e.second, dp_front[e.first].second)) {
                    dp_front[v].second = max(e.second, dp_front[e.first].second);
                    p_front[v].second = e.first;
                }
            }
        }
    }
}

void make_dp_back(int v = n - 1) {
    if (used[v]) {
        return;
    }
    used[v] = true;
    dp_back[v] = { INF, -INF };
    if (v == 0) {
        return;
    }
    for (auto e : G[v]) {
        if (d[e.first] == d[v] - 1) {
            make_dp_back(e.first);
            if (dp_back[v].first > min(e.second, dp_back[e.first].first)) {
                dp_back[v].first = min(e.second, dp_back[e.first].first);
                p_back[v].first = e.first;
            }
            if (dp_back[v].second < max(e.second, dp_back[e.first].second)) {
                dp_back[v].second = max(e.second, dp_back[e.first].second);
                p_back[v].second = e.first;
            }
        }
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    scanf("%d%d", &n, &m);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        scanf("%d%d%d", &u, &v, &c);
        --u, --v;
        G[v].push_back({ u, c });
        G[u].push_back({ v, c });
    }
    bfs();
    fill(used, used + n, false);
    make_dp_front();
    fill(used, used + n, false);
    make_dp_back();
    int v = 0, delta = -1, var = 0;
    for (int i = 0; i < n; ++i) {
        if (dp_front[i].second - dp_back[i].first > delta) {
            delta = dp_front[i].second - dp_back[i].first;
            v = i;
            var = 1;
        }
        if (dp_back[i].second - dp_front[i].first > delta) {
            delta = dp_back[i].second - dp_front[i].first;
            v = i;
            var = 0;
        }
    }
    if (delta == -1) {
        v = 0;
        var = 1;
    }
    int u = v;
    while (v != n - 1) {
        ans.push_back(v + 1);
        if (var) {
            v = p_front[v].second;
        } else {
            v = p_front[v].first;
        }
    }
    ans.push_back(n);
    reverse(ans.begin(), ans.end());
    v = u;
    while (v) {
        if (var) {
            v = p_back[v].first;
        } else {
            v = p_back[v].second;
        }
        ans.push_back(v + 1);
    }
    reverse(ans.begin(), ans.end());
    printf("%d\n", ans.size() - 1);
    for (int v : ans) {
        printf("%d ", v);
    }
    return 0;
}
