#include <iostream>
#include <vector>
using namespace std;

struct Node {
    int weight;
    int depth;
    Node *prev;
    Node *next[26];
};

Node *create(int depth) {
    Node *node = new Node();
    node->weight = 0;
    node->depth = depth;
    node->prev = nullptr;
    for (int i = 0; i < 26; i++)
        node->next[i] = nullptr;
    return node;
}

struct Bor {
    Node *root;
};

void addWord(Bor &b, string &word) {
    Node *cur = b.root;
    b.root->weight++;
    for (char c : word) {
        if (cur->next[c - 'a'] == nullptr) {
            cur->next[c - 'a'] = create(cur->depth + 1);
            cur->next[c - 'a']->prev = cur;
        }
        cur->next[c - 'a']->weight++;
        cur = cur->next[c - 'a'];
    }
}

int recFindMax(Node *cur, int k) {
    if (cur == nullptr) return 0;
    //if (cur->weight == 0) return 0;
    int Max = cur->weight;
    if (cur->weight > k) Max = 0;

    for (int i = 0; i < 26; i++)
        if (cur->next[i] != nullptr)
            Max = max(Max, recFindMax(cur->next[i], k));
    return Max;
}

Node *getFoundMax(Node *cur, int max) {
    if (cur == nullptr) return cur;
    //if (cur->weight == 0) return nullptr;
    if (max == cur->weight) return cur;
    Node *node = nullptr;
    for (int i = 0; i < 26; i++) {
        node = getFoundMax(cur->next[i], max);
        if (node != nullptr) return node;
    }
    return node;
}

void remove(Bor b, int k) {
    int maxFound = recFindMax(b.root, k);
    Node *node = getFoundMax(b.root, maxFound);

    if (node == nullptr) exit(1);

    while (node != nullptr) {
        node->weight -= maxFound;
        node = node->prev;
    }
}

int main()
{
    Bor b;
    b.root = create(0);
    int n, k;
    cin >> n >> k;
    vector <string> words(n);
    for (int i = 0; i < n; i++) {
        cin >> words[i];
        addWord(b, words[i]);
    }

    int cnt = 0;
    while (b.root->weight > 0) {
        remove(b, k);
        cnt++;
    }
    cout << cnt;
}
