#include <iostream>
#include <vector>
using namespace std;

bool matchesQ(vector <vector <char> > &grid, int i, int j) {
    bool ok = true;
    ok &= (grid[i][j] != '#');
    ok &= (grid[i + 1][j] != '#');
    ok &= (grid[i + 2][j] != '#');
    ok &= (grid[i][j + 1] != '#');
    ok &= (grid[i + 2][j + 1] != '#');
    for (int k = 0; k < 5; k++)
        ok &= (grid[i + k][j + 2] == '#');
    return ok;
}

void deleteQ(vector <vector <char> > &grid, int i, int j) {
    grid[i][j] = '0';
    grid[i + 1][j] = '0';
    grid[i + 2][j] = '0';
    grid[i][j + 1] = '0';
    grid[i + 2][j + 1] = '0';
    for (int k = 0; k < 5; k++)
        grid[i + k][j + 2] = '0';
}

bool matchesF(vector <vector <char> > &grid, int i, int j) {
    bool ok = true;
    for (int k = 0; k < 5; k++)
        ok &= (grid[i + k][j] == '#');
    ok &= (grid[i][j + 1] == '#');
    ok &= (grid[i][j + 2] == '#');
    ok &= (grid[i + 2][j + 1] == '#');
    return ok;
}

void deleteF(vector <vector <char> > &grid, int i, int j) {
    for (int k = 0; k < 5; k++)
        grid[i + k][j] = '0';
    grid[i][j + 1] = '0';
    grid[i][j + 2] = '0';
    grid[i + 2][j + 1] = '0';
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector <vector <char> > grid(n, vector <char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cin >> grid[i][j];
        getchar();
    }
    int q = 0, f = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (grid[i][j] == '#') {
                if (matchesF(grid, i, j)) {
                    f++;
                    deleteF(grid, i, j);
                }
                else {
                    q++;
                    deleteQ(grid, i, j);
                }

            }
        }
    }
    cout << q << " " << f;
}
