#include <bits/stdc++.h>
#include <regex>
#include <array>
#include <unordered_set>
#include <future>
#include <optional>
#include <any>
#include <variant>
#include <stdlib.h>
#include <cmath>
#include <random>
#include <functional>
#include <climits>

#ifdef LOCAL_UTILITS
#include "Utilits/Timer.h"
#endif

using namespace std;

using li = long long;
using vi = vector<li>;
using pi = pair<li, li>;
using vpi = vector<pi>;
using vvi = vector<vector<li>>;
using vvpi = vector<vpi>;
using ld = long double;

#define forn(i,n) for (li i = 0;i < li(n);i++)
#define ford(i,n) for (li i = li(n)-1;i >=0;i--)
#define fore(i,l,r) for (li i = li(l);i < li(r);i++)
#define forv(v,arr) for (auto& v : (arr))
#define all(a) (a).begin(),(a).end()

using Point = complex<li>;

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    forv(v, a)
        in >> v;
    return in;
}

ostream& operator<<(ostream& out, vi& a)
{
    for (auto v : a)
    {
        out << v;
        out.put(' ');
    }
    return out;
}

ostream& operator<<(ostream& out, vi&& a)
{
    for (auto v : a)
    {
        out << v;
        out.put(' ');
    }
    return out;
}

li get_num(string s)
{
    stringstream ss;
    ss << s;
    li v;
    ss >> v;
    return v;
}

li gcd(li a, li b)
{
    return b ? gcd(b, a % b) : a;
}

struct Graph
{
    vvpi a;
    vpi dp, dpr;
    vpi dpp, dprp;
    vi dist;
    vi vis;
    vi corr;
    int n, m;

    void addEdge()
    {
        li l, r, val;
        cin >> l >> r >> val;
        l--, r--;
        a[l].emplace_back(r, val);
        a[r].emplace_back(l, val);
    }

    void clear()
    {
        vis.assign(n, 0);
    }

    Graph()
    {
        cin >> n >> m;
        a.assign(n, vpi());
        dist.assign(n, -1);
        corr.assign(n, 0);
        dp.assign(n, { 1e9,0 });;
        dpr.assign(n, { 1e9,0 });;
        dpp.assign(n, { -1,-1 });;
        dprp.assign(n, { -1,-1 });;
        clear();
        forn(i, m)
            addEdge();
    }

    void bfs(int root)
    {
        queue<int> q;
        q.push(root);
        dist[root] = 0;
        while (q.size())
        {
            int v = q.front();
            q.pop();
            for (auto [to, c] : a[v])
            {
                if (dist[to] != -1)
                    continue;
                dist[to] = dist[v] + 1;
                q.push(to);
            }
        }
    }

    bool dfs_corr(int v)
    {
        if (vis[v])
            return corr[v];
        vis[v] = 1;
        if (v == n - 1)
        {
            corr[v] = 1;
            return 1;
        }
        for (auto [to, c] : a[v])
        {
            if (dist[to] != dist[v] + 1)
                continue;
            if (dfs_corr(to))
                corr[v] = 1;
        }
        return corr[v];
    }

    pi dfs_dp(int v)
    {
        if (vis[v])
            return dp[v];
        vis[v] = 1;
        auto& [mn, mx] = dp[v];
        auto& [mnp, mxp] = dpp[v];
        for (auto [to, c] : a[v])
        {
            if (!corr[to])
                continue;
            if (dist[to] != dist[v] + 1)
                continue;
            auto [mn_to, mx_to] = dfs_dp(to);
            if (mn > min(mn_to, c))
            {
                mnp = to;
                mn = min(mn_to, c);
            }
            if (mx < max(mx_to, c))
            {
                mxp = to;
                mx = max(mx_to, c);
            }
        }
        return dp[v];
    }

    pi dfs_dpr(int v)
    {
        if (vis[v])
            return dpr[v];
        vis[v] = 1;
        auto& [mn, mx] = dpr[v];
        auto& [mnp, mxp] = dprp[v];
        for (auto [to, c] : a[v])
        {
            if (!corr[to])
                continue;
            if (dist[to] != dist[v] - 1)
                continue;
            auto [mn_to, mx_to] = dfs_dpr(to);
            if (mn > min(mn_to, c))
            {
                mnp = to;
                mn = min(mn_to, c);
            }
            if (mx < max(mx_to, c))
            {
                mxp = to;
                mx = max(mx_to, c);
            }
        }
        return dpr[v];
    }

    void solve()
    {
        bfs(0);
        dfs_corr(0);
        clear();
        dfs_dp(0);
        clear();
        dfs_dpr(n - 1);
        int v = 0;

        auto colorfulness = [&](int ind)
        {
            return max(dp[ind].second - dpr[ind].first,
                dpr[ind].second - dp[ind].first);
        };

        forn(i, n)
        {
            if (colorfulness(i) > colorfulness(v))
                v = i;
        }
        bool flag = dp[v].second - dpr[v].first > dpr[v].second - dp[v].first;
        vi ans{v + 1};
        int p = v;
        while (p != 0)
        {
            p = flag ? dprp[p].first : dprp[p].second;
            ans.push_back(p + 1);
        }
        reverse(all(ans));
        p = v;
        while (p != n-1)
        {
            p = flag ? dpp[p].second : dpp[p].first;
            ans.push_back(p + 1);
        }
        cout << ans.size() - 1 << endl;
        cout << ans << endl;
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    Graph g;
    g.solve();
};