#pragma comment(linker, "/STACK:128777216")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <tuple>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <cassert>
#include <random>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); ++i)
#define sz(v) (int)(v).size()
#define forx(_name, _from, to, value) for (int name = from; name < to; name += value)
#define rforx(_name, from, to, value) for (int name = from; name > to; name -= _value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST, _SECOND) make_pair(_FIRST,_SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-9;
mt19937 rnd(42);

void start() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout.setf(ios::fixed);
#ifdef LOCAL
    //freopen("output.out", "w", stdout);
    freopen("input.in", "r", stdin);
#endif
}

const int MAX_N = (int) 1e7 + 10;
const int MAX_M = (int) 1e6 + 10;
const int MOD = (int) 1e9;
const int INF = (int) 1e9 + 7;

struct Event {
    ll ost;
    ll pos;
    int tp;
};

const ll MAXN = 5e5;

vector<ll> t(MAXN, 0);

int n;

ll sum (int r)
{
	ll result = 0;
	for (; r >= 0; r = (r & (r+1)) - 1)
		result += t[r];
	return result;
}

void inc (int i, int delta)
{
	for (; i < n; i = (i | (i+1)))
		t[i] += delta;
}

ll sum (int l, int r)
{
	return sum (r) - sum (l-1);
}

void solve() {
    int m;
    cin >> n >> m;
    fill(t.begin(), t.begin() + n, 0);
    vector<Event> evs;
    vector<ll> a(n);
    forn(i, n) cin >> a[i];

    set<pair<ll, ll>> st;
    forn(i, n - 1) {
        ll tp1 = a[i] / m;
        ll tp2 = a[i + 1] / m;
        ll ost1 = m - (a[i] % m);
        ll ost2 = m - (a[i + 1] % m);
        if (tp2 - tp1 > 2) {
            continue;
        } else if (tp2 - tp1 == 2) {
            if (ost1 < ost2) {
                evs.push_back(Event{ost1, i, 2});
                evs.push_back(Event{ost2 - 1, i, -2});
            }
        } else if (tp2 - tp1 == 1) {
            evs.push_back(Event{0, i, 2});
            evs.push_back(Event{min(ost1, ost2) - 1, i, -2});
            if (ost1 < ost2) {
                evs.push_back(Event{ost1, i, 1});
                evs.push_back(Event{ost2 - 1, i, -1});
                evs.push_back(Event{ost2, i, 2});
                evs.push_back(Event{m - 1, i, -2});
            } else {
                evs.push_back(Event{ost1, i, 2});
                evs.push_back(Event{m - 1, i, -2});
            }
        } else {
            evs.push_back(Event{0, i, 1});
            evs.push_back(Event{ost2 - 1, i, -1});
            evs.push_back(Event{ost2, i, 2});
            evs.push_back(Event{ost1 - 1, i, -2});
            evs.push_back(Event{ost1, i, 1});
            evs.push_back(Event{m - 1, i, -1});
        }
    }
    sort(evs.begin(), evs.end(), [](Event p1, Event p2) {
        if (p1.ost == p2.ost) return p1.tp > p2.tp;
        return p1.ost < p2.ost;
    });

    for (int i = 0; i < n; ++i) {
        st.insert({i, i});
    }

    ll ans = 1;
    ll ans_m = 0;
    for (int i = 0; i < evs.size(); ++i) {
        Event ev = evs[i];
        //cout << ev.pos << " " << ev.ost << " " << ev.tp << endl;
        //cout << st.begin()->first << " " << st.begin()->second << endl;
        if (ev.tp > 0) {
            auto it = --st.upper_bound({ev.pos, ev.pos});
            auto p1 = *it;
            auto p2 = *(++it);
            st.erase(p1), st.erase(p2);
            pair<ll, ll> mid = {p1.first, p2.second};
            st.insert(mid);
            if (ev.tp == 2) {
                inc(ev.pos, 1);
            }
            ll s = sum(mid.first, mid.second - 1) + 1;
            if (s > ans) {
                ans = s;
                ans_m = ev.ost;
            }
        } else {
            auto it = --st.upper_bound({ev.pos, 1e9});
            auto p = *it;
            st.erase(p);
            st.insert({p.first, ev.pos});
            st.insert({ev.pos + 1, p.second});
            if (ev.tp == -2) {
                inc(ev.pos, -1);
            }
        }
    }
    cout << ans << " " << ans_m << endl;
}

int main() {
    start();
    int t;
    cin >> t;
    while (t--)
        solve();
    //multitest();
#ifdef LOCAL
    //cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
    return 0;
}
