#include <iostream>
#include <vector>
#include <queue>

using namespace std;

vector<vector<pair<long long, long long>>>g;
vector<long long>d;
vector<long long>count_v;
vector<pair<vector<long long>, pair<long long, long long>>>p;
const long long INF = INT64_MAX;

void print_way(pair<vector<long long>, pair<long long, long long>>&p) {
	for (auto a : p.first)
		cout << a + 1 << " ";
	cout << endl;
	cout << p.second.first << " " << p.second.second << " " << p.second.second - p.second.first << endl;
}

/*void bfs(long long from, long long to) {
	queue<long long>q;
	d[from] = 0;
	q.push(from);
	vector<long long>path;
	path.push_back(from);
	p[from] = path;
	while (!q.empty()) {
		long long v = q.front();
		q.pop();
		for (long long i = 0; i < g[v].size(); i++) {
			long long to_v = g[v][i].first;
			if (d[v] + 1 <= d[to_v]) {
				cout << v + 1 << " " << to_v + 1 << endl;
				q.push(to_v);
				d[to_v] = d[v] + 1;
				count_v[to_v]++;
				path = p[v].first;
				path.push_back(to_v);
				p[to_v].first = path;
				//if (to_v == to) {
				//	print_way(p[to_v]);
				//}		
			}
		}
	}
}*/

void dfs(long long from, long long to, pair<vector<long long>, pair<long long, long long>> path, long long pref_v) {
	for (long long i = 0; i < g[from].size(); i++) {
		long long to_v = g[from][i].first;
		if (d[from] + 1 <= d[to_v] && to_v != pref_v) {
			d[to_v] = d[from] + 1;
			//cout << from + 1 << " " << to_v + 1 << endl;
			count_v[to_v]++;
			path = p[from];
			path.second.first = min(path.second.first, g[from][i].second);
			path.second.second = max(path.second.second, g[from][i].second);
			path.first.push_back(to_v);
			if (to_v != to) {
				p[to_v] = path;
				dfs(to_v, to, path, from);
			}
			else {
				if (p[to].first.size() == 0 || 
					(path.second.second - path.second.first > p[to].second.second - p[to].second.first))
					p[to] = path;
			}
		}
	}
}

int main() {
	long long n, m;
	cin >> n >> m;
	g.resize(n);
	d.resize(n, INF);
	p.resize(n);
	count_v.resize(n);
	long long to, from, c;
	for (int i = 0; i < m; i++) {
		cin >> to >> from >> c;
		to--;
		from--;
		g[to].push_back(make_pair(from, c));
		g[from].push_back(make_pair(to, c));
	}
	vector<long long>path;
	path.push_back(0);
	p[0].first = path;
	p[0].second.first = INF;
	p[0].second.second = INT64_MIN;
	d[0] = 0;
	//bfs(0, n - 1);
	dfs(0, n - 1, p[0], -1);
	cout << count_v[n - 1] << '\n';
	for (auto a : p[n - 1].first)
		cout << a + 1 << " ";
}