# Python program for the above approach
 
# Function to form edge between
# two vertices src and dest
from typing import List
from sys import maxsize
from collections import deque

colors = []
 
def add_edge(adj: List[List[int]],
             src: int, dest: int) -> None:
    adj[src].append(dest)
    adj[dest].append(src)
 
def find_paths(paths: List[List[int]], path: List[int],
               parent: List[List[int]], n: int, u: int) -> None:
    if (u == -1):
        paths.append(path.copy())
        return
 
    for par in parent[u]:
        path.append(u)
        find_paths(paths, path, parent, n, par)
        path.pop()
 
def bfs(adj: List[List[int]],
        parent: List[List[int]], n: int,
        start: int) -> None:
 
    dist = [maxsize for _ in range(n)]
    q = deque()
    q.append(start)
    parent[start] = [-1]
    dist[start] = 0
    while q:
        u = q[0]
        q.popleft()
        for v in adj[u]:
            if (dist[v] > dist[u] + 1):
                dist[v] = dist[u] + 1
                q.append(v)
                parent[v].clear()
                parent[v].append(u)
 
            elif (dist[v] == dist[u] + 1):
                parent[v].append(u)

def print_paths(adj: List[List[int]], n: int,
                start: int, end: int) -> None:
    global colors
    paths = []
    path = []
    parent = [[] for _ in range(n)]
    bfs(adj, parent, n, start)
    find_paths(paths, path, parent, n, end)

    most = -1
    index = -1
    cnt = 0
    for i in range(len(paths)):
        paths[i] = list(reversed(paths[i]))
    for v in paths:
        min_caleido = 10**10
        max_caleido = -1
        for i in range(len(v) - 1):
            min_caleido = min(min_caleido, colors[v[i]][v[i + 1]])
            max_caleido = max(max_caleido, colors[v[i]][v[i + 1]])
        if max_caleido - min_caleido > most:
            most = max_caleido - min_caleido
            index = cnt
        cnt += 1

    print(len(paths[index]) - 1)
    for i in paths[index]:
        print(i + 1, end=' ')
    print()

if __name__ == "__main__":

    # Number of vertices
    n, m = map(int, input().split())
    adj = [[] for _ in range(n)]

    colors = [[0]*n for i in range(n)]
    for i in range(m):
        st, end, color = map(int, input().split())
        add_edge(adj, st-1, end-1)
        colors[st - 1][end - 1] = color
        colors[end-1][st-1] = color
    src = 0
    dest = n - 1
 
    print_paths(adj, n, src, dest)
 
# This code is contributed by sanjeev2552
