#include <iostream>
#include <vector>
using namespace std;

// task L
using Field = vector<vector<char>>;

struct Solution {
    Field field;
    size_t fcount, qcount;

    Solution(size_t n, size_t m) : field(n, vector<char>(m)), fcount(0), qcount(0) {
        for (auto& row : field)
            for (auto& cell : row)
                cin >> cell;
    }

    void Print() const {
        for (const auto& row : field) {
            for (const auto &elem: row)
                cout << elem;
            cout << endl;
        }
    }
};

bool check_f(Solution& sol, size_t i, size_t j) {
    return sol.field[i][j] == '#' && sol.field[i][j + 1] == '#'
        && sol.field[i][j + 2] == '#' && sol.field[i + 1][j] == '#'
        && sol.field[i + 2][j] == '#' && sol.field[i + 2][j + 1] == '#'
        && sol.field[i + 3][j] == '#' && sol.field[i + 4][j] == '#';
}

bool check_q(Solution& sol, size_t i, size_t j) {
    return sol.field[i][j] == '#' && sol.field[i][j + 1] == '#'
        && sol.field[i][j + 2] == '#' && sol.field[i + 1][j] == '#'
        && sol.field[i + 1][j + 2] == '#' && sol.field[i + 2][j] == '#'
        && sol.field[i + 2][j + 1] == '#' && sol.field[i + 2][j + 2] == '#'
        && sol.field[i + 3][j + 2] == '#' && sol.field[i + 4][j + 2] == '#';
}

void paint_f(Solution& sol, size_t i, size_t j) {
    sol.field[i][j] = 'f';
    sol.field[i][j + 1] = 'f';
    sol.field[i][j + 2] = 'f';
    sol.field[i + 1][j] = 'f';
    sol.field[i + 2][j] = 'f';
    sol.field[i + 2][j + 1] = 'f';
    sol.field[i + 3][j] = 'f';
    sol.field[i + 4][j] = 'f';
    sol.fcount++;
}

void paint_q(Solution& sol, size_t i, size_t j) {
    sol.field[i][j] = 'q';
    sol.field[i][j + 1] = 'q';
    sol.field[i][j + 2] = 'q';
    sol.field[i + 1][j] = 'q';
    sol.field[i + 1][j + 2] = 'q';
    sol.field[i + 2][j] = 'q';
    sol.field[i + 2][j + 1] = 'q';
    sol.field[i + 2][j + 2] = 'q';
    sol.field[i + 3][j + 2] = 'q';
    sol.field[i + 4][j + 2] = 'q';
    sol.qcount++;
}

int main() {
    size_t n, m;
    cin >> n >> m;
    Solution sol(n, m);

    for (size_t i = 0; i < n - 4; i++)
        for (size_t j = 0; j < m - 2; j++)
            if (check_f(sol, i, j))
                paint_f(sol, i, j);

    for (size_t i = 0; i < n - 4; i++)
        for (size_t j = 0; j < m - 2; j++)
            if (check_q(sol, i, j))
                paint_q(sol, i, j);

    sol.Print();
    cout << sol.qcount << ' ' << sol.fcount << endl;

    return 0;
}