﻿// Author: russian_proger

#include <algorithm>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <numeric>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <tuple>
#include <utility>
#include <vector>


#define FOR(i, k) for (int i = 0; i < (k); ++i)
#define rep(i, j, k) for (int i = (j); i <= (k); ++i)
#define per(i, j, k) for (int i = (j); i >= (k); --i)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define tiii tuple<int, int, int>
#define pii pair<int, int>
#define pll pair<ll, ll>
#define vi vector<int>
#define vll vector<ll>
#define vpii vector<pii>
#define maximize(a, b) a = max(a, b)
#define minimize(a, b) a = min(a, b)

using namespace std;


struct item {
    int size;
    item** cs;
    item* p;
    item(item* _p = NULL) {
        cs = new item * [26];
        FOR(i, 26) cs[i] = NULL;
        size = 0;
        p = _p;
    }
} root;

multiset<pair<int, item*>, greater<pair<int, item*>>> S;

int cnt = 0;

void add(string& s) {
    item* node = &root;
    for (int i = 0; i < s.size(); ++i) {
        int t = s[i] - 'a';
        if (node->cs[t] == NULL) node->cs[t] = new item(node);
        ++(node->size);
        node = node->cs[t];
    }
    node->size++;
}

void _dfs(item* node) {
    if (node == NULL) return;
    auto t = S.find({ node->size, node });
    if (t != S.end()) S.erase(t);
    FOR(i, 26) if (node->cs[i] != NULL) {
        _dfs(node->cs[i]);
        node->cs[i] = NULL;
    }
}


void modify(item* node, int k) {
    item* cur = node->p;
    _dfs(node);
    if (cur == NULL) return;
    do  {
        S.erase(S.find({ cur->size, cur }));
        cur->size -= k;
        if (cur->size != 0) S.insert({ cur->size, cur });
        else _dfs(cur);
        cur = cur->p;
    } while (cur != NULL);
}

item* max_i = 0;

void dfs(item* node) {
    S.insert({ node->size, node });
    FOR(i, 26) if (node->cs[i] != NULL) dfs(node->cs[i]);
}

int main() {
    ios::sync_with_stdio(false);
    int n, k; cin >> n >> k;
    while (n--) {
        string s; cin >> s;
        add(s);
    }


    dfs(&root);
    int op = 0;
    while (S.size() != 0 && S.begin()->first != 0) {
        ++op;
        pair<int, item*> t = *S.upper_bound({ k + 1, NULL });
        modify(t.second, t.first);
    }
    cout << op;
}