import java.util.*

object SomeTask1 {

    val qPattern = listOf(
        Pair(0, 0),
        Pair(1, 0),
        Pair(2, 0),
        Pair(2, 1),
        Pair(2, 2),
        Pair(2, 3),
        Pair(2, 4),
        Pair(0, 1),
        Pair(0, 2),
        Pair(1, 2)
    )

    val fPattern = listOf(
        Pair(0, 0),
        Pair(1, 0),
        Pair(2, 0),
        Pair(0, 1),
        Pair(0, 2),
        Pair(1, 2),
        Pair(0, 3),
        Pair(0, 4)
    )

    @JvmStatic
    fun main(args: Array<String>) {
        Locale.setDefault(Locale.US)
        val (n, m) = readLine()!!.split(' ').map { it.toInt() }
        val points = mutableListOf<List<Point>>()
        val drawnPoints = mutableListOf<Point>()
        var drawnCount = 0
        var qCount = 0
        var fCount = 0

        for (i in 0 until n) {
            val list = mutableListOf<Point>()
            val str = readLine()!!
            for (j in 0 until m) {
                val drawn = str[j] == '#'
                val point = Point(j, i, drawn, false)
                list.add(point)
                if (drawn) {
                    drawnPoints.add(point)
                    drawnCount++
                }
            }
            points.add(list)
        }

        while (drawnCount > 0) {
            drawnPoints.forEach { point ->
                if (!point.found) {
                    val isQ = isQ(point, points)
                    val isF = isF(point, points)

                    if (isQ >= 0 && isF == -1) {
                        qCount++
                        markQ(point, isQ, points)
                        drawnCount -= 10
                    } else if (isQ == -1 && isF >= 0) {
                        fCount++
                        markF(point, isF, points)
                        drawnCount -= 8
                    }
                }
            }
        }

        println("$qCount $fCount")
    }

    data class Point(
        val x: Int,
        val y: Int,
        val drawn: Boolean,
        var found: Boolean
    )

    fun isQ(point: Point, points: List<List<Point>>): Int {
        var last = -1
        val count = qPattern.indices.count {
            isQAt(point, it, points).also { result ->
                if (result) {
                    last = it
                }
            }
        }
        return when (count) {
            0 -> -1
            1 -> last
            else -> -2
        }
    }

    fun isQAt(point: Point, num: Int, points: List<List<Point>>): Boolean {
        return qPattern.map {
            val x = point.x - qPattern[num].first + it.first
            val y = point.y - qPattern[num].second + it.second
            val sPoint = points.getOrNull(y)?.getOrNull(x)
            sPoint != null && sPoint.drawn && !sPoint.found
        }.all { it }
    }

    fun markQ(point: Point, num: Int, points: List<List<Point>>) {
        qPattern.forEach {
            val x = point.x - qPattern[num].first + it.first
            val y = point.y - qPattern[num].second + it.second
            points[y][x].found = true
        }
    }

    fun isF(point: Point, points: List<List<Point>>): Int {
        var last = -1
        val count = fPattern.indices.count {
            isFAt(point, it, points).also { result ->
                if (result) {
                    last = it
                }
            }
        }
        return when (count) {
            0 -> -1
            1 -> last
            else -> -2
        }
    }

    fun isFAt(point: Point, num: Int, points: List<List<Point>>): Boolean {
        return fPattern.map {
            val x = point.x - fPattern[num].first + it.first
            val y = point.y - fPattern[num].second + it.second
            val sPoint = points.getOrNull(y)?.getOrNull(x)
            sPoint != null && sPoint.drawn && !sPoint.found
        }.all { it }
    }

    fun markF(point: Point, num: Int, points: List<List<Point>>) {
        fPattern.forEach {
            val x = point.x - fPattern[num].first + it.first
            val y = point.y - fPattern[num].second + it.second
            points[y][x].found = true
        }
    }
}
