def calculate(stmt, x, y):
    stack = []
    for elt in stmt:
        if elt == 'x':
            stack.append(x)
        elif elt == 'y':
            stack.append(y)
        elif elt == '+':
            rhs = stack.pop()
            lhs = stack.pop()
            stack.append(lhs + rhs)
        elif elt == '-':
            rhs = stack.pop()
            lhs = stack.pop()
            stack.append(lhs - rhs)
        elif elt == '*':
            rhs = stack.pop()
            lhs = stack.pop()
            stack.append(lhs * rhs)
        elif elt == '^':
            p = stack.pop()
            num = stack.pop()
            if p < 0:
                raise ValueError
            stack.append(pow(num, p))
        else:
            stack.append(int(elt))
        if len(stack) > 0 and abs(stack[-1]) > 1 << 31:
            raise OverflowError
    if len(stack) != 1:
        raise ValueError(stack)
    return stack[0]

def check():
    equation = input().split()
    values = [list(map(lambda y: (i, y), range(-10, 11))) for i in range(-10, 11)]
    for i in range(len(values)):
        values[i] = list(map(lambda p: calculate(equation, *p), values[i]))
    for arr in values:
        print(*arr)
    max_count = 0
    min_count = 0
    plateau = False
    for i in range(1, len(values) - 1):
        for j in range(1, len(values[0]) - 1):
            if (values[i][j] > values[i][j - 1]
                    and values[i][j] > values[i][j + 1]
                    and values[i][j] > values[i + 1][j]
                    and values[i][j] > values[i - 1][j]):
                max_count += 1
            if (values[i][j] < values[i][j - 1]
                    and values[i][j] < values[i][j + 1]
                    and values[i][j] < values[i + 1][j]
                    and values[i][j] < values[i - 1][j]):
                min_count += 1
    deltas = [(0, 1), (0, -1), (1, 0), (-1, 0)]
    for i in range(0, len(values)):
        for j in range(0, len(values[i])):
            for delta in deltas:
                j_i = i + delta[0]
                j_j = j + delta[1]
                if 0 <= j_i < len(values) and 0 <= j_j < len(values[j_i]):
                    if values[j_i][j_j] == values[i][j]:
                        plateau = True
    print(max_count > 1, min_count > 1, plateau)


ans = [
    'x y +',
    'x',
    'x x * 4 x 2 ^ - * y y * 4 y 2 ^ - * + 0 1 - +',
    'x x * 4 x 2 ^ - * y y * 4 y 2 ^ - * * 0 1 - *',
    'x x * 4 x 2 ^ - * y y * 4 y 2 ^ - * +',
    'x x * 4 x 2 ^ - * y y * 4 y 2 ^ - * *',
    'x x 8 - * x 6 - * x 4 - * x 2 - * y y 8 - * y 6 - * y 4 - * y 2 - * +',
    'x 4 x 2 ^ - * y 4 y 2 ^ - * *'
]
a = input().split()
f = a[-1]
a = input().split()
s = a[-1]
a = input().split()
th = a[-1]
print(ans[int(f == 'Yes') * 4 + int(s == 'Yes') * 2 + int(th == 'Yes')])

# for 0 0 0: x y +
# for 0 0 1: x
# for 0 1 0: x x * 4 x 2 ^ - * y y * 4 y 2 ^ - * + 0 1 - +
# for 0 1 1: x x * 4 x 2 ^ - * y y * 4 y 2 ^ - * * 0 1 - *
# for 1 0 0: x x * 4 x 2 ^ - * y y * 4 y 2 ^ - * +
# for 1 0 1: x x * 4 x 2 ^ - * y y * 4 y 2 ^ - * *
# for 1 1 0: x x 8 - * x 6 - * x 4 - * x 2 - * y y 8 - * y 6 - * y 4 - * y 2 - * +
# for 1 1 1: x 4 x 2 ^ - * y 4 y 2 ^ - * *
