#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define x first
#define y second

ll n, m;
vector<vector<pair<ll, ll>>> graph;
map<pair<ll, ll>, ll> edges;
const ll INF = 1e18;


void dijkstra(vector<ll>& d, vector<vector<ll>>& p, vector<pair<ll, ll>>& kekes, ll s, ll f) {
//    vector<ll> d(n, INF);
//    vector<vector<ll>> p(n);
//    vector<pair<ll, ll>> kekes(n, {INF, -1});
    d[s] = 0;
    set<pair<ll, ll>>q;
    q.insert(make_pair(d[s], s));

    while (!q.empty()) {
        ll v = q.begin()->second;
        q.erase(q.begin());

        for (size_t j = 0; j < graph[v].size(); ++j) {
            ll to = graph[v][j].first;
            ll len = 1;

            if (d[v] + len < d[to]) {
                q.erase(make_pair(d[to], to));
                d[to] = d[v] + len;
                kekes[to] = {min(kekes[v].first, len), max(kekes[v].second, len)};
                p[to] = {v};
                q.insert(make_pair(d[to], to));
            } else if (d[v] + len == d[to]) {
                p[to].push_back(v);
            }
        }
    }
}



int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;

    graph.resize(n);


    for (int i = 0; i < m; ++i) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        graph[a].push_back({b, c});
        graph[b].push_back({a, c});

        edges[{a, b}] = c;
        edges[{b, a}] = c;
    }

    vector<ll> d_1(n, INF);
    vector<vector<ll>> p_1(n);
    vector<pair<ll, ll>> kekes_1(n, {INF, -1});


    dijkstra(d_1, p_1, kekes_1, 0, n - 1);


    vector<ll> d_2(n, INF);
    vector<vector<ll>> p_2(n);
    vector<pair<ll, ll>> kekes_2(n, {INF, -1});

    dijkstra(d_2, p_2, kekes_2, n - 1, 0);

    cout << d_1[n - 1] << '\n';

    pair<ll, ll> road = {INF, -1};
    ll mx = -1;
    for (int i = 0; i < n; ++i) {
        if (!p_1[i].empty()) {
            auto diff = (min(kekes_1[i].x, kekes_2[i].x) - max(kekes_1[i].y, kekes_2[i].y));
            if (diff > mx) {
                mx = diff;
                road = {min(kekes_1[i].x, kekes_2[i].x), max(kekes_1[i].y, kekes_2[i].y)};
            }
        }
    }

    vector<ll> answer;
    ll t = n - 1;
    while (true) {
        answer.push_back(t);
        unordered_map<ll, pair<ll, ll>> cur_answers;
        ll vertex = -1;
        for (auto i : p_1[t]) {
            pair<ll, ll> kek = {min(kekes_1[i].x, kekes_2[i].x), max(kekes_1[i].y, kekes_2[i].y)};
            if (road.x == kek.x and road.y == kek.y) {
                vertex = i;
                break;
            }
        }

//        ll mx1 = kekes_1[vertex].y - kekes_2[vertex].x;
//        pair<ll, ll> current_left_road = {min(left_road.x, edges[{vertex, t}]), max(left_road.y, edges[{vertex, t}])};
//
//        for (auto i : cur_answers) {
//            if (i.y.y - i.y.x > mx1) {
//                vertex = i.x;
//                mx1 = i.y.y - i.y.x;
//                current_left_road = {min(left_road.x, edges[{vertex, t}]), max(left_road.y, edges[{vertex, t}])};
//            }
//        }
//        left_road = current_left_road;

        t = vertex;
        if (p_1[t].empty()) {
            break;
        }
    }

    cout << 1 << ' ';
    reverse(answer.begin(), answer.end());
    for (auto i : answer) {
        cout << i + 1 << " ";
    }



    return 0;
}