#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

#define int long long
#define float long double

bool check_F(const vector<vector<int>>& v, int i, int j) {
    return v[i  ][j] > 0 && v[i  ][j+1] >  0 && v[i][j+2] > 0 &&
           v[i+1][j] > 0 && v[i+1][j+1] <= 0 &&
           v[i+2][j] > 0 && v[i+2][j+1] >  0 &&
           v[i+3][j] > 0 &&
           v[i+4][j] > 0;
}

void clean_F(vector<vector<int>>& v, int i, int j) {
    v[i  ][j] = 0; v[i  ][j+1] = 0; v[i][j+2] = 0;
    v[i+1][j] = 0; v[i+1][j+1] = 0;
    v[i+2][j] = 0; v[i+2][j+1] = 0;
    v[i+3][j] = 0;
    v[i+4][j] = 0;

    //cout << "Clean F: " << i << ' ' << j << endl;
}

bool check_Q(const vector<vector<int>>& v, int i, int j) {
    return v[i  ][j] > 0 && v[i  ][j+1] >  0 && v[i  ][j+2] > 0 &&
           v[i+1][j] > 0 && v[i+1][j+1] <= 0 && v[i+1][j+2] > 0 &&
           v[i+2][j] > 0 && v[i+2][j+1] >  0 && v[i+2][j+2] > 0 &&
                                                v[i+3][j+2] > 0 &&
                                                v[i+4][j+2] > 0;
}

void clean_Q(vector<vector<int>>& v, int i, int j) {
    v[i  ][j] = 0; v[i  ][j+1] = 0; v[i  ][j+2] = 0;
    v[i+1][j] = 0; v[i+1][j+1] = 0; v[i+1][j+2] = 0;
    v[i+2][j] = 0; v[i+2][j+1] = 0; v[i+2][j+2] = 0;
    v[i+3][j+2] = 0;
    v[i+4][j+2] = 0;

    //cout << "Clean Q: " << i << ' ' << j << endl;
}

signed main() {
    //freopen("input.txt", "r", stdin);

    int n, m, k=0;
    cin >> n >> m;

    vector<vector<int>> v(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char ch;
            cin >> ch;
            if (ch == '#') {
                v[i][j] = 1;
                ++k;
            }
        }
    }

    vector<vector<int>> f(m), q(m);
    for (int i = 0; i < n - 4; ++i) {
        for (int j = 0; j < m - 2; ++j) {
            if (check_F(v, i, j)) {
                f[j].push_back(i);
            }
            if (check_Q(v, i, j)) {
                q[j].push_back(i);
            }
        }
    }

    int rf = 0, rq = 0;
    for (int i = 0; i < m - 2; ++i) {
        //cout << "1" << endl;
        if (f[i].size() > 0 && q[i].size() == 0) {
            //cout << "for f: " << i << endl;
            for (int j = 0; j < f[i].size(); ++j) {
                if (v[f[i][j]][i] == 1) {
                    clean_F(v, f[i][j], i);
                    ++rf;
                }
            }
            //f.erase(f.begin()+i);
        }
        if (q[i].size() > 0 && f[i].size() == 0) {
            //cout << "for q: " << i << endl;
            for (int j = 0; j < q[i].size(); ++j) {
                if (v[q[i][j]][i] == 1) {
                    clean_Q(v, q[i][j], i);
                    ++rq;
                }
            }
            //q.erase(q.begin()+i);
        }
        if (f[i].size() > 0 && q[i].size() > 0) {
            //cout << "for f&q: " << i << endl;
            int j1 = 0, j2 = 0;
            while (j1 < f[i].size() && j2 < q[i].size()) {
                if (f[i][j1] < q[i][j2]) {
                    if (v[f[i][j1]][i] == 1) {
                        clean_F(v, f[i][j1], i);
                        ++rf;
                        ++j1;
                    }
                }
                else if (f[i][j1] == q[i][j2]) {
                    if (v[j1+3][i] == 1) {
                        clean_F(v, f[i][j1], i);
                        ++rf;
                        ++j1;
                    }
                    else {
                        clean_Q(v, q[i][j2], i);
                        ++rq;
                        ++j2;
                    }
                }
                else {
                    if (v[f[i][j2]][i] == 1) {
                        clean_Q(v, q[i][j2], i);
                        ++rq;
                        ++j2;
                    }
                }
            }
            for (int j = j1; j < f[i].size(); ++j) {
                if (v[f[i][j]][i] == 1) {
                    clean_F(v, f[i][j], i);
                    ++rf;
                }
            }
            for (int j = j2; j < q[i].size(); ++j) {
                if (v[q[i][j]][i] == 1) {
                    clean_Q(v, q[i][j], i);
                    ++rq;
                }
            }
        }
        /*if (f[i].size() > 0 || q[i].size() > 0) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    cout << v[i][j];
                }
                cout << endl;
            }
            cout << endl;
        }*/
    }

    cout << rq << ' ' << rf;
    
    
    /*for (int i = 0; i <= q.size(); ++i) {
        if ((k - i*10) % 8 == 0 && (k - i*10) / 8 <= f.size()) {
            cout << i << ' ' << (k - i*10) / 8 << '\n';
        }
    }*/


    /*for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << v[i][j];
        }
        cout << endl;
    }*/

    return 0;
}