// @author: Nayami
#pragma GCC optimise ("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target ("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,avx,avx2,tune=native")
#include <bits/stdc++.h>
using namespace std;

#define debug(x) cerr << #x << " = " << x << '\n';
#define int long long
#define all(h) h.begin  (), h.end()
#define fi first
#define se second

int const N = 1e5;
vector<pair<int,int>> gr[N + 1];
int len[N + 1];
vector<int> levels[N + 1];

void bfs(int v){
    len[v] = 1;
    levels[1].push_back(v);
    queue<int> q;
    q.push(v);
    while(!q.empty()){
        int u = q.front();
        q.pop();
        for (auto & to : gr[u]){
            if (!len[to.fi]){
                len[to.fi] = len[u] + 1;
                levels[len[u] + 1].push_back(to.fi);
                q.push(to.fi);
            }
        }
    }
}

void calc(int n){
    vector<int> pr(n + 1);
    pr[1] = -1;
    vector<int> min_x(n + 1, 1e18);
    vector<int> max_x(n + 1, -1e18);
    min_x[1] = 1e18, max_x[1] = -1e18;
    for (int l = 1; l < len[n]; ++l){
        for (auto & v : levels[l]){
            for (auto & to : gr[v]){
                int u = to.fi;
                int c = to.se;
                if (len[u] == l + 1) {
                    int new_mx = max(c, max_x[v]);
                    int new_mn = min(c, min_x[v]);
                    if (new_mx - new_mn > max_x[u] - min_x[u]) {
                        max_x[u] = new_mx;
                        min_x[u] = new_mn;
                        pr[u] = v;
                    }
                }
            }
        }
    }
    int t = n;
    vector<int> path;
    while (t != -1){
        path.push_back(t);
        t = pr[t];
    }
    cout << path.size() - 1 << '\n';
    for (int i = path.size() - 1; i > -1; --i){
        cout << path[i] << ' ';
    }
}


signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i){
        int v, u, c;
        cin >> v >> u >> c;
        gr[v].emplace_back(make_pair(u, c));
        gr[u].emplace_back(make_pair(v, c));
    }
    bfs(1);
    calc(n);

    return 0;
}