﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;

namespace ConsoleApplication1
{
    internal class Program
    {
        public static void Main(string[] args)
        {
            var subwordsByWord = new Dictionary<string, HashSet<string>>();
            var wordsBySubword = new Dictionary<string, HashSet<string>>();
            var array = Console.ReadLine().Split().Select(int.Parse).ToArray();
            var n = array[0];
            var k = array[1];
            for (int i = 0; i < n; i++)
            {
                var word = Console.ReadLine();
                var subwords = new HashSet<string>();
                for (int m = 1; m <= word.Length; m++)
                {
                    subwords.Add(word.Substring(0, m));
                }

                subwordsByWord[word] = subwords;
                foreach (var subword in subwords)
                {
                    if (wordsBySubword.TryGetValue(subword, out var words))
                        words.Add(word);
                    else wordsBySubword[subword] = new HashSet<string> {word};
                }
            }

            var count = 0;
            while (subwordsByWord.Any())
            {
                count++;
                if (subwordsByWord.Count <= k)
                {
                    break;
                }
                var toDelete = wordsBySubword
                    .Where(x => x.Value.Count <= k)
                    .OrderByDescending(x => x.Value.Count)
                    .First();

                var subwordToDelete = toDelete.Key;
                var wordsToDelete = toDelete.Value;
                foreach (var wordToDelete in wordsToDelete.ToArray())
                {
                    var usedSubwords = subwordsByWord[wordToDelete];
                    subwordsByWord.Remove(wordToDelete);
                    foreach (var subword in usedSubwords)
                    {
                        wordsBySubword[subword].Remove(wordToDelete);
                    }
                }
            }

            Console.WriteLine(count);
        }
    }
}