from typing import Dict, List


class PrefixTree:
    def __init__(self, char: str):
        self.char = char
        self.inner_count: int = 0
        self.next_nodes: Dict[str, PrefixTree] = dict()

    def add_file(self, filename):
        self.inner_count += 1
        if filename == '':
            return
        first_char = filename[0]
        if first_char not in self.next_nodes:
            self.next_nodes[first_char] = PrefixTree(first_char)
        next_node = self.next_nodes[first_char]
        next_node.add_file(filename[1:])

    def __repr__(self):
        return "'" + self.char + "':" + str(self.inner_count)


split_char = ' '
(count, max_files) = [int(x) for x in input().split()]
tree = PrefixTree('')
for _ in range(count):
    raw = input()
    tree.add_file(raw)

result = 0
while tree.inner_count > 0:
    visited: List[PrefixTree] = []
    queue: List[PrefixTree] = [tree, ]
    while len(queue) > 0:
        current = queue.pop()
        visited.append(current)
        if current.inner_count <= max_files:
            result += 1
            deleted = current.inner_count
            for i in visited:
                i.inner_count -= deleted
            break
        optimal_node = None
        next_node = None
        max_count = 0
        for v in current.next_nodes.values():
            c = v.inner_count
            if c == max_files:
                optimal_node = v
            if c >= max_count:
                max_count = v.inner_count
                next_node = v
        if optimal_node is not None:
            queue.append(optimal_node)
        elif next_node is not None:
            queue.append(next_node)
print(result)
