from typing import Dict, List


class PrefixTree:
    def __init__(self, char: str):
        self.char = char
        self.inner_count: int = 0
        self.next_nodes: Dict[str, PrefixTree] = dict()

    def add_file(self, filename):
        self.inner_count += 1
        if filename == '':
            return
        first_char = filename[0]
        if first_char in self.next_nodes:
            next_n = self.next_nodes[first_char]
        else:
            next_n = PrefixTree(first_char)
            self.next_nodes[first_char] = next_n
        next_n.add_file(filename[1:])

    def __repr__(self):
        return "'" + self.char + "':" + str(self.inner_count)


split_char = ' '
(count, max_files) = [int(x) for x in input().split()]
tree = PrefixTree('')
for p in range(count):
    raw = input()
    tree.add_file(raw)

result = 0
while tree.inner_count > 0:
    visited: List[PrefixTree] = []
    next_node = tree
    while next_node is not None:
        current = next_node
        visited.append(current)
        if current.inner_count <= max_files:
            result += 1
            deleted = current.inner_count
            for i in visited:
                i.inner_count -= deleted
            break
        optimal_node = None
        next_node = None
        max_count = 0
        for v in current.next_nodes.values():
            c = v.inner_count
            if c == max_files:
                optimal_node = v
            if c > max_count:
                max_count = v.inner_count
                next_node = v
        if optimal_node is not None:
            next_node = optimal_node
print(result)
