#include <iostream>

using namespace std;

int h;
int w;

void printMatr(char** m) {
	cout << endl << endl;
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			cout << m[i][j];
		}
		cout << endl;
	}
}

bool isMarked(char** m, int i, int j) {
	if (i >= h || j >= w) return false;
	if (m[i][j] == '#') return true;
	return false;
}

bool isLetter(char** m, int i, int j) {
	return true;
}

void mark(char** m, int i, int j) {
	if (i >= h || j >= w) return;
	m[i][j] = '.';
}

bool checkForQ(char** m, int i, int j, bool remove) {
	if (isMarked(m, i, j) && isMarked(m, i, j + 1) && isMarked(m, i, j + 2)) {
		if (isMarked(m, i + 1, j) && isMarked(m, i + 2, j) && isMarked(m, i + 2, j + 1)) {
			if (isMarked(m, i + 1, j + 2) && isMarked(m, i + 2, j + 2) && isMarked(m, i + 3, j + 2) && isMarked(m, i + 4, j + 2) && !isMarked(m, i + 1, j + 1)) {
				if (remove) {
					mark(m, i, j);
					mark(m, i, j + 1);
					mark(m, i, j + 2);
					mark(m, i + 1, j);
					mark(m, i + 2, j);
					mark(m, i + 2, j + 1);
					mark(m, i + 1, j + 2);
					mark(m, i + 2, j + 2);
					mark(m, i + 3, j + 2);
					mark(m, i + 4, j + 2);
				}
				return true;
			}
		}
	}
	return false;
}

bool checkForF(char** m, int i, int j, bool remove) {
	if (isMarked(m, i, j) && isMarked(m, i, j + 1) && isMarked(m, i, j + 2)) {
		if (isMarked(m, i + 1, j) && isMarked(m, i + 2, j) && isMarked(m, i + 3, j) && isMarked(m, i + 4, j)) {
			if (isMarked(m, i + 2, j + 1) && !isMarked(m, i + 1, j + 1)) {
				if (remove) {
					mark(m, i, j);
					mark(m, i, j + 1);
					mark(m, i, j + 2);
					mark(m, i + 1, j);
					mark(m, i + 2, j);
					mark(m, i + 3, j);
					mark(m, i + 4, j);
					mark(m, i + 2, j + 1);
				}
				return true;
			}
		}
	}
	return false;
}


int main() {
	cin >> h >> w;
	char c1 = getchar();

	char** matr = new char* [h];
	for (int i = 0; i < h; i++) {
		matr[i] = new char[w];
		for (int j = 0; j < w; j++) {
			matr[i][j] = getchar();
		}
		char c = getchar();
	}

	int qcnt = 0;
	int fcnt = 0;
	bool retry = false;
	do {
		retry = false;
		for (int i = 0; i < h; i++) {
			for (int j = 0; j < w; j++) {
				if (isLetter(matr, i, j)) {
					if (checkForF(matr, i, j, false) && checkForQ(matr, i, j, false)) {
						retry = true;
						continue;
					}

					if (checkForF(matr, i, j, true)) {
						fcnt++;
						continue;
					}
					if (checkForQ(matr, i, j, true)) {
						qcnt++;
						continue;
					}
				}
			}
		}
	} while (retry == true);
	printMatr(matr);

	cout << qcnt << " " << fcnt << endl;

	return 0;
}