import java.io.BufferedReader
import java.io.BufferedWriter
import java.io.InputStreamReader
import java.io.OutputStreamWriter

private val matrix = arrayListOf<ArrayList<Boolean>>()
private val flags = arrayListOf<ArrayList<Boolean>>()

private var fAmount = 0
private var qAmount = 0

fun main() {
    val scanner = BufferedReader(InputStreamReader(System.`in`))
    val writer = BufferedWriter(OutputStreamWriter(System.`out`))

    val n: Int
    val m: Int

    scanner.readLine().split(" ").let {
        n = Integer.parseInt(it[0])
        m = Integer.parseInt(it[1])
    }

    repeat(n) {
        val flagsRow = arrayListOf<Boolean>()
        repeat(m) {
            flagsRow.add(false)
        }
        flags.add(flagsRow)
    }

    repeat(n) {
        val matrixRow = arrayListOf<Boolean>()
        scanner.readLine().toCharArray().forEach {
            matrixRow.add(it == '#')
        }
        matrix.add(matrixRow)
    }

    for (row in n - 1 downTo 4) {
        for (cell in m - 1 downTo 0) {
            if (flags[row][cell] || !matrix[row][cell])
                continue

            if (cell > 1)
                checkQ(row, cell)

            if (cell < m - 2)
                checkF(row, cell)
        }
    }

    writer.write("$qAmount $fAmount")
    writer.close()
}

fun checkQ(row: Int, cell: Int) {
    for (i in 0..4)
        if (flags[row - i][cell] || !matrix[row - i][cell])
            return

    for (i in 0..2)
        if (flags[row - 2 - i][cell - 2] || !matrix[row - 2 - i][cell - 2])
            return

    if (flags[row - 2][cell - 1] || !matrix[row - 2][cell - 1])
        return

    if (flags[row - 4][cell - 1] || !matrix[row - 4][cell - 1])
        return

    for (i in 0..4)
        flags[row - i][cell] = true

    for (i in 0..2)
        flags[row - 2 - i][cell - 2] = true

    flags[row - 2][cell - 1] = true
    flags[row - 4][cell - 1] = true

    qAmount++
}

fun checkF(row: Int, cell: Int) {
    for (i in 0..4)
        if (flags[row - i][cell] || !matrix[row - i][cell])
            return

    for (i in 1..2)
        if (flags[row - 4][cell + i] || !matrix[row - 4][cell + i])
            return

    if (flags[row - 2][cell + 1] || !matrix[row - 2][cell + 1])
        return

    for (i in 0..4)
        flags[row - i][cell] = true

    for (i in 1..2)
        flags[row - 4][cell + i] = true

    flags[row - 2][cell + 1] = true

    fAmount++
}