﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <sstream>
#include <climits>
#include <string>
#include <queue>
#include <deque>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <fstream>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef pair<ll, ll> pii;

struct Node;

bool operator<(const Node& lhs, const Node& rhs);


//#pragma warning(disable : 4996)
auto miban = [](Node* n1, Node* n2) {
	return *n1 < *n2;
};

set<Node*, decltype(miban)> nodes(miban);

struct Node
{
	vector<Node*> children;
	Node* parent = nullptr;
	
	ll childCount = 0;
	ll maxDepth = 0;
	ll id;
	bool isLast = false;

	Node() : children(26, nullptr)
	{
		static ll global_id = 0;
		id = global_id++;
	}

	void insert(const string& s, int ind = 0, Node* parent = nullptr)
	{
		++childCount;
		maxDepth = max(maxDepth, (ll)s.length());
		this->parent = parent;

		if (ind == s.length())
			return;

		int i = s[ind] - 'a';
		if (children[i] == nullptr)
			children[i] = new Node;

		children[i]->insert(s, ind + 1, this);
	}

	friend bool operator<(const Node& lhs, const Node& rhs)
	{
		if (lhs.childCount != rhs.childCount)
			return lhs.childCount < rhs.childCount;
		if (lhs.maxDepth != rhs.maxDepth)
			return lhs.maxDepth < rhs.maxDepth;
		return lhs.id < rhs.id;

	}

	void erase(int cnt) {
		nodes.erase(this);
		childCount -= cnt;
		maxDepth = 0;
		for (auto el : children) {
			if(el)
				maxDepth = max(maxDepth, el->maxDepth);
		}
		if (parent)
			parent->erase(cnt);
		if(childCount > 0)
			nodes.insert(this);
	}

	~Node()
	{
		for (int i = 0; i < children.size(); ++i)
			delete children[i];
	}
};

void dfs(Node* root)
{
	if (root == nullptr)
		return;

	nodes.insert(root);
	for (auto child : root->children)
		dfs(child);
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n, k;
	cin >> n >> k;

	Node* root = new Node;

	for (int i = 0; i < n; ++i)
	{
		string s;
		cin >> s;

		root->insert(s);
	}

	dfs(root);

	ll ans = 0;
	while (root->childCount > k)
	{
		Node* target = new Node;
		target->maxDepth = 1e6;
		target->childCount = k;
		auto it = nodes.lower_bound(target);
		it--;

		Node* cur = *it;
		nodes.erase(it);
		int cnt = cur->childCount;
		cur->childCount = 0;
		cur->maxDepth = 0;
		cur->parent->erase(cnt);
		ans++;
	}

	cout << ans + 1 << endl;
}
