#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<vector<pair<ll,ll>>> vec;
const ll INF = 10e10;

vector<char> used;
vector<ll> parent;
ll n;
ll step0 = -1;

ll maxdiff = -1;



int gcd(int a, int b)
{
	if (a == 0)
		return b;
	return gcd(b % a, a);
}

struct queue_item
{
	queue_item(ll f, ll s, ll maxx, ll minn, vector<ll> pathh)
	{
		index = f;
		step = s;
		maxColor = maxx;
		minColor = minn;
		path = pathh;
	}

	ll index;
	ll step;
	ll maxColor;
	ll minColor;
	vector<ll> path;
};

vector<ll> result_path;

void bfs(int start)
{
	queue<queue_item> q;
	vector<ll> path;
	queue_item firstItem(0, 0, 0, INF, path);
	q.push(firstItem);

	while (!q.empty())
	{
		queue_item item = q.front();

		if (step0 != -1 && item.step > step0)
			break;

		ll from = item.index;
		ll step = item.step;
		ll minn = item.minColor;
		ll maxx = item.maxColor;

		used[from] = true;
		q.pop();

		for (int i = 0; i < vec[from].size(); ++i)
		{
			pair<ll, ll> to = vec[from][i];
			if (used[to.first] == true)
				continue;

			vector<ll> path0(item.path);
			path0.push_back(from);

			queue_item toItem(to.first, step + 1,
				max(to.second, maxx), min(to.second, minn), path0);
			q.push(toItem);

			if (to.first == n - 1)
			{
				step0 = step + 1;

				if (toItem.maxColor - toItem.minColor > maxdiff)
				{
					maxdiff = toItem.maxColor - toItem.minColor;
					result_path.resize(0);
					for (int i = 0; i < toItem.path.size(); ++i)
						result_path.push_back(toItem.path[i] + 1);

					result_path.push_back(toItem.index + 1);
				}
			}
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie();
	cout.tie();

	ll m;
	cin >> n >> m;
	
	used.resize(n);
	vec.resize(n);
	parent.resize(n);

	for (int i = 0; i < m; ++i)
	{
		ll from, to, c;
		cin >> from >> to >> c;
		--from; --to;

		vec[from].push_back(make_pair(to, c));
		vec[to].push_back(make_pair(from, c));
	}

	bfs(0);

	cout << result_path.size() - 1 << endl;
	for (int i = 0; i < result_path.size(); ++i)
		cout << result_path[i] << ' ';

	cout << endl;
}