#include "bits/stdc++.h"
using namespace std;

struct TrieNode {

	map<char, TrieNode*> children;

	bool isEndOfWord;
    
	map<char, int> num;
};

struct TrieNode* root;

struct TrieNode* getNewTrieNode()
{
	struct TrieNode* pNode = new TrieNode;
	pNode->isEndOfWord = false;
	return pNode;
}

void insertWord(string word)
{
	struct TrieNode* current = root;

	char s;

	for (int i = 0; i < word.length(); i++) {
		s = word[i];

		if (current->children.find(s)
			== current->children.end()) {

			struct TrieNode* p = getNewTrieNode();

			(current->children)[s] = p;
			(current->num)[s] = 1;
		}
		else {
			current->num[s] = (current->num)[s] + 1;
		}

		current = (current->children)[s];
	}
	current->isEndOfWord = true;
}

pair<bool,int> countWords(vector<string>& words,
			string prefix, TrieNode* root, int k)
{

	char s;
    struct TrieNode* current = root;
	int wordCount = 0;

	for (int i = 0; prefix[i]; i++) {
		s = prefix[i];
        
		if (current->children.find(s)
			== current->children.end()) {

			wordCount = 0;
			break;
		}

		wordCount = (current->num)[s];

		current = (current->children)[s];
	}
    current=root;
    if(wordCount<=k){
        for (int i = 0; prefix[i]; i++) {
		s = prefix[i];
        (current->num)[s]-=wordCount;
        if(current->num[s]<=0) {
            current->children.erase(s);
            current->num.erase(s);
            break;}
		current = (current->children)[s];
	}
    return {1,wordCount};
    }
	return {0,-1};
}

bool check(string str, string del){
    for(int i = 0 ; i < del.length();i++){
        if(del[i]!=str[i]) return 0;
    }
    return 1;
}

int main()
{

    int n,k;
    cin >> n>>k;
	vector<string> words(n);
	for(int i = 0 ; i < n ; i++) cin>>words[i];
    sort(words.begin(),words.end());
    root = getNewTrieNode();
	for (int i = 0; i < n; i++) {
		insertWord(words[i]);
	}

string prefix,last_del="";
int wc= n,res = 0;
for(int i =0; i < n; i++){
    prefix="";
    if(wc<=k){
        res++;
        break;
    }
    if(last_del!=""&&check(words[i],last_del)){
        continue;
    }
    for(int j = 0 ; j < words[i].size();j++){
        prefix+=words[i][j];
        pair <bool,int> tmp = countWords(words,prefix,root,k);
        if(tmp.first){
           wc-=tmp.second;
           last_del=prefix;
           res++;
           break; 
        }
    }
    
}
    cout<< res <<endl;
	return 0;
}
