#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cctype>
#include <map>
#include <cassert>
#include <set>
#include <numeric>
#include <iomanip>
#include <deque>
#include <random>
#include <list>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 1'100'000;
const int INF = 1e9 + 7;
const int M = 998244353;
const ll LINF = 1e18;


void Solve() {

    map<string, int> s2i;
    vector <string> i2s;
    int strcnt = 0;

    int sumOp = 0;
    int t;
    cin >> t;
    
    vector <vector <pair <int, int>>> ops(t);
    
    for (int i = 0; i < t; ++i) {
        int n;
        cin >> n;
        int last = 0;
        sumOp += n;
        for (int j = 0; j < n; ++j) {
            string s;
            cin >> s;
            int sep;
            for (sep = 0; sep < s.size(); ++sep) {
                if (s[sep] == '=') break;
            }
            string name = s.substr(0, sep);
            int val = stoi(s.substr(sep + 1));

            if (s2i.find(name) == s2i.end()) {
                s2i[name] = strcnt;
                i2s.push_back(name);
                strcnt++;
            }

            ops[i].push_back({ s2i[name], val });
        }
        reverse(ops[i].begin(), ops[i].end());
    }
    
    int rcnt;
    cin >> rcnt;
    vector <int> rules(strcnt);
    for (int i = 0; i < rcnt; i++) {
        string s;
        int t;
        cin >> s >> t;
        rules[s2i[s]] = t;
    }

    vector <int> ans;

    vector <vector <bool>> canDo(t);
    vector <int> done(t);
    vector <vector <pair <int, int>>> ndxs(strcnt);
    vector <int> signals;
   
    for (int i = 0; i < t; ++i) {
        canDo[i].resize(ops[i].size());
        for (int j = 0; j < ops[i].size(); j++) {
            ndxs[ops[i][j].first].push_back({ i, j });
            if (ops[i][j].second == rules[ops[i][j].first]) {
                canDo[i][j] = true;
                if (j == done[i])
                    signals.push_back(i);
            }
        }
    }

    while (!signals.empty()) {
        int ndx = signals.back();
        signals.pop_back();

        while (done[ndx] < canDo[ndx].size() && canDo[ndx][done[ndx]]) {
            for (auto i : ndxs[ops[ndx][done[ndx]].first]) {
                canDo[i.first][i.second] = true;
                if (i.second == done[i.first])
                    signals.push_back(i.first);
            }
            ndxs[ops[ndx][done[ndx]].first].clear();
            done[ndx]++;
            ans.push_back(ndx + 1);
        }

    }
    if (ans.size() == sumOp) {
        cout << "Yes\n";
        reverse(ans.begin(), ans.end());
        for (auto i : ans)
            cout << i << " ";
    }
    else
        cout << "No";
}

int main() {
#ifdef _DEBUG
	std::freopen("input.txt", "r", stdin);
	std::freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}
