﻿#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <queue>
using namespace std;

const int N = 100005;

vector<pair<int, int>> a[N]; // <city, color>
int ans[N], cur[N];
int dist = N, cur_dist = -1, ans_min = 1, ans_max = 0;
bool mark[N];
int n;

void dfs(int c, int cur_min, int cur_max) {
	if (cur_dist + 1 > dist)
		return;

	mark[c] = 1;
	cur_dist++;
	cur[cur_dist] = c + 1;

	if (c == n - 1 && (cur_dist < dist || cur_max - cur_min > ans_max - ans_min)) {
		ans_min = cur_min;
		ans_max = cur_max;
		dist = cur_dist;
		for (int i = 0; i <= dist; i++)
			ans[i] = cur[i];
	}

	int mn_color = 1000000005, mx_color = -1;
	for (auto [dest, color] : a[c])
		if (!mark[dest]) {
			mn_color = min(mn_color, color);
			mx_color = max(mx_color, color);
		}
	for (auto [dest, color] : a[c])
		if (!mark[dest] && (color == mn_color || color == mx_color))
			dfs(dest, min(cur_min, color), max(cur_max, color));

	cur[cur_dist] = 0;
	cur_dist--;
	mark[c] = 0;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int m;
	cin >> n >> m;

	for (int i = 0; i < m; i++) {
		int b, c, color;
		cin >> b >> c >> color;
		a[b - 1].push_back({ c - 1,color });
		a[c - 1].push_back({ b - 1,color });
	}

	dfs(0, 1000000005, -1);

	cout << dist << '\n';
	for (int i = 0; i <= dist; i++)
		cout << ans[i] << ' ';

	return 0;
}