﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ICPC_sharp
{
    class Program
    {
        static void Main(string[] args)
        {
            var st = Console.ReadLine().Split();
            var n = int.Parse(st[0]);
            var k = int.Parse(st[1]);
            var g = new PrefixGraph();
            for (var i = 0; i < n; i++)
            {
                var s = Console.ReadLine();
                g.AddChild(s, 0);
            }
            Console.WriteLine(g.Remove(k));
        }
    }

    class PrefixGraph
    {
        public int ChildCount;
        public Dictionary<char, PrefixGraph> Children = new Dictionary<char, PrefixGraph>();

        public void AddChild(string s, int pos)
        {
            ChildCount++;
            if (pos == s.Length)
                return;
            if (!Children.ContainsKey(s[pos]))
                Children[s[pos]] = new PrefixGraph();
            Children[s[pos]].AddChild(s, pos + 1);
        }

        public int Remove(int k)
        {
            var removes = 0;
            foreach (var child in Children.Values.OrderByDescending(c => c.ChildCount))
            {
                if (ChildCount <= k)
                {
                    return removes + 1;
                }
                removes += child.Remove(k);
                ChildCount -= child.ChildCount;
                
            }
            return removes;
        }

        public override string ToString()
        {
            return "Childs: " + ChildCount;
        }
    }
}