#include <bits/stdc++.h>

using namespace std;

// const int MAXN = 1e6;

int n, k;
vector<int> cnt;
vector<vector<int>> bohr;

inline void add_new_node() {
	cnt.push_back(0);
	bohr.push_back(vector<int>(26, -1));
}

void add(const string& s) {
	int v = 0;

	for (const char c : s) {
		cnt[v]++;
		if (bohr[v][c - 'a'] == -1) {
			bohr[v][c - 'a'] = bohr.size();
			add_new_node();
		}
		v = bohr[v][c - 'a'];
	}

	cnt[v]++;
}

int dfs (int v) {
	if (cnt[v] <= k)
		return 1;

	int res = 0;

	vector<pair<int, int>> a;
 
	for (int i = 0; i < 26; ++i) if (bohr[v][i] != -1) {
		int r = dfs(bohr[v][i]);
		res += r;
		a.push_back({cnt[bohr[v][i]], r});
	}

	sort(a.rbegin(), a.rend());

	int sum = 0;

	while (!a.empty() && a.back().first + sum <= k) {
		res -= a.back().second;
		sum += a.back().first;
		a.pop_back();
	}

	if (sum)
		res++;

	return res;
}

int main() {
	cin >> n >> k;

	add_new_node();

	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		add(s);
	}

	cout << dfs(0);

    return 0;
}