#include <bits/stdc++.h>

using namespace std;

int n, m;
vector<vector<pair<int, int>>> g;
vector<pair<int, pair<int, int>>> edges;
vector<int> d_begin, d_end;
vector<int> mn_begin, mn_end;

deque<int> q;

int main() {

    cin >> n >> m;

    d_begin.assign(n, INT_MAX);
    d_end.assign(n, INT_MAX);
    mn_begin.assign(n, INT_MAX);
    mn_end.assign(n, INT_MAX);
    g.resize(n);

    while (m--) {
        int u, v, c;
        cin >> u >> v >> c; v--, u--;
        g[u].push_back({v, c});
        g[v].push_back({u, c});
    }

    queue<int> q;
    q.push(0);
    d_begin[0] = 0;

    while(!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto [to, cost] : g[v]) {
            if (d_begin[to] == INT_MAX) {
                q.push(to);
                d_begin[to] = d_begin[v] + 1;
            }

            if (d_begin[to] == d_begin[v] + 1) {
                mn_begin[to] = min(mn_begin[to], min(mn_begin[v], cost));
            }
        }
    }

    q.push(n - 1);
    d_end[n - 1] = 0;

    while(!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto [to, cost] : g[v]) {
            if (d_end[to] == INT_MAX) {
                q.push(to);
                d_end[to] = d_end[v] + 1;
            }

            if (d_end[to] == d_end[v] + 1) {
                mn_end[to] = min(mn_end[to], min(mn_end[v], cost));
            }
        }
    }

    int res = 0, res_u = -1, res_v = -1;

    for (int v = 0; v < n; ++v) {
        for (auto [to, c] : g[v]) {
            if (d_begin[v] + d_end[to] + 1 != d_end[0])
                continue;

            if (res <= c - min({c, mn_begin[v], mn_end[to]})) {
                res = c - min({c, mn_begin[v], mn_end[to]});
                res_u = v;
                res_v = to;
            }
        }
    }

    cout << d_end[0] << '\n';

    vector<int> path;

    int v = res_u;
    bool need = true;

    while (v != 0) {
        path.push_back(v);
        for (auto [to, c] : g[v]) {
            if (d_begin[v] == d_begin[to] + 1 && (!need || c == mn_begin[v] || mn_begin[to] == mn_begin[v])) {
                v = to;
                if (c == mn_begin[v])
                    need = false;
                break;
            }
        }
    }
    path.push_back(0);

    reverse(path.begin(), path.end());

    v = res_v;
    need = true;

    while (v != n - 1) {
        path.push_back(v);
        for (auto [to, c] : g[v]) {
            if (d_end[v] == d_end[to] + 1 && (!need || c == mn_end[v] || mn_end[to] == mn_end[v])) {
                v = to;
                if (c == mn_end[v])
                    need = false;
                break;
            }
        }
    }
    path.push_back(n - 1);

    for (int x : path) {
        cout << x + 1 << ' ';
    }

    return 0;
}