
#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<set>
#include<stack>
#include<deque>
#include<queue>
#include<iomanip>

#define x first
#define y second
#define pb push_back
#define mp make_pair
#define sz(v) (int)v.size()
#define up_b upper_bound
#define low_b lower_bound
#define all(v) v.begin(),v.end()

using namespace std;

typedef long long ll;
typedef long double ld;

const int N=2e5+1;
const ll mod=1e9+7;
const int inf=2e9;
const ll INF=1e18;
const int dx[4]={0,0,1,-1};
const int dy[4]={1,-1,0,0};

vector<pair<int,int>>g[N];
int d[2][N];
int mn[2][N][2];
int mx[2][N][2];
int pmx[2][N];
int pmn[2][N];

void maximize(int s,int id){
	mx[id][s][0]=inf;
	mx[id][s][1]=-inf;
	set<pair<int,int>>q;
	q.insert(mp(mx[id][s][1],s));
	while(!q.empty()){
		pair<int,int>p=*q.begin();
		q.erase(p);
		int v=p.y;
		for(int i=0;i<sz(g[v]);i++){
			int to=g[v][i].x;
			int c=max(g[v][i].y,p.x);
			if(d[id][to]==d[id][v]+1){
				if(mx[id][to][1]<c){
					q.erase(mp(mx[id][to][1],to));
					mx[id][to][1]=c;
					mx[id][to][0]=min(mx[id][v][0],g[v][i].y);
					pmx[id][to]=v;
					q.insert(mp(mx[id][to][1],to));
				}
			}
		}
	}
}

void minimize(int s,int id){
	mn[id][s][0]=inf;
	mn[id][s][1]=-inf;
	set<pair<int,int>>q;
	q.insert(mp(-mn[id][s][0],s));
	while(!q.empty()){
		pair<int,int>p=*q.begin();
		q.erase(p);
		int v=p.y;
		for(int i=0;i<sz(g[v]);i++){
			int to=g[v][i].x;
			int c=min(-p.x,g[v][i].y);
			if(d[id][to]==d[id][v]+1){
				if(mn[id][to][0]>c){
					q.erase(mp(-mn[id][to][0],to));
					mn[id][to][0]=c;
					mn[id][to][1]=max(mn[id][v][1],g[v][i].y);
					pmn[id][to]=v;
					q.insert(mp(-mn[id][to][0],to));
				}
			}
		}
	}
}

void solve(){
	int n,m;
	cin>>n>>m;
	for(int i=1;i<=m;i++){
		int u,v,c;
		cin>>u>>v>>c;
		g[u].pb(mp(v,c));
		g[v].pb(mp(u,c));
	}
	for(int i=1;i<=n;i++){
		d[0][i]=inf;
		d[1][i]=inf;
	}
	queue<int>q;
	d[0][1]=0;
	q.push(1);
	while(!q.empty()){
		int v=q.front();
		q.pop();
		for(int i=0;i<sz(g[v]);i++){
			int to=g[v][i].x;
			if(d[0][to]>d[0][v]+1){
				d[0][to]=d[0][v]+1;
				q.push(to);
			}
		}
	}
	d[1][n]=0;
	q.push(n);
	while(!q.empty()){
		int v=q.front();
		q.pop();
		for(int i=0;i<sz(g[v]);i++){
			int to=g[v][i].x;
			if(d[1][to]>d[1][v]+1){
				d[1][to]=d[1][v]+1;
				q.push(to);
			}
		}
	}
	int dist=d[0][n];
//	assert(d[0][n]==d[1][1]);
	for(int i=1;i<=n;i++){
		mx[0][i][0]=mx[1][i][0]=mn[0][i][0]=mn[1][i][0]=inf;
		mx[0][i][1]=mx[1][i][1]=mn[0][i][1]=mn[1][i][1]=-inf;
	}
	maximize(1,0);
	maximize(n,1);
	/*
	for(int i=1;i<=n;i++){
		cout<<mx[0][i][0]<<" "<<mx[0][i][1]<<endl;
		cout<<mx[1][i][0]<<" "<<mx[1][i][1]<<endl;
	}
	*/
	minimize(1,0);
	minimize(n,1);
	int ans=-inf;
	vector<int>path;
	for(int i=1;i<=n;i++){
	//	cout<<mn[1][i][0]<<" "<<mn[1][i][1]<<endl;
		if(d[0][i]+d[1][i]==dist){
			int a=min(mn[0][i][0],mx[1][i][0]);
			int b=min(mn[0][i][1],mx[1][i][1]);
			if(b-a>ans){
				ans=b-a;
				vector<int>p1;
				vector<int>p2;
				int x=i;
				while(x!=1){
					p1.pb(x);
					x=pmn[0][x];
				}
				p1.pb(x);
				x=i;
				while(x!=n){
					p2.pb(x);
					x=pmx[1][x];
				}
				p2.pb(n);
				reverse(all(p1));
				p1.pop_back();
				path.clear();
				for(int ver:p1)path.pb(ver);
				for(int ver:p2)path.pb(ver);
			}
			a=min(mx[0][i][0],mn[1][i][0]);
			b=max(mx[0][i][1],mn[1][i][1]);
			if(b-a>ans){
				ans=b-a;
        vector<int>p1;
				vector<int>p2;
				int x=i;
				while(x!=1){
					p1.pb(x);
					x=pmx[0][x];
				}
				p1.pb(x);
				x=i;
				while(x!=n){
					p2.pb(x);
					x=pmn[1][x];
				}
				p2.pb(n);
				reverse(all(p1));
				p1.pop_back();
				path.clear();
				for(int ver:p1)path.pb(ver);
				for(int ver:p2)path.pb(ver);
			}
			a=min(mn[0][i][0],mn[1][i][0]);
			b=max(mn[0][i][1],mn[1][i][1]);
			if(b-a>ans){
				ans=b-a;
        vector<int>p1;
				vector<int>p2;
				int x=i;
				while(x!=1){
					p1.pb(x);
					x=pmn[0][x];
				}
				p1.pb(x);
				x=i;
				while(x!=n){
					p2.pb(x);
					x=pmn[1][x];
				}
				p2.pb(n);
				reverse(all(p1));
				p1.pop_back();
				path.clear();
				for(int ver:p1)path.pb(ver);
				for(int ver:p2)path.pb(ver);
			}
			a=min(mx[0][i][0],mx[1][i][0]);
			b=max(mx[0][i][1],mx[1][i][1]);
			if(b-a>ans){
				ans=b-a;
        vector<int>p1;
				vector<int>p2;
				int x=i;
				while(x!=1){
					p1.pb(x);
					x=pmx[0][x];
				}
				p1.pb(x);
				x=i;
				while(x!=n){
					p2.pb(x);
					x=pmx[1][x];
				}
				p2.pb(n);
				reverse(all(p1));
				p1.pop_back();
				path.clear();
				for(int ver:p1)path.pb(ver);
				for(int ver:p2)path.pb(ver);
			}
		}
	}
	cout<<dist<<endl;
	for(int ver:path)cout<<ver<<" "; 
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0),cout.tie(0);
	int T=1;
//	cin>>T;
	while(T--){
		solve();
		cout<<endl;
	}
}

