#include <iostream>
#include <map>
#include <unordered_map>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

const int N = (int) 1e6 + 7;

int best = INT_MAX, ans_m = 0, ans_c = 0;
int n;
int m, c;

void relax(int cur, int pos_c, int i) {
  int now = abs(cur + pos_c * c - n);
  if (now < best) {
    ans_m = i;
    ans_c = pos_c;
    best = now;
  }
}

int gcd(int a, int b) {
    if (a == 0)
      return b;
    return gcd(b % a, a);
}

int coprime(int x, int y) {
  return gcd(x, y) == 1;
}

unordered_map<int, vector<int>> indices;

int solve(int n) {
  vector<int> a;
  for (int i = 1; i <= n - 1; i++) {
    if (coprime(i, n)) a.push_back(i);
  }
  int m = a.size();
  int idx = m / 2;
  if (m % 2 == 0) idx--;
  cout << a[idx] << " ";
  /* cout << n << " " << a[idx] << endl; */
  indices[a[idx]].push_back(n);
  return a[idx];
}

long long fast(long long n) {
  if (n <= 4ll) return 1;
  long long rem = n % 4;
  long long x = n / 2;
  if (rem == 3) return x;
  if (rem == 0) return x - 1;
  if (rem == 1) return x;
  if (rem == 2) return x - 2;
  return -1;
}

int main() {
  int t;
  cin >> t;
  while (t--) {
    long long n;
    cin >> n;
    cout << fast(n) << '\n';
  }
  /* int n; */
  /* cin >> n; */
  /* for (int i = 2; i <= n; i++) { */
  /*   solve(i); */
  /*   cout << fast(i) << endl; */ 
  /*   assert(fast(i) == solve(i)); */
  /* } */
  /* for (int i = 1; i <= 100; i++) { */
  /*   cout << i << ":    "; */
  /*   for (auto x : indices[i]) cout << x << " "; */
  /*   cout << endl; */
  /* } */

  // 17 * 2 + 1, 17 * 2 + 2, 17 * 2 + 4
  // p * 2 + (1, 2, 4) = n
  return 0;
}
