#include <bits/stdc++.h>

using namespace std;

struct my_queue
{
    pair<int, int> MX, MN;
    int v, mn, mx;
};

inline void get_path(int v, int f, bool& done, vector<int>& path, vector<int>& final_path, vector<vector<pair<int, int>>>& g, vector<int>& dp) {
    if (dp[v] > dp[f] || done)
        return;
    path.push_back(v);

    if (v == f) {
        final_path = path;
        done = true;
        return;
    }

    for (auto to: g[v]) {
        if (dp[v] + 1 == dp[to.first]) {
            get_path(to.first, f, done, path, final_path, g, dp);
        }
    }
    path.pop_back();
}

inline void solve(){
    int n, m;
    cin >> n >> m;

    vector<vector<pair<int, int>>> g(n + 1);
    vector<int> u(m + 1), v(m + 1), c(m + 1);
    for (int i = 0; i < m; ++i) {
        cin >> u[i] >> v[i] >> c[i];
        g[u[i]].push_back({v[i], c[i]});
        g[v[i]].push_back({u[i], c[i]});
    }

    queue<my_queue> q;
    vector<int> dp(n + 1, INT_MAX), p(n + 1), edges;
    pair<int, int> final_MX, final_MN;
    int dif = -1;
    my_queue temp;
    temp.v = 1;
    temp.mn = INT_MAX;
    temp.mx = 0;
    q.push(temp);
    dp[1] = 0;
    while (!q.empty()) {
        int v = q.front().v, mn = q.front().mn, mx = q.front().mx;
        auto MN = q.front().MN;
        auto MX = q.front().MX;
        q.pop();

        if (v == n && dif < mx - mn) {
            dif = mx - mn;
            final_MX = MX;
            final_MN = MN;
        }

        for (auto to: g[v]) {
            if (dp[to.first] >= dp[v] + 1) {
                dp[to.first] = dp[v] + 1;
                pair<int, int> cur_MN = MN, cur_MX = MX;
                if (mn > to.second) {
                    cur_MN = {v, to.first};
                }
                if (mx < to.second) {
                    cur_MX = {v, to.first};
                }
                my_queue temp;
                temp.v = to.first;
                temp.MN = cur_MN;
                temp.MX = cur_MX;
                temp.mn = min(mn, to.second);
                temp.mx = max(mx, to.second);
                q.push(temp);
            }
        }
    }

    if (dp[final_MN.first] > dp[final_MX.first])
        swap(final_MN, final_MX);

    vector<int> res;
    if (final_MN == final_MX) {
        vector<int> temp, path1, path2;
        bool done = false;
        get_path(1, final_MN.first, done, temp, path1, g, dp);
        done = 0;
        temp.clear();
        get_path(final_MN.second, n, done, temp, path2, g, dp);
        for(auto i: path1) {
            res.push_back(i);
        }
        for(auto i: path2) {
            res.push_back(i);
        }
    } else {
        vector<int> temp, path1, path2, path3;
        bool done = false;
        get_path(1, final_MN.first, done, temp, path1, g, dp);
        done = 0;
        temp.clear();
        get_path(final_MN.second, final_MX.first, done, temp, path2, g, dp);
        done = 0;
        temp.clear();
        get_path(final_MX.second, n, done, temp, path3, g, dp);
        for(auto i: path1) {
            res.push_back(i);
        }
        for(auto i: path2) {
            res.push_back(i);
        }
        for(auto i: path3) {
            res.push_back(i);
        }
    }
    cout << res.size() - 1 << "\n";
    for (auto i: res){
        cout << i << " ";
    }
}

int main(){
    #ifdef nurik
    freopen("in", "r", stdin);
    #endif

    ios_base::sync_with_stdio(0);

    solve();

    return 0;
}
