#include <bits/stdc++.h>
 
#define pb push_back
#define sz(x) (int)x.size()
#define whole(x) x.begin(), x.end()
#define rwhole(x) x.rbegin(), x.rend()
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
const int N = (int)3e5 + 2;
const int INF = (int)1e9 + 7;
const ll linf = (ll)1e14;
 
int n, m;
 
int a[305][305], used[305][305];
set<pair<int, pair<int, int>>> g[305][305];
 
bool can(int i, int j) {
    return ((1 <= i && i <= n) && (1 <= j && j <= m));
}
 
bool is_q(int i, int j) {
    int sum = 0;
    for (int d = 0; d <= 2; ++d) {
        if (!can(i, j + d)) return false;
        sum += a[i][j + d];
    }
    for (int d = 1; d <= 2; ++d) {
        if (!can(i + d, j)) return false;
        sum += a[i + d][j];
    }
    if (!can(i + 2, j + 1)) return false;
    sum += a[i + 2][j + 1];
    for (int d = 1; d <= 4; ++d) {
        if (!can(i + d, j + 2)) return false;
        sum += a[i + d][j + 2];
    }
    return (sum == 10);
}
 
void mark_q(int i, int j) {
    for (int d = 0; d <= 2; ++d) {
        used[i][j + d] = 1;
        g[i][j + d].clear();
    }
    for (int d = 1; d <= 2; ++d) {
        used[i + d][j] = 1;
        g[i + d][j].clear();
    }
    used[i + 2][j + 1] = 1;
    g[i + 2][j + 1].clear();
    for (int d = 1; d <= 4; ++d) {
        used[i + d][j + 2] = 1;
        g[i + d][j + 2].clear();
    }
}
 
void fill_q(int i, int j) {
    for (int d = 0; d <= 2; ++d) {
        g[i][j + d].insert({0, {i, j}});
    }
    for (int d = 1; d <= 2; ++d) {
        g[i + d][j].insert({0, {i, j}});
    }
    g[i + 2][j + 1].insert({0, {i, j}});
    for (int d = 1; d <= 4; ++d) {
        g[i + d][j + 2].insert({0, {i, j}});        
    }
}

bool check_q(int i, int j) {
    for (int d = 0; d <= 2; ++d) {
        if (g[i][j + d].empty()) return false;
    }
    for (int d = 1; d <= 2; ++d) {
        if (g[i + d][j].empty()) return false;
    }
    if (g[i + 2][j + 1].empty()) return false;
    for (int d = 1; d <= 4; ++d) {
        if (g[i + d][j + 2].empty()) return false;
    }
    return true;
}

bool is_f(int i, int j) {
    int sum = 0;
    for (int d = 0; d <= 2; ++d) {
        if (!can(i, j + d)) return false;
        sum += a[i][j + d];
    }
    for (int d = 1; d <= 4; ++d) {
        if (!can(i + d, j)) return false;
        sum += a[i + d][j];
    }
    if (!can(i + 2, j + 1)) return false;
    sum += a[i + 2][j + 1];
    return (sum == 8);
}
 
void mark_f(int i, int j) {
    for (int d = 0; d <= 2; ++d) {
        used[i][j + d] = 1;
        g[i][j + d].clear();
    }
    for (int d = 1; d <= 4; ++d) {
        used[i + d][j] = 1;
        g[i + d][j].clear();
    }
    used[i + 2][j + 1] = 1;
    g[i + 2][j + 1].clear();
}
 
void fill_f(int i, int j) {
    for (int d = 0; d <= 2; ++d) {
        g[i][j + d].insert({1, {i, j}});
    }
    for (int d = 1; d <= 4; ++d) {
        g[i + d][j].insert({1, {i, j}});
    }
    g[i + 2][j + 1].insert({1, {i, j}});
}

bool check_f(int i, int j) {
    for (int d = 0; d <= 2; ++d) {
        if (g[i][j + d].empty()) return false;
    }
    for (int d = 1; d <= 4; ++d) {
        if (g[i + d][j].empty()) return false;
    }
    if (g[i + 2][j + 1].empty()) return false;
    return true;
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    return sz(g[a.first][a.second]) < sz(g[b.first][b.second]);
}

bool ok() {
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (!g[i][j].empty()) return false;
        }
    }
    return true;
}

bool check(pair<int, pair<int, int>> root) {
    if (root.first == 0) return check_q(root.second.first, root.second.second);
    return check_f(root.second.first, root.second.second);
}

int get_mn() {
    int mn = INF;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (g[i][j].empty()) continue;
            mn = min(mn, sz(g[i][j]));
        }
    }
    return mn;
}

void solve() {  
    cin >> n >> m;
 
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            char ch; cin >> ch;
            if (ch == '#') a[i][j] = 1;
            else a[i][j] = 0;
        }
    }
 
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (is_f(i, j)) {
                fill_f(i, j);
            }
            if (is_q(i, j)) {
                fill_q(i, j);
            }
        }
    }

    int cnt_q = 0, cnt_f = 0;
    while (!ok()) {
        int mn = get_mn();
        bool found = false;
        for (int i = 1; i <= n; ++i) {
            for (int j = 1; j <= m; ++j) {
                if (sz(g[i][j]) == mn) {
                    pair<int, pair<int, int>> cur;
                    for (auto p : g[i][j]) {
                        if (check(p)) {
                            cur = p;
                        }
                    }
                    if (cur.first == 0) mark_q(cur.second.first, cur.second.second), ++cnt_q;
                    else mark_f(cur.second.first, cur.second.second), ++cnt_f;
                    found = true;
                    break;
                }
            }
            if (found) break;
        }
    }

    cout << cnt_q << " " << cnt_f << "\n";
}
 
int main() {
    int tt = 1;
    while (tt--) solve();
    return 0;
}
 
/*
   for (int ii = 1; ii <= n; ++ii) {
                    for (int jj = 1; jj <= m; ++jj) {
                        cout << used[ii][jj] << " ";
                    }
                    cout << "\n";
                }
                cout << "\n";
*/