#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template <typename T>
int sz(T &x) {
  return (int)(x.size());
}

int power(int x, int y, int mod) {
  if (y == 0) {
    return 1;
  }
  int z = power(x, y >> 1, mod);
  z = z * 1ll * z % mod;
  if (y & 1) {
    z = z * 1ll * x % mod;
  }
  return z;
}

const int mod = 998244353;
const int inf = 1000000007;




auto intersections2 = [](pii a, pii b) {
  return make_pair(max(a.first, b.first), min(a.second, b.second));
};

auto bintersections2 = [](pii a, pii b) {
  if (a.first == inf || b.first == inf) {
    return false;
  }
  return max(a.first, b.first) <= min(a.second, b.second);
};

struct node {
  pii val;
  int add;
  node *l, *r;
  node() {
    add = 0;
    val = make_pair(0, 0);
    l = nullptr;
    r = nullptr;
  }
};

void push(node *v) {
  if (v -> add) {
    v -> l -> add += v -> add;
    v -> l -> val.first += v -> add;
    v -> r -> add += v -> add;
    v -> r -> val.first += v -> add;
    v -> add = 0;
  }
}

vector<node> t;

void add_range(node *v, int tl, int tr, int l, int r, int x) {
  if (l > r) {
    return;
  }
  if (l == tl && r == tr) {
    v -> add += x;
    v -> val.first += x;
    return;
  }
  int tm = (tl + tr) >> 1;
  if (v -> l == nullptr) {
    v -> l = new node();
    v -> l -> val = make_pair(0, tm);
  }
  if (v -> r == nullptr) {
    v -> r = new node();
    v -> r -> val = make_pair(0, tr);
  }
  push(v);
  add_range(v -> l, tl, tm, l, min(r, tm), x);
  add_range(v -> r, tm + 1, tr, max(tm + 1, l), r, x);
  v -> val = max(v -> l -> val, v -> r -> val);
}


node *root = new node();


void solve() {
  int n, m;
  cin >> n >> m;

  vector<int> a(n);
  map<int, int> mn, mx;
  set<int> check;

  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    int block = a[i] / m;
    check.insert(block);
    check.insert(block + 1);
    if (!mn.count(block)) {
      mn[block] = a[i] % m;
      mx[block] = a[i] % m;
    } else {
      mn[block] = min(mn[block], a[i] % m);
      mx[block] = max(mx[block], a[i] % m);
    }
  }

  vector<pair<int, pair<pii, pii> > > blocks;
  for (int i : check) {
    pii A = make_pair(inf, -inf);
    if (mn.count(i)) {
      A = make_pair(0, m - mn[i] - 1);
    }

    pii B = make_pair(inf, -inf);
    if (mx.count(i - 1)) {
      B = make_pair(m - mx[i - 1], m - 1);
    }
    if (bintersections2(A, B)) {
      A = make_pair(min(A.first, B.first), max(A.second, B.second));
      B = make_pair(inf, -inf);
    }

    blocks.push_back(make_pair(i, make_pair(A, B)));
  }



  auto solve = [&](vector<pair<pii, pii> > vals) {

    int k = sz(vals);
    pair<int, int> ans = make_pair(-1, -1);

    int r = -1;
    for (int i = 0; i < k; ++i) {
      while (r + 1 < sz(vals)) {
        ++r;
        if (vals[r].first.first <= vals[r].first.second) {
          add_range(root, 0, inf, vals[r].first.first, vals[r].first.second, 1);
        }
        if (vals[r].second.first <= vals[r].second.second) {
          add_range(root, 0, inf, vals[r].second.first, vals[r].second.second, 1);
        }
        if (root -> val.first != r - i + 1) {
          if (vals[r].first.first <= vals[r].first.second) {
            add_range(root, 0, inf, vals[r].first.first, vals[r].first.second, -1);
          }
          if (vals[r].second.first <= vals[r].second.second) {
            add_range(root, 0, inf, vals[r].second.first, vals[r].second.second, -1);
          }
          --r;
          break;
        }
      }
      pii f = root -> val;
      if (f.first > ans.first) {
        ans = f;
      }
      if (vals[i].first.first <= vals[i].first.second) {
        add_range(root, 0, inf, vals[i].first.first, vals[i].first.second, -1);
      }
      if (vals[i].second.first <= vals[i].second.second) {
        add_range(root, 0, inf, vals[i].second.first, vals[i].second.second, -1);
      }



    }
    return ans;

  };



  pii ans = make_pair(-1, -1);

  for (int i = 0; i < sz(blocks); ) {
    int j = i;
    while (j + 1 < sz(blocks) && blocks[j].first == blocks[j + 1].first - 1) {
      ++j;
    }
    vector<pair<pii, pii> > ff;
    for (int k = i; k <= j; ++k) {
      ff.push_back(blocks[k].second);
    }
    pii z = solve(ff);
    if (ans.first < z.first) {
      ans = z;
    }
    i = j + 1;
  }

  cout << ans.first << " " << ans.second << "\n";
}

int main() {
  #ifndef LOCAL58
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
  #endif

  int t = 1;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
