#include <iostream>
#include <algorithm>
#include <iomanip>
using namespace std;
int janeVels[100100];
int n, L, julia;
double calc(double t) {
    double ans = 0;
    for(int i = 1; i <= n; i++) {
        double ti = L * 1.0 / janeVels[i];
        if (ti + 1e-7 < t) {
            ans += ti;
        } else {
            double R = janeVels[i] * t;
            ans += (L - R) / (julia + janeVels[i]) * 2 + t;
        }
    }
    return ans / n;
}


int main() {
    cin >> n >> L >> julia;
    for(int i = 1; i <= n; i++) {
        cin >> janeVels[i];
    }
    sort(janeVels+1, janeVels + 1 + n);
    reverse(janeVels + 1, janeVels + 1 + n);
    double ans = 0;
    double t = 0;
    double lt = 0, rt = L * 1.0 / janeVels[n];
    for(int i = 1; i <= 100; i++) {
        double m1 = lt + (rt - lt) / 3;
        double m2 = rt - (rt - lt) / 3;
        if (calc(m1) > calc(m2)) {
            lt = m1;
        } else {
            rt = m2;
        }
    }
    cout << fixed << setprecision(12) << ans << endl;
    return 0;
}