#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>
#include <set>
#include <map>
#include <iomanip>

#define ll long long

using namespace std;

void _() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

int cur = 0;

struct TrieNode{
    TrieNode *childs[26];
    TrieNode *par;
    int t;
    int ind;
    int h;
    int num;
    int child_sum;
    TrieNode(TrieNode* par, int num_) : num(num_) {
        child_sum = 0;
        this->ind = cur++;
        if(par == nullptr) {
            this->h = 0;
        } else {
            this->h = par->h + 1;
        }
        this->par = par;
        this->t = 0;
        for (int i = 0; i < 26; i++) {
            this->childs[i] = nullptr;
        }
    }
};

bool cmp(const TrieNode* a, const TrieNode* b){
    if (a->t == b->t) {
        if (a->h == b->h) {
            if (a->child_sum == b->child_sum) {
                return a->ind > b->ind;
            }
            return a->child_sum < b->child_sum;
        }
        return a->h < b->h;
    }
    return a->t < b->t;
}

multiset <TrieNode*, decltype(&cmp) > s(&cmp);
TrieNode *root = new TrieNode(nullptr, 0);
void insertTrie(const string &key)
{
    TrieNode* cur = root;
    for (int i = 0; i < key.length(); i++)
    {
        cur->t ++;
        if (cur->childs[key[i] - 'a'] == nullptr) {
            cur->childs[key[i] - 'a'] = new TrieNode(cur, key[i] - 'a');
        }
        cur = cur->childs[key[i] - 'a'];
    }
    cur->t ++; 
}


void dfsInsert(TrieNode *node)
{
    s.insert(node);
    for(int i = 0; i < 26; ++i){
        if(node->childs[i] != nullptr){
            dfsInsert(node->childs[i]);
        }
    }
}

void deleteTrie(TrieNode *root){
    if(root == nullptr)
        return;
    if (s.find(root) == s.end()) return;
    s.erase(s.find(root));
    for(int i = 0; i < 26; ++i){
        if(root->childs[i] != nullptr){
            deleteTrie(root->childs[i]);
            root->childs[i] = nullptr;
        }
    }
    // delete root;
}

void deletePars(TrieNode *cur) {
    auto x = cur->par;

    while(x != nullptr) {
        // cout << "    " << char(x->num + 'a') << endl;
        // cout << "removed " << char((*s.find(x))->num + 'a') << endl;
        s.erase(s.find(x));
        x->t -= cur->t;
        if(x->t > 0) {
            s.insert(x);
        }
        if (x->par != nullptr && x->t <= 0) {
            x->par->childs[x->num] = nullptr;
        }
        x = x->par;
    }
}

int numberOfChilds(TrieNode *root){
    for(int i = 0; i < 26; ++i){
        if(root->childs[i])
            root->child_sum += numberOfChilds(root->childs[i]);
    }
    return root->child_sum;
}
int main() {
    _();
    int n, k;
    cin >> n >> k;

    for(int i = 1; i <= n; ++i) {
        string s;
        cin >> s;
        insertTrie(s);
    }
    dfsInsert(root);
    numberOfChilds(root);
    int sum = 0;
    int ans = 0;
    auto canon = new TrieNode(nullptr, 0);
    canon->t = k;
    canon->h = 1e9;
    canon->child_sum = 1e9;
    while(sum < n) {
        auto curTrie = *(--s.upper_bound(canon));
        sum += curTrie->t;
        // cout << char( 'a' + curTrie->num) << endl << s.size() << endl;
        // for (auto & el : s) {
        //     cout << el.first << ' ' << el.second->t << endl;
        // }
        // cout << endl << endl;
        deletePars(curTrie);
        // cout << s.size() << endl;
        // for (auto & el : s) {
        //     cout << el.first << ' ' << el.second->t << endl;
        // }
        // cout << endl << endl;
        if (curTrie->par != nullptr && curTrie->t <= 0) {
            curTrie->par->childs[curTrie->num] = nullptr;
        }
        deleteTrie(curTrie);
        // cout << s.size() << endl;
        ++ans;
        // for (auto & el : s) {
        //     cout << el.first << ' ' << el.second->t << endl;
        // }
        // cout << endl << endl;
    }

    cout << ans;



}