#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <cassert>
#include <queue>
#include <bitset>
#include <numeric>
#include <cstdlib>
#include <iostream>     // std::cout
#include <algorithm>    // std::random_shuffle
#include <vector>       // std::vector
#include <ctime>        // std::time
#include <cstdlib>
#include <iomanip>
#include <sstream>
#include <cstring>

using namespace std;

const int N = (int) 3e5 + 123;
const int MOD = (int) 1e9 + 7;

int n, k;

struct Node {
    int v;
    int pr, next[26];

    int cnt_end, total_cnt;

    bool is_deleted;
    Node() {}
    Node(int x, int pr_v) {
        v = x;
        pr = pr_v;
        memset(next, -1, sizeof next);

        cnt_end = total_cnt = 0;

        is_deleted = false;
    }
};

vector < Node > nodes;

int root;

void add(string &s) {
    int v = root;
    for (auto i : s) {
        if (nodes[v].next[i - 'a'] == -1) {
            int new_v = size(nodes);
            nodes.push_back(Node(new_v, v));
            nodes[v].next[i - 'a'] = new_v;
        }
        v = nodes[v].next[i - 'a'];
    }
    nodes[v].cnt_end += 1;
}

set < pair < int, int > > all;

void dfs(int v) {
    nodes[v].total_cnt += nodes[v].cnt_end;

    for (int i = 0; i < 26; i++) {
        int to = nodes[v].next[i];

        if (to == -1) {
            continue;
        }
        dfs(to);
        nodes[v].total_cnt += nodes[to].total_cnt;
    }

    all.insert(make_pair(nodes[v].total_cnt, v));
}

void delete_all(int v) {
    if (nodes[v].is_deleted) {
        return;
    }
    all.erase(make_pair(nodes[v].total_cnt, v));
    nodes[v].is_deleted = true;
    for (int i = 0; i < 26; i++) {
        if (nodes[v].next[i] != -1) {
            delete_all(nodes[v].next[i]);
        }
    }
}

void delete_prs(int v, int val) {
    while(nodes[v].pr != -1) {
        v = nodes[v].pr;
        all.erase(make_pair(nodes[v].total_cnt, v));
        nodes[v].total_cnt -= val;
        if (nodes[v].total_cnt > 0) {
            all.insert(make_pair(nodes[v].total_cnt, v));
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    nodes.push_back(Node(0, -1));
    root = 0;

    cin >> n >> k;
    string s;
    for (int i = 0; i < n; i++) {
        cin >> s;
        add(s);
    }

    dfs(0);

    int ans = 0;
    while (!all.empty()) {
        auto it = all.upper_bound(make_pair(k, MOD));
        it--;
        int v = it -> second;

        assert (nodes[v].total_cnt <= k);
//        cout << "deleted " << v << endl;

        int val_delete = nodes[v].total_cnt;
        ans++;
        delete_all(v);
        delete_prs(v, val_delete);
    }

    cout << ans << endl;
    return 0;
}
