#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <cassert>
#include <queue>
#include <bitset>
#include <numeric>
#include <cstdlib>
#include <iostream>     // std::cout
#include <algorithm>    // std::random_shuffle
#include <vector>       // std::vector
#include <ctime>        // std::time
#include <cstdlib>
#include <iomanip>
#include <sstream>

#define mp make_pair

using namespace std;

const int N = (int) 1e6 + 123;
const int MOD = (int) 1e9 + 7;

struct Node {
    int parent;
    int cnt;
    int next[26];
    Node () {
        parent = 0;
        cnt = 0;
        for (int i = 0; i < 26; i++) {
            next[i] = 0;
        }
    }
};

Node t[N];
int root = 1;
int sz = 1;
int n, k;

void add(string s) {
    int v = root;
    t[v].cnt++;
    for (auto ch : s) {
        int edge = ch - 'a';
        if (!t[v].next[edge]) {
            t[v].next[edge] = ++sz;
            t[sz] = Node();
            t[sz].parent = v;
        }
        v = t[v].next[edge];
        t[v].cnt++;
    }
}

set<pair<int, int>> all;
bool removed[N];

void dfs(int v) {
    if (!v) return;
    all.insert(make_pair(t[v].cnt, v));
    for (int edge = 0; edge < 26; edge++) {
        dfs(t[v].next[edge]);
    }
}

void del(int v) {
    if (!v) return;
    if (removed[v]) return;
    removed[v] = true;
    all.erase(make_pair(t[v].cnt, v));
    for (int edge = 0; edge < 26; edge++) {
        del(t[v].next[edge]);
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);

    cin >> n >> k;

    while (n--) {
        string s;
        cin >> s;
        add(s);
    }

    dfs(root);

    int ans = 0;
    while (!all.empty()) {
        auto it = all.upper_bound(make_pair(k, MOD));
        it--;
        int c = it->first;
        int v = it->second;
        if (c) ++ans;
        del(v);
        for (int u = t[v].parent; u; u = t[u].parent) {
            all.erase(make_pair(t[u].cnt, u));
            t[u].cnt -= c;
            all.insert(make_pair(t[u].cnt, u));
        }
    }
    cout << ans;

    return 0;
}