#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <cassert>
#include <queue>
#include <bitset>
#include <numeric>
#include <cstdlib>
#include <iostream>     // std::cout
#include <algorithm>    // std::random_shuffle
#include <vector>       // std::vector
#include <ctime>        // std::time
#include <cstdlib>
#include <iomanip>
#include <sstream>

#define mp make_pair

using namespace std;

const int N = (int) 1e6 + 123;
const int MOD = (int) 1e9 + 7;

int n, m;

int dStart[N];
int parMinStart[N];
int parMaxStart[N];
int minStart[N];
int maxStart[N];

int dEnd[N];
int parMinEnd[N];
int parMaxEnd[N];
int minEnd[N];
int maxEnd[N];

vector<pair<int, int>> g[N];

int d[N];
int mn[N];
int mx[N];
int parmn[N];
int parmx[N];

void bfs(int st) {
    queue<int> q;
    q.push(st);
    for (int i = 1; i <= n; i++) {
        d[i] = MOD;
        mn[i] = MOD;
        mx[i] = -MOD;
        parmn[i] = parmx[i] = 0;
    }
    d[st] = 0;
    mn[st] = MOD;
    mx[st] = -MOD;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto edge : g[v]) {
            int to = edge.first;
            int color = edge.second;
            if (d[to] >= d[v] + 1) {
                if (d[to] > d[v] + 1)
                    q.push(to);
                d[to] = d[v] + 1;
                int tmp = min(mn[v], color);
                if (tmp < mn[to]) {
                    mn[to] = tmp;
                    parmn[to] = v;
                }
                tmp = max(mx[v], color);
                if (tmp > mx[to]) {
                    mx[to] = tmp;
                    parmx[to] = v;
                }
            }
        }
    }
    if (st == 1) {
        for (int i = 1; i <= n; i++) {
            dStart[i] = d[i];
            minStart[i] = mn[i];
            maxStart[i] = mx[i];
            parMinStart[i] = parmn[i];
            parMaxStart[i] = parmx[i];
        }
    } else if (st == n) {
        for (int i = 1; i <= n; i++) {
            dEnd[i] = d[i];
            minEnd[i] = mn[i];
            maxEnd[i] = mx[i];
            parMinEnd[i] = parmn[i];
            parMaxEnd[i] = parmx[i];
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);

    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        g[u].push_back(make_pair(v, c));
        g[v].push_back(make_pair(u, c));
    }

    bfs(1);
    bfs(n);

    assert(dStart[n] == dEnd[1]);

    int shortest = dStart[n];

    if (shortest == 1) {
        cout << 1 << "\n";
        cout << 1 << ' ' << n;
        return 0;
    }

    int ans = -MOD;
    int opt = -1;
    for (int inter = 2; inter < n; inter++) {
        if (dStart[inter] + dEnd[inter] == shortest) {

            int c1 = maxEnd[inter] - minStart[inter];
            int c2 = maxStart[inter] - minEnd[inter];

            if (max(c1, c2) > ans) {
                ans = max(c1, c2);
                opt = inter;
            }

        }
    }
    assert(opt != -1);

    cout << shortest << "\n";

    int c1 = maxEnd[opt] - minStart[opt];
    int c2 = maxStart[opt] - minEnd[opt];

    if (c1 == ans) {
        vector<int> p1;
        for (int i = opt; i != 0; i = parMinStart[i])
            p1.push_back(i);
        vector<int> p2;
        for (int i = opt; i != 0; i = parMaxEnd[i])
            p2.push_back(i);

        reverse(p1.begin(), p1.end());
        for (auto it : p1) cout << it << ' ';
        for (auto it : p2) {
            if (it == opt) continue;
            cout << it << ' ';
        }

        return 0;
    }

    if (c2 == ans) {
        vector<int> p1;
        for (int i = opt; i != 0; i = parMaxStart[i])
            p1.push_back(i);
        vector<int> p2;
        for (int i = opt; i != 0; i = parMinEnd[i])
            p2.push_back(i);

        reverse(p1.begin(), p1.end());
        for (auto it : p1) cout << it << ' ';
        for (auto it : p2) {
            if (it == opt) continue;
            cout << it << ' ';
        }
        return 0;
    }


    return 0;
}